"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var enzyme_1 = require("enzyme");
var __1 = require("../../");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
describe('Avatar component', function () {
    describe('firstName and lastName properties', function () {
        it('should render the Avatar with initials if src is not passed', function () {
            var component = (0, enzyme_1.mount)(react_1.default.createElement(__1.Provider, null,
                react_1.default.createElement(__1.Avatar, { firstName: "test", lastName: "user" })));
            expect(component.text()).toContain('TU');
        });
    });
    describe('null src, valid firstName and valid lastName properties', function () {
        it('should render the Avatar with initials if src is passed but it is null', function () {
            var component = (0, enzyme_1.mount)(react_1.default.createElement(__1.Provider, null,
                react_1.default.createElement(__1.Avatar, { firstName: "example", lastName: "user" })));
            expect(component.text()).toContain('EU');
        });
    });
    describe('component with all props to null', function () {
        it('should render fallback icon if no props has value', function () {
            var component = (0, enzyme_1.mount)(react_1.default.createElement(__1.Provider, null,
                react_1.default.createElement(__1.Avatar, null)));
            expect(component.children().find(react_fontawesome_1.FontAwesomeIcon)).toHaveLength(1);
        });
    });
});
