"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Wrapped = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var faRecycle_1 = require("@fortawesome/free-solid-svg-icons/faRecycle");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var __1 = require("../..");
exports.default = {
    title: 'Core/Breadcrumbs',
    component: _1.Breadcrumbs,
    parameters: {
        backgrounds: {
            default: 'dark',
        },
    },
};
var crumbs = [
    {
        text: 'route 1',
        href: '/?path=/story/core-breadcrumbs--default',
        onClick: function (event) {
            event.preventDefault();
            alert('click route 1');
        },
    },
    {
        text: 'route 2',
        href: '/?path=/story/core-breadcrumbs--default',
        onClick: function (event) {
            event.preventDefault();
            alert('click route 2');
        },
    },
    {
        text: 'route 3 with icon',
        href: '/?path=/story/core-breadcrumbs--default',
        icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faRecycle_1.faRecycle }),
        onClick: function (event) {
            event.preventDefault();
            alert('click route 3');
        },
    },
];
var Template = (0, utils_1.createTemplate)(_1.Breadcrumbs);
var WrappedBreadcrumb = function (_a) {
    var crumbs = _a.crumbs;
    return (react_1.default.createElement(__1.Flex, { maxWidth: "70px" },
        react_1.default.createElement(_1.Breadcrumbs, { crumbs: crumbs })));
};
exports.Default = (0, utils_1.createStory)(Template, {
    crumbs: crumbs,
});
exports.Wrapped = (0, utils_1.createStory)(WrappedBreadcrumb, {
    crumbs: crumbs,
});
