"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Card = void 0;
var map_1 = __importDefault(require("lodash/map"));
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var DismissableContainer_1 = require("../../internal/DismissableContainer");
var Divider_1 = require("../Divider");
var Flex_1 = require("../Flex");
var Heading_1 = require("../Heading");
var useBreakpoint_1 = require("../../hooks/useBreakpoint");
var Wrapper = (0, styled_components_1.default)(DismissableContainer_1.DismissableContainer)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t& {\n\t\tpadding: ", ";\n\t}\n"], ["\n\t& {\n\t\tpadding: ", ";\n\t}\n"])), function (props) { return (props.small ? '24px' : '32px 44px'); });
var BaseCard = function (_a) {
    var title = _a.title, cta = _a.cta, rows = _a.rows, children = _a.children, small = _a.small, props = __rest(_a, ["title", "cta", "rows", "children", "small"]);
    var hasHeader = title || cta;
    var isSmall = (0, useBreakpoint_1.useBreakpoint)(small);
    var Header = hasHeader && (React.createElement(React.Fragment, null,
        React.createElement(Flex_1.Flex, { justifyContent: "space-between", alignItems: "center" },
            React.createElement(Heading_1.Heading.h5, { fontSize: 4 }, title),
            cta),
        React.createElement(Divider_1.Divider, { my: 2 })));
    var Rows = rows &&
        (0, map_1.default)(rows, function (row, index) { return (React.createElement(Flex_1.Flex, { key: index, fontSize: 2, flexDirection: "column", flexWrap: "wrap" },
            index > 0 && React.createElement(Divider_1.Divider, null),
            row)); });
    var Body = children && (React.createElement(Flex_1.Flex, { fontSize: 2, flex: 1, flexDirection: "column", flexWrap: "wrap" }, children));
    return (React.createElement(Wrapper, __assign({ small: isSmall, flexDirection: "column", alignItems: "stretch" }, props),
        Header,
        Rows,
        Body));
};
exports.Card = (0, asRendition_1.default)(BaseCard);
var templateObject_1;
