"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChangelogButton = void 0;
var React = __importStar(require("react"));
var Button_1 = require("../Button");
var Flex_1 = require("../Flex");
var Txt_1 = require("../Txt");
var styled_components_1 = __importDefault(require("styled-components"));
var semver = __importStar(require("semver"));
var ChangelogModal_1 = require("./ChangelogModal");
var utils_1 = require("../../utils");
var LAST_VIEWED_CHANGELOG_VERSION_STORAGE_KEY = 'last-viewed-changelog-version';
var NotificationBubble = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t", "\n\tborder-radius: 50%;\n\tpadding: 5px;\n\tposition: absolute;\n"], ["\n\t", "\n\tborder-radius: 50%;\n\tpadding: 5px;\n\tposition: absolute;\n"])), function (props) { return "\n\t\tbackground-color: ".concat(props.theme.colors.primary.main, ";\n\t"); });
var ChangelogButton = function (_a) {
    var getChangelog = _a.getChangelog, latestChangelogVersion = _a.latestChangelogVersion, onClick = _a.onClick, style = _a.style, restProps = __rest(_a, ["getChangelog", "latestChangelogVersion", "onClick", "style"]);
    var _b = React.useState(false), showChangelogModal = _b[0], setShowChangelogModal = _b[1];
    var lastViewedChangelogVersion = React.useMemo(function () {
        return (0, utils_1.getFromLocalStorage)(LAST_VIEWED_CHANGELOG_VERSION_STORAGE_KEY);
    }, [showChangelogModal]);
    React.useEffect(function () {
        if (!lastViewedChangelogVersion) {
            (0, utils_1.setToLocalStorage)(LAST_VIEWED_CHANGELOG_VERSION_STORAGE_KEY, latestChangelogVersion);
        }
    }, []);
    React.useEffect(function () {
        if (showChangelogModal) {
            (0, utils_1.setToLocalStorage)(LAST_VIEWED_CHANGELOG_VERSION_STORAGE_KEY, latestChangelogVersion);
        }
    }, [showChangelogModal]);
    React.useEffect(function () {
        if (lastViewedChangelogVersion &&
            latestChangelogVersion &&
            Number(lastViewedChangelogVersion.split('.')[0]) <
                Number(latestChangelogVersion.split('.')[0])) {
            setShowChangelogModal(true);
        }
    }, [lastViewedChangelogVersion]);
    return (React.createElement(Flex_1.Flex, { justifyContent: "flex-end" },
        React.createElement(Button_1.Button, __assign({ color: "quartenary.main", onClick: function (e) {
                onClick === null || onClick === void 0 ? void 0 : onClick(e);
                setShowChangelogModal(true);
            }, style: __assign({ background: 'rgba(0, 0, 0, 0.1)', borderRadius: '2px', lineHeight: 1.1 }, style) }, restProps),
            React.createElement(Flex_1.Flex, { flexDirection: "column" },
                React.createElement(Txt_1.Txt, null, "Changelog"),
                latestChangelogVersion && React.createElement(Txt_1.Txt, null,
                    "v",
                    latestChangelogVersion))),
        lastViewedChangelogVersion &&
            latestChangelogVersion &&
            semver.lt(lastViewedChangelogVersion, latestChangelogVersion) && (React.createElement(NotificationBubble, null)),
        showChangelogModal && (React.createElement(ChangelogModal_1.ChangelogModal, { onDone: function () { return setShowChangelogModal(false); }, getChangelog: getChangelog }))));
};
exports.ChangelogButton = ChangelogButton;
var templateObject_1;
