import * as React from 'react';
import { RenditionSystemProps } from '../../common-types';
import { BoxProps } from '../Box';
interface InternalCopyProps extends Omit<BoxProps, 'onClick' | 'onCopy' | 'content'> {
    content: string | number;
    show?: 'hover' | 'always';
    onClick?: (content: string) => void;
    children?: React.ReactNode;
    onCopy?: React.MouseEventHandler<HTMLElement>;
}
export type CopyProps = InternalCopyProps & RenditionSystemProps;
export declare const Copy: ({ content, show, children, onClick, onCopy, ...otherProps }: InternalCopyProps) => React.JSX.Element;
export {};
