"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataGrid = void 0;
var react_1 = __importDefault(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var utils_1 = require("../../utils");
var useBreakpoint_1 = require("../../hooks/useBreakpoint");
var Base = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: grid;\n\tjustify-content: left;\n\tgrid-gap: ", ";\n\tgrid-template-columns: ", ";\n"], ["\n\tdisplay: grid;\n\tjustify-content: left;\n\tgrid-gap: ", ";\n\tgrid-template-columns: ", ";\n"])), function (props) { return (0, utils_1.px)(props.theme.space[4]); }, function (props) {
    return "repeat(auto-fill, minmax(".concat(props.itemMinWidth, ", 1fr))");
});
var BaseItem = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tmin-width: ", ";\n\tmax-width: ", ";\n"], ["\n\tmin-width: ", ";\n\tmax-width: ", ";\n"])), function (props) { return props.itemMinWidth; }, function (props) { return props.itemMaxWidth; });
var BaseDataGrid = function (_a) {
    var itemMinWidth = _a.itemMinWidth, itemMaxWidth = _a.itemMaxWidth, items = _a.items, renderItem = _a.renderItem, getItemKey = _a.getItemKey;
    var currentMinWidth = (0, useBreakpoint_1.useBreakpoint)(itemMinWidth);
    var currentMaxWidth = (0, useBreakpoint_1.useBreakpoint)(itemMaxWidth !== null && itemMaxWidth !== void 0 ? itemMaxWidth : '100%');
    return (react_1.default.createElement(Base, { itemMinWidth: currentMinWidth, itemMaxWidth: currentMaxWidth }, items.map(function (item) { return (react_1.default.createElement(BaseItem, { key: getItemKey(item), itemMinWidth: currentMinWidth, itemMaxWidth: currentMaxWidth }, renderItem(item))); })));
};
exports.DataGrid = BaseDataGrid;
var templateObject_1, templateObject_2;
