import type { JSONSchema7 as JSONSchema } from 'json-schema';
import { FULL_TEXT_SLUG, Operator } from '../Filters/SchemaSieve';
import type { CreateFilter } from './utils';
import { OperatorSlugs } from '.';
export declare const operators: () => {
    contains: string;
    not_contains: string;
};
export type OperatorSlug = keyof ReturnType<typeof operators> | typeof FULL_TEXT_SLUG;
export declare const createFilter: CreateFilter<OperatorSlugs>;
export declare const getFilter: (field: string, schema: JSONSchema, value: string, operator: Operator<OperatorSlugs>) => JSONSchema;
export declare const editSchema: (schema: JSONSchema, operator: Operator<OperatorSlugs> | undefined) => JSONSchema;
