"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFilter = exports.operators = void 0;
var index_1 = require("../../utils/index");
var SchemaSieve_1 = require("../Filters/SchemaSieve");
var operators = function () { return ({
    is: 'is',
    is_not: 'is not',
}); };
exports.operators = operators;
var createFilter = function (field, operator, value) {
    var _a, _b, _c;
    var operatorSlug = operator.slug;
    if (operatorSlug === SchemaSieve_1.FULL_TEXT_SLUG && typeof value === 'string') {
        return {
            properties: (_a = {},
                _a[field] = {
                    type: 'string',
                    regexp: {
                        pattern: (0, index_1.regexEscape)(value),
                        flags: 'i',
                    },
                },
                _a),
            required: [field],
        };
    }
    if (operatorSlug === 'is' || operatorSlug === SchemaSieve_1.FULL_TEXT_SLUG) {
        return {
            properties: (_b = {},
                _b[field] = {
                    const: value,
                },
                _b),
            required: [field],
        };
    }
    if (operatorSlug === 'is_not') {
        return {
            properties: (_c = {},
                _c[field] = {
                    not: {
                        const: value,
                    },
                },
                _c),
        };
    }
    return {};
};
exports.createFilter = createFilter;
