"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDataModel = exports.isDateTimeFormat = void 0;
var arrayType = __importStar(require("./array"));
var booleanType = __importStar(require("./boolean"));
var dateTimeType = __importStar(require("./date-time"));
var enumType = __importStar(require("./enum"));
var numberType = __importStar(require("./number"));
var objectType = __importStar(require("./object"));
var oneOfType = __importStar(require("./oneOf"));
var stringType = __importStar(require("./string"));
var isDateTimeFormat = function (format) {
    return format === null || format === void 0 ? void 0 : format.endsWith('date-time');
};
exports.isDateTimeFormat = isDateTimeFormat;
var typeMap = {
    array: arrayType,
    string: stringType,
    object: objectType,
    boolean: booleanType,
    number: numberType,
};
var getDataModel = function (schema) {
    if (!schema) {
        return null;
    }
    var format = schema.format, type = schema.type;
    if (schema.enum) {
        return enumType;
    }
    if (schema.oneOf) {
        return oneOfType;
    }
    if ((0, exports.isDateTimeFormat)(format)) {
        return dateTimeType;
    }
    var typeSet = Array.isArray(type) ? type : [type];
    var dataTypeKey = Object.keys(typeMap).find(function (t) { return typeSet.includes(t); });
    if (!dataTypeKey) {
        return null;
    }
    var dataType = typeMap[dataTypeKey];
    return dataType;
};
exports.getDataModel = getDataModel;
