"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFilter = exports.operators = void 0;
var SchemaSieve_1 = require("../Filters/SchemaSieve");
var operators = function () { return ({
    is: 'is',
    is_not: 'is not',
    is_more_than: 'is more than',
    is_less_than: 'is less than',
}); };
exports.operators = operators;
var createFilter = function (field, operator, value) {
    var _a, _b, _c, _d;
    var operatorSlug = operator.slug;
    var val = typeof value === 'number'
        ? value
        : value !== '' && value != null
            ? Number(value)
            : undefined;
    if (val == null || isNaN(val)) {
        return {};
    }
    if (operatorSlug === 'is' || operatorSlug === SchemaSieve_1.FULL_TEXT_SLUG) {
        return {
            properties: (_a = {},
                _a[field] = {
                    type: 'number',
                    const: val,
                },
                _a),
            required: [field],
        };
    }
    if (operatorSlug === 'is_not') {
        return {
            properties: (_b = {},
                _b[field] = {
                    type: 'number',
                    not: {
                        const: val,
                    },
                },
                _b),
            required: [field],
        };
    }
    if (operatorSlug === 'is_more_than') {
        return {
            properties: (_c = {},
                _c[field] = {
                    type: 'number',
                    exclusiveMinimum: val,
                },
                _c),
            required: [field],
        };
    }
    if (operatorSlug === 'is_less_than') {
        return {
            properties: (_d = {},
                _d[field] = {
                    type: 'number',
                    exclusiveMaximum: val,
                },
                _d),
            required: [field],
        };
    }
    return {};
};
exports.createFilter = createFilter;
