import type { JSONSchema7 as JSONSchema } from 'json-schema';
import { UiSchema } from '@rjsf/core';
import { FULL_TEXT_SLUG, Operator } from '../Filters/SchemaSieve';
import type { CreateFilter } from './utils';
import { KeysOfUnion } from '~/common-types';
export declare const isKeyValueObj: (schema: JSONSchema) => boolean;
export declare const operators: (s: JSONSchema) => {
    contains: string;
    not_contains: string;
    is?: string | undefined;
    is_not?: string | undefined;
} | {
    key_contains: string;
    key_not_contains: string;
    key_is: string;
    key_matches_re: string;
    key_not_matches_re: string;
    value_is: string;
    value_contains: string;
    value_not_contains: string;
    value_matches_re: string;
    value_not_matches_re: string;
    is?: string | undefined;
    is_not?: string | undefined;
};
export type OperatorSlug = KeysOfUnion<ReturnType<typeof operators>> | typeof FULL_TEXT_SLUG;
export declare const createFilter: CreateFilter<OperatorSlug>;
export declare const editSchema: (schema: JSONSchema, operator: Operator<OperatorSlug> | undefined) => {
    title: string;
    properties: Partial<{
        [key: string]: import("json-schema").JSONSchema7Definition;
    }>;
    $id?: string | undefined;
    $ref?: string | undefined;
    $schema?: string | undefined;
    $comment?: string | undefined;
    $defs?: {
        [key: string]: import("json-schema").JSONSchema7Definition;
    } | undefined;
    type?: import("json-schema").JSONSchema7TypeName | import("json-schema").JSONSchema7TypeName[] | undefined;
    enum?: import("json-schema").JSONSchema7Type[] | undefined;
    const?: import("json-schema").JSONSchema7Type | undefined;
    multipleOf?: number | undefined;
    maximum?: number | undefined;
    exclusiveMaximum?: number | undefined;
    minimum?: number | undefined;
    exclusiveMinimum?: number | undefined;
    maxLength?: number | undefined;
    minLength?: number | undefined;
    pattern?: string | undefined;
    items?: import("json-schema").JSONSchema7Definition | import("json-schema").JSONSchema7Definition[] | undefined;
    additionalItems?: import("json-schema").JSONSchema7Definition | undefined;
    maxItems?: number | undefined;
    minItems?: number | undefined;
    uniqueItems?: boolean | undefined;
    contains?: import("json-schema").JSONSchema7Definition | undefined;
    maxProperties?: number | undefined;
    minProperties?: number | undefined;
    required?: string[] | undefined;
    patternProperties?: {
        [key: string]: import("json-schema").JSONSchema7Definition;
    } | undefined;
    additionalProperties?: import("json-schema").JSONSchema7Definition | undefined;
    dependencies?: {
        [key: string]: string[] | import("json-schema").JSONSchema7Definition;
    } | undefined;
    propertyNames?: import("json-schema").JSONSchema7Definition | undefined;
    if?: import("json-schema").JSONSchema7Definition | undefined;
    then?: import("json-schema").JSONSchema7Definition | undefined;
    else?: import("json-schema").JSONSchema7Definition | undefined;
    allOf?: import("json-schema").JSONSchema7Definition[] | undefined;
    anyOf?: import("json-schema").JSONSchema7Definition[] | undefined;
    oneOf?: import("json-schema").JSONSchema7Definition[] | undefined;
    not?: import("json-schema").JSONSchema7Definition | undefined;
    format?: string | undefined;
    contentMediaType?: string | undefined;
    contentEncoding?: string | undefined;
    definitions?: {
        [key: string]: import("json-schema").JSONSchema7Definition;
    } | undefined;
    description?: string | undefined;
    default?: import("json-schema").JSONSchema7Type | undefined;
    readOnly?: boolean | undefined;
    writeOnly?: boolean | undefined;
    examples?: import("json-schema").JSONSchema7Type | undefined;
} | {
    title: string;
    $id?: string | undefined;
    $ref?: string | undefined;
    $schema?: string | undefined;
    $comment?: string | undefined;
    $defs?: {
        [key: string]: import("json-schema").JSONSchema7Definition;
    } | undefined;
    type?: import("json-schema").JSONSchema7TypeName | import("json-schema").JSONSchema7TypeName[] | undefined;
    enum?: import("json-schema").JSONSchema7Type[] | undefined;
    const?: import("json-schema").JSONSchema7Type | undefined;
    multipleOf?: number | undefined;
    maximum?: number | undefined;
    exclusiveMaximum?: number | undefined;
    minimum?: number | undefined;
    exclusiveMinimum?: number | undefined;
    maxLength?: number | undefined;
    minLength?: number | undefined;
    pattern?: string | undefined;
    items?: import("json-schema").JSONSchema7Definition | import("json-schema").JSONSchema7Definition[] | undefined;
    additionalItems?: import("json-schema").JSONSchema7Definition | undefined;
    maxItems?: number | undefined;
    minItems?: number | undefined;
    uniqueItems?: boolean | undefined;
    contains?: import("json-schema").JSONSchema7Definition | undefined;
    maxProperties?: number | undefined;
    minProperties?: number | undefined;
    required?: string[] | undefined;
    properties?: {
        [key: string]: import("json-schema").JSONSchema7Definition;
    } | undefined;
    patternProperties?: {
        [key: string]: import("json-schema").JSONSchema7Definition;
    } | undefined;
    additionalProperties?: import("json-schema").JSONSchema7Definition | undefined;
    dependencies?: {
        [key: string]: string[] | import("json-schema").JSONSchema7Definition;
    } | undefined;
    propertyNames?: import("json-schema").JSONSchema7Definition | undefined;
    if?: import("json-schema").JSONSchema7Definition | undefined;
    then?: import("json-schema").JSONSchema7Definition | undefined;
    else?: import("json-schema").JSONSchema7Definition | undefined;
    allOf?: import("json-schema").JSONSchema7Definition[] | undefined;
    anyOf?: import("json-schema").JSONSchema7Definition[] | undefined;
    oneOf?: import("json-schema").JSONSchema7Definition[] | undefined;
    not?: import("json-schema").JSONSchema7Definition | undefined;
    format?: string | undefined;
    contentMediaType?: string | undefined;
    contentEncoding?: string | undefined;
    definitions?: {
        [key: string]: import("json-schema").JSONSchema7Definition;
    } | undefined;
    description?: string | undefined;
    default?: import("json-schema").JSONSchema7Type | undefined;
    readOnly?: boolean | undefined;
    writeOnly?: boolean | undefined;
    examples?: import("json-schema").JSONSchema7Type | undefined;
};
export declare const uiSchema: (schema: JSONSchema) => {
    [key: string]: UiSchema;
};
export declare const getFilter: (field: string, schema: JSONSchema, value: string, operator: Operator<OperatorSlug>) => JSONSchema;
