"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var Tag_1 = require("../Tag");
var utils_1 = require("../../utils");
var parseFilter = function (filter) {
    if (!filter) {
        return {};
    }
    try {
        return JSON.parse(filter.description);
    }
    catch (err) {
        return { value: filter.description };
    }
};
var FilterDescription = function (_a) {
    var _b;
    var filter = _a.filter, props = __rest(_a, ["filter"]);
    var tagProps = ((_b = filter.anyOf) === null || _b === void 0 ? void 0 : _b.map(function (filterFragment, i) {
        var _a, _b;
        var parsedFilter = parseFilter(filterFragment);
        var format = (0, utils_1.findInObject)(filterFragment, 'format');
        parsedFilter.name = parsedFilter.title;
        parsedFilter.operator = (_b = (_a = parsedFilter.operator) === null || _a === void 0 ? void 0 : _a.label) === null || _b === void 0 ? void 0 : _b.replace("".concat(parsedFilter.title, " "), '');
        if (parsedFilter.label) {
            parsedFilter.value = parsedFilter.label;
        }
        if (typeof parsedFilter.value === 'boolean') {
            parsedFilter.value = JSON.stringify(parsedFilter.value);
        }
        if (typeof parsedFilter.value === 'object') {
            parsedFilter.value = Object.entries(parsedFilter.value)
                .map(function (_a) {
                var key = _a[0], value = _a[1];
                return "".concat(key, ": ").concat(value);
            })
                .join(', ');
        }
        if (format === 'date-time') {
            var date = new Date(parsedFilter.value);
            parsedFilter.value = "".concat(date.toLocaleDateString(), " ").concat(date.toLocaleTimeString());
        }
        if (i > 0) {
            parsedFilter.prefix = 'or';
        }
        return parsedFilter;
    })) || [parseFilter(filter)];
    return React.createElement(Tag_1.Tag, __assign({ mt: 2, multiple: tagProps }, props));
};
exports.default = FilterDescription;
