"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Summary = void 0;
var react_1 = __importDefault(require("react"));
var Button_1 = require("../Button");
var Flex_1 = require("../Flex");
var Form_1 = require("../Form");
var Modal_1 = require("../Modal");
var Txt_1 = require("../Txt");
var FilterDescription_1 = __importDefault(require("./FilterDescription"));
var schema = {
    type: 'object',
    properties: {
        name: { type: 'string' },
    },
};
var Summary = function (_a) {
    var filters = _a.filters, onEdit = _a.onEdit, onDelete = _a.onDelete, onClearFilters = _a.onClearFilters, showSaveView = _a.showSaveView, onSaveView = _a.onSaveView;
    var _b = react_1.default.useState(false), showViewForm = _b[0], setShowViewForm = _b[1];
    var _c = react_1.default.useState(), viewData = _c[0], setViewData = _c[1];
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Flex_1.Flex, { flex: "1", flexDirection: "column" },
            react_1.default.createElement(Flex_1.Flex, { flex: "1", justifyContent: "space-between" },
                react_1.default.createElement(Flex_1.Flex, null,
                    react_1.default.createElement(Txt_1.Txt, { bold: true }, "Filters"),
                    react_1.default.createElement(Txt_1.Txt, { mr: 1 },
                        "(",
                        filters.length,
                        ")"),
                    react_1.default.createElement(Button_1.Button, { plain: true, primary: true, onClick: onClearFilters }, "Clear all")),
                showSaveView && (react_1.default.createElement(Flex_1.Flex, null,
                    react_1.default.createElement(Button_1.Button, { plain: true, primary: true, onClick: function () { return setShowViewForm(true); } }, "Save view")))),
            react_1.default.createElement(Flex_1.Flex, { flexWrap: "wrap" }, filters.map(function (filter, index) { return (react_1.default.createElement(FilterDescription_1.default, { key: filter.$id || index, filter: filter, onClick: function () {
                    onEdit(filter);
                }, onClose: function () { return onDelete(filter); } })); }))),
        showViewForm && (react_1.default.createElement(Modal_1.Modal, { title: "Save current view", cancel: function () { return setShowViewForm(false); }, done: function () {
                if (!(viewData === null || viewData === void 0 ? void 0 : viewData.name)) {
                    return;
                }
                onSaveView(viewData);
                setShowViewForm(false);
            }, action: "Save", primaryButtonProps: {
                disabled: !(viewData === null || viewData === void 0 ? void 0 : viewData.name),
            } },
            react_1.default.createElement(Form_1.Form, { width: "100%", hideSubmitButton: true, liveValidate: true, onFormChange: function (_a) {
                    var formData = _a.formData;
                    return setViewData(formData);
                }, schema: schema, value: viewData })))));
};
exports.Summary = Summary;
