"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Filters = void 0;
var react_1 = __importDefault(require("react"));
var Button_1 = require("../Button");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var faFilter_1 = require("@fortawesome/free-solid-svg-icons/faFilter");
var ViewsMenu_1 = __importDefault(require("./ViewsMenu"));
var styled_components_1 = __importDefault(require("styled-components"));
var Box_1 = require("../Box");
var Search_1 = require("../Search");
var Flex_1 = require("../Flex");
var FilterModal_1 = require("./FilterModal");
var Summary_1 = require("./Summary");
var utils_1 = require("../../utils");
var cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var SchemaSieve_1 = require("./SchemaSieve");
var SearchWrapper = (0, styled_components_1.default)(Box_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\twidth: 100%;\n\tflex-basis: 100%;\n\tposition: relative;\n\tmargin-right: 4px;\n\tpadding: 0 4px;\n\talign-self: center;\n"], ["\n\twidth: 100%;\n\tflex-basis: 100%;\n\tposition: relative;\n\tmargin-right: 4px;\n\tpadding: 0 4px;\n\talign-self: center;\n"])));
var Filters = function (_a) {
    var disabled = _a.disabled, filters = _a.filters, views = _a.views, schema = _a.schema, addFilterButtonProps = _a.addFilterButtonProps, viewsMenuButtonProps = _a.viewsMenuButtonProps, renderMode = _a.renderMode, dark = _a.dark, compact = _a.compact, showSaveView = _a.showSaveView, onViewsUpdate = _a.onViewsUpdate, onFiltersUpdate = _a.onFiltersUpdate, onSearch = _a.onSearch;
    var searchContainer = react_1.default.createRef();
    var _b = react_1.default.useState(false), showFilterModal = _b[0], setShowFilterModal = _b[1];
    var _c = react_1.default.useState(false), showSearchDropDown = _c[0], setShowSearchDropDown = _c[1];
    var _d = react_1.default.useState(), searchString = _d[0], setSearchString = _d[1];
    var _e = react_1.default.useState(filters !== null && filters !== void 0 ? filters : []), internalFilters = _e[0], setFilters = _e[1];
    var _f = react_1.default.useState(views), internalViews = _f[0], setViews = _f[1];
    var _g = react_1.default.useState(), editFilter = _g[0], setEditFilter = _g[1];
    react_1.default.useEffect(function () {
        if ((0, isEqual_1.default)(internalFilters, filters !== null && filters !== void 0 ? filters : [])) {
            return;
        }
        setFilters(filters !== null && filters !== void 0 ? filters : []);
    }, [filters]);
    react_1.default.useEffect(function () {
        if ((0, isEqual_1.default)(internalViews, views)) {
            return;
        }
        setViews(views);
    }, [views]);
    var deleteView = function (view) {
        if (!internalViews) {
            return;
        }
        var newViews = internalViews.filter(function (i) { return i.id !== view.id; });
        setViews(newViews);
        onViewsUpdate === null || onViewsUpdate === void 0 ? void 0 : onViewsUpdate(newViews);
    };
    var addFilter = function (filter) {
        var newFilters = internalFilters !== null && internalFilters !== void 0 ? internalFilters : [];
        if (editFilter === null || editFilter === void 0 ? void 0 : editFilter.$id) {
            newFilters = newFilters.filter(function (f) { return f.$id !== editFilter.$id; });
        }
        newFilters = __spreadArray(__spreadArray([], newFilters, true), [filter], false);
        setFilters(newFilters);
        onFiltersUpdate === null || onFiltersUpdate === void 0 ? void 0 : onFiltersUpdate(newFilters);
    };
    var deleteFilter = function (filter) {
        var _a;
        var newFilters = (_a = internalFilters === null || internalFilters === void 0 ? void 0 : internalFilters.filter(function (f) { return f.$id !== filter.$id; })) !== null && _a !== void 0 ? _a : [];
        setFilters(newFilters);
        onFiltersUpdate === null || onFiltersUpdate === void 0 ? void 0 : onFiltersUpdate(newFilters);
    };
    var saveView = function (name) {
        var _a;
        var view = {
            id: (0, utils_1.randomString)(),
            name: name,
            filters: (_a = (0, cloneDeep_1.default)(filters)) !== null && _a !== void 0 ? _a : [],
        };
        var newViews = __spreadArray(__spreadArray([], (internalViews !== null && internalViews !== void 0 ? internalViews : []), true), [view], false);
        setViews(newViews);
        onViewsUpdate === null || onViewsUpdate === void 0 ? void 0 : onViewsUpdate(newViews);
    };
    return (react_1.default.createElement(Box_1.Box, { style: { position: 'relative' } },
        react_1.default.createElement(Flex_1.Flex, { flex: "1" },
            (!renderMode || renderMode.includes('search')) && (react_1.default.createElement(SearchWrapper, { ref: searchContainer, onFocus: function () {
                    setShowSearchDropDown(true);
                    if (searchContainer.current) {
                        (0, utils_1.onClickOutOrEsc)(searchContainer.current, function () {
                            setShowSearchDropDown(false);
                        });
                    }
                } },
                react_1.default.createElement(Search_1.Search, { dark: dark, disabled: disabled, value: searchString, onChange: function (e) {
                        setShowSearchDropDown(e.target.value !== '');
                        setSearchString(e.target.value);
                    }, onEnter: function (e) {
                        e.preventDefault();
                        e.stopPropagation();
                        if (!searchString) {
                            return;
                        }
                        var newFilter = (0, SchemaSieve_1.createFullTextSearchFilter)(schema, searchString);
                        addFilter(newFilter);
                        setSearchString('');
                    } }),
                searchString && showSearchDropDown && (onSearch === null || onSearch === void 0 ? void 0 : onSearch(searchString)))),
            (!renderMode || renderMode.includes('add')) && (react_1.default.createElement(Button_1.Button, __assign({ disabled: disabled, light: dark, outline: true, quartenary: true, icon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faFilter_1.faFilter }), onClick: function () { return setShowFilterModal(true); }, label: "Add filter", compact: compact }, addFilterButtonProps))),
            (!renderMode || renderMode.includes('views')) && (react_1.default.createElement(ViewsMenu_1.default, { dark: dark, buttonProps: viewsMenuButtonProps, disabled: disabled, views: views || [], schema: schema, renderMode: renderMode, setFilters: function (f) {
                    setFilters(f);
                    onFiltersUpdate === null || onFiltersUpdate === void 0 ? void 0 : onFiltersUpdate(f);
                }, deleteView: deleteView, compact: compact }))),
        (!renderMode || renderMode.includes('summary')) &&
            internalFilters.length > 0 &&
            !disabled && (react_1.default.createElement(Summary_1.Summary, { onEdit: function (filter) {
                setEditFilter(filter);
                setShowFilterModal(true);
            }, onDelete: deleteFilter, onClearFilters: function () {
                setFilters([]);
                onFiltersUpdate === null || onFiltersUpdate === void 0 ? void 0 : onFiltersUpdate([]);
            }, showSaveView: showSaveView !== null && showSaveView !== void 0 ? showSaveView : renderMode === null || renderMode === void 0 ? void 0 : renderMode.includes('views'), onSaveView: function (_a) {
                var name = _a.name;
                return saveView(name);
            }, filters: internalFilters })),
        showFilterModal && (react_1.default.createElement(FilterModal_1.FilterModal, { schema: schema, editFilter: editFilter, addFilter: function (filter) {
                addFilter(filter);
                setShowFilterModal(false);
            }, onClose: function () { return setShowFilterModal(false); } }))));
};
exports.Filters = Filters;
var templateObject_1;
