import type { JSONSchema7 as JSONSchema } from 'json-schema';
import * as React from 'react';
import RsjfForm, { IChangeEvent, FormProps as JsonSchemaFormProps, UiSchema, WidgetProps, Field, Widget } from '@rjsf/core';
import { BoxProps } from '../Box';
import { ButtonProps } from '../Button';
import { Format } from '../Renderer/types';
export interface RenditionUiSchema extends UiSchema {
    'ui:warning'?: string;
}
export interface FormWidgetProps extends WidgetProps {
    registry: {
        fields: {
            [name: string]: Field;
        };
        widgets: {
            [name: string]: Widget;
        };
        definitions: {
            [name: string]: any;
        };
        formContext: any;
    };
    type?: string;
    rawErrors: string[];
}
export interface FormProps extends BoxProps, Pick<JsonSchemaFormProps<any>, 'validate' | 'noValidate' | 'liveValidate' | 'transformErrors' | 'disabled'> {
    submitButtonText?: string | JSX.Element;
    hideSubmitButton?: boolean;
    submitButtonProps?: ButtonProps;
    secondaryButtonProps?: ButtonProps;
    value?: number | string | boolean | {
        [index: string]: any;
    } | any[] | null;
    onFormChange?: (result: IChangeEvent) => void;
    onFormSubmit?: (result: any) => void;
    uiSchema?: RenditionUiSchema;
    schema: JSONSchema;
    extraFormats?: Format[];
    widgets?: {
        [k: string]: any;
    };
}
export declare const Form: React.ForwardRefExoticComponent<FormProps & React.RefAttributes<RsjfForm<any>>>;
