"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var Select_1 = require("../../Select");
var SelectWidget = function (props) {
    var id = props.id, options = props.options, value = props.value, disabled = props.disabled, readonly = props.readonly, onChange = props.onChange;
    var enumOptions = options.enumOptions, enumDisabled = options.enumDisabled;
    if (!Array.isArray(enumOptions)) {
        return null;
    }
    var sanitizedEnumDisabled = Array.isArray(enumDisabled)
        ? enumDisabled
        : null;
    var selectOptions = enumOptions.map(function (option) {
        return __assign(__assign({}, option), { disabled: sanitizedEnumDisabled != null &&
                sanitizedEnumDisabled.includes(option.value) });
    });
    return (React.createElement(Select_1.Select, { width: "100%", id: id, value: value !== undefined
            ? selectOptions.find(function (option) { return option.value === value; })
            : undefined, disabled: disabled || readonly, onChange: function (_a) {
            var option = _a.option;
            onChange(option.value);
        }, options: selectOptions, emphasized: options.emphasized, valueKey: "value", labelKey: "label", disabledKey: "disabled" }));
};
exports.default = SelectWidget;
