"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Layout = void 0;
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var useBreakpoint_1 = require("../../hooks/useBreakpoint");
var ErrorBoundary_1 = __importDefault(require("../../internal/ErrorBoundary"));
var Box_1 = require("../Box");
var Sidebar_1 = require("../Sidebar");
var Header_1 = require("./Header");
var Grid = (0, styled_components_1.default)(Box_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: grid;\n\tgrid-template-areas: ", ";\n\tgrid-template-rows: ", ";\n\tgrid-template-columns: ", ";\n"], ["\n\tdisplay: grid;\n\tgrid-template-areas: ", ";\n\tgrid-template-rows: ", ";\n\tgrid-template-columns: ", ";\n"])), function (props) { return props.gridTemplateAreas; }, function (props) { return props.gridTemplateRows; }, function (props) { return props.gridTemplateColumns; });
var GridItem = (0, styled_components_1.default)(Box_1.Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tgrid-area: ", ";\n"], ["\n\tgrid-area: ", ";\n"])), function (props) { return props.gridArea; });
var Layout = function (_a) {
    var header = _a.header, footer = _a.footer, leftSider = _a.leftSider, contentHeader = _a.contentHeader, children = _a.children, ErrorBoundary = _a.ErrorBoundary, isSidebarCollapsed = _a.isSidebarCollapsed, setIsSidebarCollapsed = _a.setIsSidebarCollapsed;
    var templateAreas = "\n\t\t\"leftSider header\"\n\t\t\"leftSider contentHeader\"\n\t\t\"leftSider content\"\n\t\t\"footer footer\"\n\t";
    var templateRows = "\n\t\t[header header] max-content\n\t\t[contentHeader] max-content\n\t\t[content] minmax(0,1fr)\n\t\t[footer footer] max-content\n\t";
    var templateColumns = "\n\t\t[leftSider] max-content\n\t\t[content] minmax(0, 1fr)\n\t";
    var mobile = (0, useBreakpoint_1.useBreakpoint)([true, true, false]);
    var _b = React.useState(true), collapsed = _b[0], setCollapsed = _b[1];
    React.useEffect(function () {
        if (mobile) {
            (setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed)(true);
        }
        else {
            (setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed)(false);
        }
    }, [mobile]);
    var ErrorBoundaryComponent = React.useCallback(function (_a) {
        var children = _a.children;
        return ErrorBoundary ? (React.createElement(ErrorBoundary, null, children)) : (React.createElement(ErrorBoundary_1.default, null, children));
    }, [ErrorBoundary]);
    return (React.createElement(Grid, { bg: "transparent", height: "100%", gridTemplateAreas: templateAreas.trim(), gridTemplateRows: templateRows.trim(), gridTemplateColumns: templateColumns },
        header && (React.createElement(GridItem, { gridArea: "header" },
            React.createElement(ErrorBoundaryComponent, null, React.isValidElement(header) ? (header) : typeof header === 'object' ? (React.createElement(Header_1.Header, __assign({ isSidebarCollapsed: isSidebarCollapsed !== null && isSidebarCollapsed !== void 0 ? isSidebarCollapsed : collapsed, setIsSidebarCollapsed: setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed }, header))) : (header(isSidebarCollapsed !== null && isSidebarCollapsed !== void 0 ? isSidebarCollapsed : collapsed, setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed))))),
        leftSider && (React.createElement(GridItem, { style: {
                overflowY: 'auto',
            }, gridArea: "leftSider" }, React.isValidElement(leftSider) ? (leftSider) : typeof leftSider === 'object' ? (React.createElement(ErrorBoundaryComponent, null,
            React.createElement(Sidebar_1.Sidebar, __assign({}, (!mobile && {
                isCollapsed: isSidebarCollapsed !== null && isSidebarCollapsed !== void 0 ? isSidebarCollapsed : collapsed,
                setIsCollapsed: setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed,
            }), leftSider)))) : (leftSider(isSidebarCollapsed !== null && isSidebarCollapsed !== void 0 ? isSidebarCollapsed : collapsed, setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed)))),
        contentHeader && (React.createElement(GridItem, { gridArea: "contentHeader" }, React.createElement(ErrorBoundaryComponent, null, contentHeader))),
        React.createElement(GridItem, { style: {
                flexDirection: 'column',
                display: 'flex',
                overflowY: 'auto',
            }, gridArea: "content" },
            React.createElement(ErrorBoundaryComponent, null, children)),
        footer && (React.createElement(GridItem, { gridArea: "footer" },
            React.createElement(ErrorBoundaryComponent, null, footer)))));
};
exports.Layout = Layout;
var templateObject_1, templateObject_2;
