"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Nested = exports.WithTooltip = exports.WithOverflowingContent = exports.WithCustomizedButtons = exports.WithMultielementTitle = exports.WithCustomWidth = exports.WithTitleDetails = exports.NoCancel = exports.CustomAction = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var __1 = require("../../");
var _1 = require(".");
var pokedex_1 = __importDefault(require("../../stories/assets/pokedex"));
var NestedModalDemo = function (props) {
    var _a = react_1.default.useState(false), show1 = _a[0], setShow1 = _a[1];
    var _b = react_1.default.useState(false), show2 = _b[0], setShow2 = _b[1];
    return (react_1.default.createElement(__1.Box, null,
        react_1.default.createElement(__1.Button, { primary: true, onClick: function () { return setShow1(true); } }, "Open Modal"),
        show1 && (react_1.default.createElement(_1.Modal, __assign({ title: "First Modal" }, props, { cancel: function () {
                var _a;
                setShow1(false);
                (_a = props.cancel) === null || _a === void 0 ? void 0 : _a.call(props);
            }, done: function () {
                var _a;
                setShow2(true);
                (_a = props.done) === null || _a === void 0 ? void 0 : _a.call(props);
            }, action: "Open another modal" }), show2 && (react_1.default.createElement(_1.Modal, __assign({ title: "Second Modal" }, props, { cancel: function () {
                var _a;
                setShow2(false);
                (_a = props.cancel) === null || _a === void 0 ? void 0 : _a.call(props);
            }, done: function () {
                var _a;
                setShow2(false);
                (_a = props.done) === null || _a === void 0 ? void 0 : _a.call(props);
            } })))))));
};
exports.default = {
    title: 'Core/Modal',
    component: _1.Modal,
};
var Template = (0, utils_1.createTemplate)(NestedModalDemo);
exports.Default = (0, utils_1.createStory)(Template, {
    title: 'Modal title',
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
exports.CustomAction = (0, utils_1.createStory)(Template, {
    title: 'Modal title',
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("p", null, "Lorem ipsum dolor sit amet"))),
    action: 'Go!',
});
exports.NoCancel = (0, utils_1.createStory)(Template, {
    title: 'Modal title',
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
exports.WithTitleDetails = (0, utils_1.createStory)(Template, {
    title: (react_1.default.createElement(react_1.default.Fragment, null,
        "Modal title",
        react_1.default.createElement(__1.Txt, { mt: 3, fontSize: "initial" }, "Optional details"))),
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
exports.WithCustomWidth = (0, utils_1.createStory)(Template, {
    title: (react_1.default.createElement(react_1.default.Fragment, null,
        "Modal title",
        react_1.default.createElement(__1.Txt, { mt: 3, fontSize: "initial" }, "Optional details"))),
    width: ['auto', 500, 1000],
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
exports.WithMultielementTitle = (0, utils_1.createStory)(Template, {
    title: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(__1.Heading.h3, null, "Heading"),
        react_1.default.createElement(__1.Button, { mt: 3, primary: true }, "A button"))),
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
exports.WithCustomizedButtons = (0, utils_1.createStory)(Template, {
    title: 'Modal title',
    secondaryButtonProps: {
        children: 'Refresh',
        onClick: function () { return null; },
    },
    cancelButtonProps: {
        children: 'Abort',
        width: 150,
        style: {
            marginRight: 30,
        },
    },
    primaryButtonProps: {
        width: 150,
        danger: true,
        primary: false,
        disabled: true,
    },
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
exports.WithOverflowingContent = (0, utils_1.createStory)(Template, {
    title: 'Modal title',
    children: (react_1.default.createElement(react_1.default.Fragment, null, pokedex_1.default.map(function (x, i) { return (react_1.default.createElement("p", { key: i }, x.Description)); }))),
});
exports.WithTooltip = (0, utils_1.createStory)(Template, {
    title: 'Modal title',
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(__1.Heading.h5, { tooltip: { text: 'Good job!', trigger: 'hover' } }, "Hover me and a tooltip will be displayed."))),
});
exports.Nested = (0, utils_1.createStory)(Template, {
    title: 'Modal title',
    children: (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(NestedModalDemo, null))),
});
