"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Positioning = exports.Types = exports.Default = void 0;
var React = __importStar(require("react"));
var utils_1 = require("../../stories/utils");
var __1 = require("../..");
var _1 = require(".");
var textNotification = 'This is a notification';
var getContainerNotification = function (container) { return ({
    container: container,
    content: container,
}); };
var getTypeNotification = function (type) { return ({
    type: type,
    duration: 0,
    content: type,
}); };
var NotificationButton = function (_a) {
    var buttonText = _a.buttonText, notification = _a.notification;
    return (React.createElement(__1.Button, { m: 2, minWidth: 150, onClick: function () { return _1.notifications.addNotification(notification); } }, buttonText || notification.content));
};
var NotificationsStory = function () {
    React.useEffect(function () {
        _1.notifications.addNotification(buttonNotification);
        _1.notifications.addNotification(textNotification);
    }, []);
    return (React.createElement(__1.Flex, { flexDirection: "column", p: 3, alignItems: "flex-start" },
        React.createElement(_1.NotificationsContainer, null),
        React.createElement(NotificationButton, { buttonText: "Add text notification", notification: textNotification }),
        React.createElement(NotificationButton, { buttonText: "Add button notification", notification: buttonNotification })));
};
var NotificationTypeStory = function () {
    var typeNotifications = ['danger', 'success', 'warning', 'info'].map(getTypeNotification);
    React.useEffect(function () {
        typeNotifications.forEach(_1.notifications.addNotification);
    }, []);
    return (React.createElement(__1.Flex, { flexDirection: "column", p: 3, alignItems: "flex-start" },
        React.createElement(_1.NotificationsContainer, null),
        typeNotifications.map(function (typeNotification, index) { return (React.createElement(NotificationButton, { key: index, notification: typeNotification })); })));
};
var NotificationPositionStory = function () {
    var containerNotifications = [
        'top-left',
        'top-center',
        'top-right',
        'center',
        'bottom-left',
        'bottom-center',
        'bottom-right',
    ].map(getContainerNotification);
    React.useEffect(function () {
        containerNotifications.forEach(_1.notifications.addNotification);
    }, []);
    return (React.createElement(React.Fragment, null,
        React.createElement(_1.NotificationsContainer, null),
        React.createElement(__1.Flex, { pt: 6, flexDirection: "column", alignItems: "center", justifyContent: "center" },
            React.createElement(__1.Flex, null,
                React.createElement(NotificationButton, { notification: containerNotifications[0] }),
                React.createElement(NotificationButton, { notification: containerNotifications[1] }),
                React.createElement(NotificationButton, { notification: containerNotifications[2] })),
            React.createElement(NotificationButton, { notification: containerNotifications[3] }),
            React.createElement(__1.Flex, null,
                React.createElement(NotificationButton, { notification: containerNotifications[4] }),
                React.createElement(NotificationButton, { notification: containerNotifications[5] }),
                React.createElement(NotificationButton, { notification: containerNotifications[6] })))));
};
var buttonNotification = {
    onDismiss: function () { return null; },
    content: (React.createElement(__1.Box, null,
        React.createElement(__1.Txt, { mb: 2 }, "Some text for the user to read"),
        React.createElement(__1.Button, null, "This is a button"))),
};
exports.default = {
    title: 'Core/Notifications',
    component: _1.NotificationsContainer,
};
var Template = (0, utils_1.createTemplate)(NotificationsStory);
exports.Default = (0, utils_1.createStory)(Template, {});
var TypeTemplate = (0, utils_1.createTemplate)(NotificationTypeStory);
exports.Types = (0, utils_1.createStory)(TypeTemplate, {});
var PositionTemplate = (0, utils_1.createTemplate)(NotificationPositionStory);
exports.Positioning = (0, utils_1.createStory)(PositionTemplate, {});
