import * as React from 'react';
import { ReactNotifications } from 'react-notifications-component';
import { AlertProps } from '../Alert';
type CONTAINER = 'top-left' | 'top-right' | 'top-center' | 'bottom-left' | 'bottom-right' | 'bottom-center';
type NOTIFICATION_TYPE = 'danger' | 'warning' | 'success' | 'info';
export interface NotificationOptions extends Pick<AlertProps, 'prefix'> {
    content: React.ReactNode;
    onDismiss?: () => void;
    id?: string;
    duration?: number;
    container?: CONTAINER;
    type?: NOTIFICATION_TYPE;
}
export declare const NotificationsContainer: import("styled-components").StyledComponent<typeof ReactNotifications, any, {}, never>;
export declare const notifications: {
    addNotification: (options: React.ReactNode | NotificationOptions) => void;
    removeNotification: (id: string) => void;
};
export {};
