"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.notifications = exports.NotificationsContainer = void 0;
var React = __importStar(require("react"));
var react_notifications_component_1 = require("react-notifications-component");
var styled_components_1 = __importDefault(require("styled-components"));
var animations_1 = require("../../animations");
var Alert_1 = require("../Alert");
var defaultStyle_1 = __importDefault(require("./defaultStyle"));
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var faBan_1 = require("@fortawesome/free-solid-svg-icons/faBan");
var Txt_1 = require("../Txt");
var theme_1 = __importDefault(require("../../theme"));
var NOTIFICATION_WIDTH = 300;
var DEFAULT_NOTIFICATION_DURATION = 6000;
var DEFAULT_NOTIFICATION_CONTAINER = 'top-right';
var FullWidthContainer = (0, styled_components_1.default)(Alert_1.Alert)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\twidth: 100%;\n"], ["\n\twidth: 100%;\n"])));
var enterExitAnimation = {
    duration: 200,
    timingFunction: 'linear',
    delay: 0,
};
var generateNotificationId = function () {
    return Math.random().toString(36).substr(2, 9);
};
var NotificationContainer = function (_a) {
    var content = _a.content, type = _a.type, onDismiss = _a.onDismiss, id = _a.id, prefix = _a.prefix;
    return (React.createElement(FullWidthContainer, { emphasized: Boolean(type), success: type === 'success', danger: type === 'danger', warning: type === 'warning', info: type === 'info', onDismiss: function () {
            if (onDismiss) {
                onDismiss();
            }
            react_notifications_component_1.Store.removeNotification(id);
        }, prefix: prefix !== null && prefix !== void 0 ? prefix : (type === 'danger' ? (React.createElement(React.Fragment, null,
            React.createElement(Txt_1.Txt.span, { color: theme_1.default.colors.danger.main, mr: 2 },
                React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faBan_1.faBan })),
            React.createElement(Txt_1.Txt.span, null, "Error!"))) : undefined) }, content));
};
exports.NotificationsContainer = (0, styled_components_1.default)(react_notifications_component_1.ReactNotifications)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t", "\n\t", "\n\n\tposition: fixed;\n\tz-index: 9000;\n\tpointer-events: none;\n\twidth: 100%;\n\theight: 100%;\n\n\t/* This overrides the react-notification library's default container shadow */\n\t.rnc__notification-item {\n\t\tbox-shadow: none;\n\t}\n"], ["\n\t", "\n\t", "\n\n\tposition: fixed;\n\tz-index: 9000;\n\tpointer-events: none;\n\twidth: 100%;\n\theight: 100%;\n\n\t/* This overrides the react-notification library's default container shadow */\n\t.rnc__notification-item {\n\t\tbox-shadow: none;\n\t}\n"])), animations_1.animations, defaultStyle_1.default);
var isNotificationOptions = function (options) {
    return typeof options === 'object' && !React.isValidElement(options);
};
exports.notifications = {
    addNotification: function (options) {
        var _a, _b, _c;
        var transformedOptions = isNotificationOptions(options)
            ? options
            : { content: options };
        (_a = transformedOptions.id) !== null && _a !== void 0 ? _a : (transformedOptions.id = generateNotificationId());
        (_b = transformedOptions.duration) !== null && _b !== void 0 ? _b : (transformedOptions.duration = DEFAULT_NOTIFICATION_DURATION);
        (_c = transformedOptions.container) !== null && _c !== void 0 ? _c : (transformedOptions.container = DEFAULT_NOTIFICATION_CONTAINER);
        react_notifications_component_1.Store.addNotification({
            container: transformedOptions.container,
            animationIn: ['animated', 'fadeIn', 'faster'],
            animationOut: ['animated', 'fadeOut', 'faster'],
            slidingEnter: enterExitAnimation,
            slidingExit: enterExitAnimation,
            touchRevert: enterExitAnimation,
            touchSlidingExit: {
                swipe: enterExitAnimation,
                fade: enterExitAnimation,
            },
            dismiss: {
                duration: transformedOptions.duration,
                pauseOnHover: true,
                waitForAnimation: false,
                click: false,
                touch: false,
            },
            width: NOTIFICATION_WIDTH,
            id: transformedOptions.id,
            content: (React.createElement(NotificationContainer, { type: transformedOptions.type, onDismiss: transformedOptions.onDismiss, id: transformedOptions.id, content: transformedOptions.content, prefix: transformedOptions.prefix })),
        });
    },
    removeNotification: function (id) { return react_notifications_component_1.Store.removeNotification(id); },
};
var templateObject_1, templateObject_2;
