"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var enzyme_1 = require("enzyme");
var noop_1 = __importDefault(require("lodash/noop"));
var react_1 = __importDefault(require("react"));
var sinon_1 = __importDefault(require("sinon"));
var __1 = require("../../");
describe('Pager component', function () {
    it('should disable the "prev" button on page 0', function () {
        var callback = sinon_1.default.spy();
        var component = (0, enzyme_1.mount)(react_1.default.createElement(__1.Provider, null,
            react_1.default.createElement(__1.Pager, { totalItems: 436, itemsPerPage: 50, page: 0, nextPage: noop_1.default, prevPage: callback })));
        var firstButton = component.find('button').first();
        firstButton.simulate('click');
        expect(callback.callCount).toEqual(0);
        expect(firstButton.prop('disabled')).toEqual(true);
    });
    it('should disable the "next" button on the last page', function () {
        var callback = sinon_1.default.spy();
        var component = (0, enzyme_1.mount)(react_1.default.createElement(__1.Provider, null,
            react_1.default.createElement(__1.Pager, { totalItems: 100, itemsPerPage: 50, page: 1, nextPage: callback, prevPage: noop_1.default })));
        var lastButton = component.find('button').last();
        lastButton.simulate('click');
        expect(callback.callCount).toEqual(0);
        expect(lastButton.prop('disabled')).toEqual(true);
    });
});
