"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Rating = void 0;
var faStar_1 = require("@fortawesome/free-solid-svg-icons/faStar");
var faStar_2 = require("@fortawesome/free-regular-svg-icons/faStar");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var React = __importStar(require("react"));
var range_1 = __importDefault(require("lodash/range"));
var isNumber_1 = __importDefault(require("lodash/isNumber"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var useTheme_1 = require("../../hooks/useTheme");
var Flex_1 = require("../Flex");
var Star = function (_a) {
    var full = _a.full, rest = __rest(_a, ["full"]);
    var theme = (0, useTheme_1.useTheme)();
    var iconProps = full
        ? {
            color: theme.rating.star.color.full,
            icon: faStar_1.faStar,
        }
        : {
            color: theme.rating.star.color.empty,
            icon: faStar_2.faStar,
        };
    return React.createElement(react_fontawesome_1.FontAwesomeIcon, __assign({}, iconProps, rest));
};
var isStarFull = function (hoverValue, newValue, value) {
    if (hoverValue > 0) {
        return newValue <= hoverValue;
    }
    return (0, isNumber_1.default)(value) && newValue <= value;
};
var BaseRating = React.memo(function (_a) {
    var value = _a.value, onChange = _a.onChange, rest = __rest(_a, ["value", "onChange"]);
    var _b = React.useState(0), hoverValue = _b[0], setHoverValue = _b[1];
    return (React.createElement(Flex_1.Flex, __assign({}, rest), (0, range_1.default)(1, 6).map(function (newValue) {
        return (React.createElement(Star, { key: newValue, full: isStarFull(hoverValue, newValue, value), onClick: function () { return onChange(newValue); }, onMouseOver: function () { return setHoverValue(newValue); }, onMouseOut: function () { return setHoverValue(0); } }));
    })));
});
exports.Rating = (0, asRendition_1.default)(BaseRating);
