"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RendererPlayground = void 0;
var React = __importStar(require("react"));
var keys_1 = __importDefault(require("lodash/keys"));
var get_1 = __importDefault(require("lodash/get"));
var escapeRegExp_1 = __importDefault(require("lodash/escapeRegExp"));
var filter_1 = __importDefault(require("lodash/filter"));
var memoize_1 = __importDefault(require("lodash/memoize"));
var json_schema_draft_07_json_1 = __importDefault(require("ajv/lib/refs/json-schema-draft-07.json"));
var styled_components_1 = __importDefault(require("styled-components"));
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var faUndo_1 = require("@fortawesome/free-solid-svg-icons/faUndo");
var asRendition_1 = __importDefault(require("../../../asRendition"));
var Flex_1 = require("../../Flex");
var Box_1 = require("../../Box");
var Card_1 = require("../../Card");
var Select_1 = require("../../Select");
var Button_1 = require("../../Button");
var Heading_1 = require("../../Heading");
var Checkbox_1 = require("../../Checkbox");
var index_1 = require("../index");
var examples_1 = require("../examples");
var JsonEditor_1 = __importDefault(require("./JsonEditor"));
var util_1 = require("./util");
var SlimCard = (0, styled_components_1.default)(Card_1.Card)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t& > div {\n\t\tflex: 1;\n\t\tdisplay: flex;\n\t\tflex-direction: column;\n\t}\n"], ["\n\t& > div {\n\t\tflex: 1;\n\t\tdisplay: flex;\n\t\tflex-direction: column;\n\t}\n"])));
var ResultCard = (0, styled_components_1.default)(SlimCard)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t& > div > div:last-child {\n\t\tdisplay: flex;\n\t}\n"], ["\n\t& > div > div:last-child {\n\t\tdisplay: flex;\n\t}\n"])));
var EditCard = (0, styled_components_1.default)(SlimCard)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\t& > div > div {\n\t\tflex: 1;\n\t\tdisplay: flex;\n\t\tflex-direction: column;\n\t\tmin-height: 0;\n\t}\n"], ["\n\t& > div > div {\n\t\tflex: 1;\n\t\tdisplay: flex;\n\t\tflex-direction: column;\n\t\tmin-height: 0;\n\t}\n"])));
var defaultJsonProps = { value: {}, schema: {}, uiSchema: {} };
var defaultRegExp = new RegExp('');
var getExampleNames = (0, memoize_1.default)(function (examples) { return (0, keys_1.default)(examples); });
var commonCardProps = {
    small: true,
    backgroundColor: 'quartenary.light',
};
var RendererPlaygroundBase = function (_a) {
    var _b = _a.title, title = _b === void 0 ? 'JSON Playground' : _b, examples = _a.examples, props = __rest(_a, ["title", "examples"]);
    var _c = React.useState(true), validate = _c[0], setValidate = _c[1];
    var _d = React.useState(''), selectedExample = _d[0], setSelectedExample = _d[1];
    var _e = React.useState(defaultRegExp), searchTermRegExp = _e[0], setSearchTermRegExp = _e[1];
    var _f = React.useState({}), value = _f[0], setValue = _f[1];
    var _g = React.useState({}), schema = _g[0], setSchema = _g[1];
    var _h = React.useState({}), uiSchema = _h[0], setUiSchema = _h[1];
    var _j = React.useState(true), isValueJsonValid = _j[0], setIsValueJsonValid = _j[1];
    var _k = React.useState(true), isSchemaJsonValid = _k[0], setIsSchemaJsonValid = _k[1];
    var _l = React.useState(true), isUiSchemaJsonValid = _l[0], setIsUiSchemaJsonValid = _l[1];
    var reset = React.useCallback(function () {
        setSelectedExample('');
        setSearchTermRegExp(defaultRegExp);
    }, [setSelectedExample, setSearchTermRegExp]);
    var onValueStrChange = React.useCallback(function (valueStr) {
        try {
            setValue(JSON.parse(valueStr));
            setIsValueJsonValid(true);
        }
        catch (_a) {
            setIsValueJsonValid(false);
        }
    }, []);
    var onSchemaStrChange = React.useCallback(function (schemaStr) {
        try {
            setSchema(JSON.parse(schemaStr));
            setIsSchemaJsonValid(true);
        }
        catch (_a) {
            setIsSchemaJsonValid(false);
        }
    }, []);
    var onUiSchemaStrChange = React.useCallback(function (uiSchemaStr) {
        try {
            setUiSchema(JSON.parse(uiSchemaStr));
            setIsUiSchemaJsonValid(true);
        }
        catch (_a) {
            setIsUiSchemaJsonValid(false);
        }
    }, []);
    React.useEffect(function () {
        var example = (0, get_1.default)(examples, selectedExample, defaultJsonProps);
        setValue(example.value);
        setSchema(example.schema);
        setUiSchema(example.uiSchema);
        setSearchTermRegExp(defaultRegExp);
    }, [selectedExample]);
    var uiSchemaMetaSchema = React.useMemo(function () {
        try {
            var newMetaSchema = (0, util_1.generateUiSchemaMetaSchema)({
                value: value,
                schema: schema,
                uiSchema: uiSchema,
                extraContext: __assign(__assign({}, examples_1.CONTEXT_FUNCTIONS), { root: value }),
            });
            return newMetaSchema;
        }
        catch (error) {
            console.error('Failed to parse schemas', error);
            throw new Error('Failed to parse schemas');
        }
    }, [uiSchema, schema, value]);
    var valueStr = React.useMemo(function () { return JSON.stringify(value, null, 2); }, [value]);
    var schemaStr = React.useMemo(function () { return JSON.stringify(schema, null, 2); }, [schema]);
    var uiSchemaStr = React.useMemo(function () { return JSON.stringify(uiSchema, null, 2); }, [uiSchema]);
    var unfilteredExampleNames = getExampleNames(examples);
    var exampleNames = searchTermRegExp.source
        ? (0, filter_1.default)(unfilteredExampleNames, function (name) { return searchTermRegExp.test(name); })
        : unfilteredExampleNames;
    return (React.createElement(Flex_1.Flex, __assign({ p: 3 }, props),
        React.createElement(Flex_1.Flex, { flex: "1 1 50%", minWidth: 0, flexDirection: "column", pr: 2 },
            React.createElement(Flex_1.Flex, { mb: 3, alignItems: "center", justifyContent: "space-between" },
                React.createElement(Heading_1.Heading.h3, null, title),
                React.createElement(Flex_1.Flex, { ml: 3, alignItems: "center", justifyContent: "flex-end", flex: 1 },
                    React.createElement(Box_1.Box, { flex: 1 },
                        React.createElement(Select_1.Select, { placeholder: "Load an example...", emptySearchMessage: "No results", searchPlaceholder: "Search...", onSearch: function (s) {
                                return setSearchTermRegExp(new RegExp((0, escapeRegExp_1.default)(s), 'i'));
                            }, value: selectedExample, options: exampleNames, onChange: function (_a) {
                                var option = _a.option;
                                setSelectedExample(option);
                            } })),
                    React.createElement(Button_1.Button, { ml: 2, tooltip: { text: 'Reset', placement: 'right' }, icon: React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faUndo_1.faUndo }), onClick: reset }))),
            React.createElement(EditCard, __assign({ flex: 1 }, commonCardProps),
                React.createElement(JsonEditor_1.default, { title: "Data", value: valueStr, onChange: onValueStrChange, schema: schema, isValid: isValueJsonValid }),
                React.createElement(JsonEditor_1.default, { title: "Schema", value: schemaStr, onChange: onSchemaStrChange, schema: json_schema_draft_07_json_1.default, isValid: isSchemaJsonValid }),
                React.createElement(JsonEditor_1.default, { title: "UI Schema", value: uiSchemaStr, onChange: onUiSchemaStrChange, schema: uiSchemaMetaSchema, isValid: isUiSchemaJsonValid }))),
        React.createElement(Flex_1.Flex, { flex: "1 1 50%", minWidth: 0, flexDirection: "column", pl: 2 },
            React.createElement(ResultCard, __assign({ flex: 1 }, commonCardProps, { title: "Result", cta: React.createElement(Checkbox_1.Checkbox, { checked: validate, label: "Validate", onChange: function (e) { return setValidate(e.target.checked); } }) }),
                React.createElement(index_1.Renderer, { value: value, schema: schema, uiSchema: uiSchema, p: 2, pb: 1, validate: validate, backgroundColor: "#fff", extraFormats: examples_1.EXTRA_FORMATS, extraContext: __assign(__assign({}, examples_1.CONTEXT_FUNCTIONS), { root: value }) })))));
};
exports.RendererPlayground = (0, asRendition_1.default)(RendererPlaygroundBase);
var templateObject_1, templateObject_2, templateObject_3;
