"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WidgetWrapperUiOptions = exports.FlexUiOptions = exports.SpaceUiOptions = exports.UiOption = exports.responsive = void 0;
var responsive = function (schema) {
    return {
        anyOf: [
            {
                type: 'array',
                items: schema,
            },
            __assign({}, schema),
        ],
    };
};
exports.responsive = responsive;
exports.UiOption = {
    string: {
        type: 'string',
    },
    boolean: {
        type: 'boolean',
    },
    number: {
        type: 'number',
    },
    integer: {
        type: 'integer',
    },
    space: (0, exports.responsive)({
        type: ['number', 'string'],
    }),
};
exports.SpaceUiOptions = {};
[
    'p',
    'pt',
    'pb',
    'pl',
    'pr',
    'px',
    'py',
    'm',
    'mt',
    'mb',
    'ml',
    'mr',
    'mx',
    'my',
].reduce(function (options, option) {
    options[option] = exports.UiOption.space;
    return options;
}, exports.SpaceUiOptions);
exports.FlexUiOptions = {
    flex: (0, exports.responsive)({
        type: ['number', 'string'],
    }),
    flexDirection: (0, exports.responsive)({
        type: 'string',
        enum: ['column', 'row', 'column-reverse', 'row-reverse'],
    }),
    flexBasis: (0, exports.responsive)({
        type: 'string',
    }),
    flexWrap: (0, exports.responsive)({
        type: 'string',
        enum: ['nowrap', 'wrap', 'wrap-reverse', 'initial', 'inherit'],
    }),
    alignItems: (0, exports.responsive)({
        type: 'string',
        enum: [
            'stretch',
            'center',
            'flex-start',
            'flex-end',
            'baseline',
            'initial',
            'inherit',
        ],
    }),
    alignSelf: (0, exports.responsive)({
        type: 'string',
        enum: [
            'auto',
            'stretch',
            'center',
            'flex-start',
            'flex-end',
            'baseline',
            'initial',
            'inherit',
        ],
    }),
    justifyContent: (0, exports.responsive)({
        type: 'string',
        enum: [
            'flex-start',
            'flex-end',
            'center',
            'space-between',
            'space-around',
            'initial',
            'inherit',
        ],
    }),
    justifySelf: (0, exports.responsive)({
        type: 'string',
        enum: [
            'auto',
            'normal',
            'stretch',
            'center',
            'start',
            'end',
            'flex-start',
            'flex-end',
            'self-start',
            'self-end',
            'left',
            'right',
            'baseline',
            'initial',
            'inherit',
            'unset',
        ],
    }),
};
exports.WidgetWrapperUiOptions = __assign(__assign({}, exports.SpaceUiOptions), exports.FlexUiOptions);
