"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectOptions = exports.Invalid = exports.Emphasized = exports.WithCustomOption = exports.WithPlaceholder = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var __1 = require("../../");
var _1 = require(".");
exports.default = {
    title: 'Core/Select',
    component: _1.Select,
};
var Template = (0, utils_1.createTemplate)(_1.Select);
exports.Default = (0, utils_1.createStory)(Template, {
    options: ['Option 1', 'Option 2', 'Option 3'],
});
exports.WithPlaceholder = (0, utils_1.createStory)(Template, {
    options: ['Option 1', 'Option 2', 'Option 3'],
    placeholder: 'Select one...',
});
exports.WithCustomOption = (0, utils_1.createStory)(Template, {
    value: 'Option 1',
    options: ['Option 1', 'Option 2', 'Option 3'],
    children: function (option) { return react_1.default.createElement(__1.Badge, { m: 1 }, option); },
});
exports.Emphasized = (0, utils_1.createStory)(Template, {
    value: 'Option 1',
    options: ['Option 1', 'Option 2', 'Option 3'],
    emphasized: true,
});
exports.Invalid = (0, utils_1.createStory)(Template, {
    value: 'Option 1',
    options: ['Option 1', 'Option 2', 'Option 3'],
    invalid: true,
});
exports.ObjectOptions = (0, utils_1.createStory)(Template, {
    options: [
        { title: 'Object 1', value: '1' },
        { title: 'Object 2', value: '2' },
        { title: 'Object 3', value: '3' },
    ],
    labelKey: 'title',
    valueKey: 'value',
    value: { title: 'Object 1', value: '1' },
});
