import { SelectProps as GrommetSelectProps } from 'grommet';
import * as React from 'react';
import { Omit, RenditionSystemProps } from '../../common-types';
type AdjustedGrommetSelectProps = Omit<GrommetSelectProps, 'onChange' | 'children'>;
interface InternalSelectProps<T> extends AdjustedGrommetSelectProps, Omit<React.HTMLAttributes<HTMLElement>, 'defaultValue' | 'onChange' | 'children' | 'placeholder' | 'color'> {
    emphasized?: boolean;
    invalid?: boolean;
    onChange: (data: {
        option: T;
        selected: number;
        target: React.ChangeEvent<HTMLElement>;
        value: T;
    }) => void;
    children?: (option: T, index: number, options: T[], state: {
        active: boolean;
        disabled: boolean;
        selected: boolean;
    }) => void;
}
export interface SelectProps<T> extends Omit<InternalSelectProps<T>, 'size' | 'selected' | 'focusIndicator' | 'margin'>, RenditionSystemProps {
}
type SelectType = <T extends {}>(props: SelectProps<T>) => JSX.Element;
export declare const Select: SelectType;
export {};
