"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var enzyme_1 = require("enzyme");
var noop_1 = __importDefault(require("lodash/noop"));
var sinon_1 = __importDefault(require("sinon"));
var react_1 = __importDefault(require("react"));
var __1 = require("../../");
describe('Select component', function () {
    describe('value property', function () {
        it('should set the value of the select element', function () {
            var component = (0, enzyme_1.mount)(react_1.default.createElement(__1.Provider, null,
                react_1.default.createElement(__1.Select, { value: 'Option 1', onChange: noop_1.default, options: ['Option 1', 'Option 2', 'Option 3'] })));
            expect(component.find('input[value="Option 1"]')).toHaveLength(1);
        });
    });
    describe('onChange property', function () {
        it('should set be called when the select element value is changed', function () {
            var value = 'Option 2';
            var spy = sinon_1.default.spy();
            var component = (0, enzyme_1.mount)(react_1.default.createElement(__1.Provider, null,
                react_1.default.createElement(__1.Select, { onChange: spy, options: ['Option 1', 'Option 2', 'Option 3'] })));
            component.find('button').at(0).simulate('click');
            component.find('button').at(2).simulate('click');
            expect(spy.callCount).toEqual(1);
            expect(spy.firstCall.args[0].option).toEqual(value);
        });
    });
});
