"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithAdditionalComponents = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var Flex_1 = require("../Flex");
var Txt_1 = require("../Txt");
var menuItems = [
    {
        title: 'MenuItem 1',
        href: 'menuitem1',
        component: react_1.default.createElement(react_1.default.Fragment, null, "Menu item 1"),
    },
    {
        title: 'MenuItem 2',
        href: 'menuitem2',
        component: react_1.default.createElement(react_1.default.Fragment, null, "Menu item 2"),
    },
    {
        title: 'MenuItem 3',
        href: 'menuitem3',
        component: react_1.default.createElement(react_1.default.Fragment, null, "Menu item 3"),
    },
];
var SidebarDemo = function (props) {
    return (react_1.default.createElement(Flex_1.Flex, { width: "90vw", height: "90vh" },
        react_1.default.createElement(_1.Sidebar, __assign({}, props, { width: 300, height: "100%" })),
        react_1.default.createElement(Flex_1.Flex, null, menuItems.map(function (_item, index) { return (react_1.default.createElement("div", null,
            "Page - ",
            index)); }))));
};
exports.default = {
    title: 'Core/Sidebar',
    component: _1.Sidebar,
};
var Template = (0, utils_1.createTemplate)(SidebarDemo);
exports.Default = (0, utils_1.createStory)(Template, {
    crumbs: [
        {
            text: 'MenuItem 1',
            href: 'menuitem1',
        },
        {
            text: 'Summary',
        },
    ],
    menuItems: menuItems,
    showBreadcrumbs: true,
});
exports.WithAdditionalComponents = (0, utils_1.createStory)(Template, {
    crumbs: [
        {
            text: 'MenuItem 1',
            href: 'menuitem1',
        },
        {
            text: 'Summary',
        },
    ],
    menuItems: menuItems,
    showBreadcrumbs: true,
    additionalComponents: react_1.default.createElement(Txt_1.Txt, { color: "white" }, "Another component can go here"),
});
