"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sidebar = void 0;
var React = __importStar(require("react"));
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var Flex_1 = require("../Flex");
var Breadcrumbs_1 = require("../Breadcrumbs");
var Button_1 = require("../Button");
var faChevronLeft_1 = require("@fortawesome/free-solid-svg-icons/faChevronLeft");
var faChevronRight_1 = require("@fortawesome/free-solid-svg-icons/faChevronRight");
var Menu_1 = require("./Menu");
var ChangelogButton_1 = require("../Changelog/ChangelogButton");
var Sidebar = function (_a) {
    var menuItems = _a.menuItems, crumbs = _a.crumbs, _b = _a.showBreadcrumbs, showBreadcrumbs = _b === void 0 ? true : _b, _c = _a.isCollapsed, isCollapsed = _c === void 0 ? false : _c, additionalComponents = _a.additionalComponents, setIsCollapsed = _a.setIsCollapsed, navLink = _a.navLink, getChangelog = _a.getChangelog, onChangelogClick = _a.onChangelogClick, latestChangelogVersion = _a.latestChangelogVersion, props = __rest(_a, ["menuItems", "crumbs", "showBreadcrumbs", "isCollapsed", "additionalComponents", "setIsCollapsed", "navLink", "getChangelog", "onChangelogClick", "latestChangelogVersion"]);
    return (React.createElement(Flex_1.Flex, __assign({ flexDirection: "column", flexWrap: "nowrap", backgroundColor: "secondary.main" }, props),
        showBreadcrumbs && !!crumbs && (React.createElement(Flex_1.Flex, { pl: isCollapsed ? 15 : 24, pr: 1, mb: 3, mt: 20 },
            React.createElement(Breadcrumbs_1.Breadcrumbs, { crumbs: crumbs, isCollapsed: isCollapsed }))),
        React.createElement(Menu_1.Menu, { flex: "1", ml: !isCollapsed && showBreadcrumbs && !!crumbs ? 32 : 0, flexDirection: "column", style: { overflowX: 'auto' }, items: menuItems, isCollapsed: isCollapsed, navLink: navLink }),
        React.createElement(Flex_1.Flex, { justifyContent: "space-between", alignItems: "center", mb: 3, px: 2 },
            !isCollapsed && getChangelog && (React.createElement(ChangelogButton_1.ChangelogButton, { getChangelog: getChangelog, onClick: onChangelogClick, latestChangelogVersion: latestChangelogVersion })),
            additionalComponents,
            !!setIsCollapsed && isCollapsed != null && (React.createElement(Button_1.Button, { height: "38px", width: "38px", color: "text.light", icon: React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: isCollapsed ? faChevronRight_1.faChevronRight : faChevronLeft_1.faChevronLeft }), onClick: function () { return setIsCollapsed(!isCollapsed); }, style: {
                    background: 'rgba(0, 0, 0, 0.1)',
                    borderRadius: '2px',
                } })))));
};
exports.Sidebar = Sidebar;
