"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Ordered = exports.WithoutBorders = exports.WithCustomTitle = exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var faMapSigns_1 = require("@fortawesome/free-solid-svg-icons/faMapSigns");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var utils_1 = require("../../stories/utils");
var _1 = require(".");
exports.default = {
    title: 'Core/Steps',
    component: _1.Steps,
    subcomponents: { Step: _1.Step },
};
var Template = (0, utils_1.createTemplate)(_1.Steps);
exports.Default = (0, utils_1.createStory)(Template, {
    children: [
        react_1.default.createElement(_1.Step, { status: "completed" }, "These are"),
        react_1.default.createElement(_1.Step, { status: "completed" }, "all completed"),
        react_1.default.createElement(_1.Step, { status: "completed" }, "and not clickable"),
    ],
});
exports.WithCustomTitle = (0, utils_1.createStory)(Template, {
    titleIcon: react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faMapSigns_1.faMapSigns }),
    titleText: 'Beginners Guide',
    children: [
        react_1.default.createElement(_1.Step, { status: "completed" }, "These are"),
        react_1.default.createElement(_1.Step, { status: "completed" }, "all completed"),
        react_1.default.createElement(_1.Step, { status: "completed" }, "and not clickable"),
    ],
});
exports.WithoutBorders = (0, utils_1.createStory)(Template, {
    bordered: false,
    children: [
        react_1.default.createElement(_1.Step, { status: "completed", onClick: function () { return null; } }, "Doesn't have"),
        react_1.default.createElement(_1.Step, { status: "pending", onClick: function () { return null; } }, "Title or dismiss button"),
        react_1.default.createElement(_1.Step, { status: "none", onClick: function () { return null; } }, "That's it (no icon)"),
    ],
});
exports.Ordered = (0, utils_1.createStory)(Template, {
    ordered: true,
    activeStepIndex: 1,
    children: [
        react_1.default.createElement(_1.Step, { status: "completed" }, "These are"),
        react_1.default.createElement(_1.Step, { status: "pending" }, "all completed"),
        react_1.default.createElement(_1.Step, { status: "pending" }, "and not clickable"),
    ],
});
