"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var utils_1 = require("../../stories/utils");
var theme_1 = __importDefault(require("../../theme"));
var Flex_1 = require("../Flex");
var Heading_1 = require("../Heading");
var Txt_1 = require("../Txt");
exports.default = {
    title: 'Styles/Colors',
};
var getContrast = function (hexColor) {
    var r = parseInt(hexColor.substr(1, 2), 16);
    var g = parseInt(hexColor.substr(3, 2), 16);
    var b = parseInt(hexColor.substr(5, 2), 16);
    var colorSpace = (r * 299 + g * 587 + b * 114) / 1000;
    return colorSpace >= 128 ? 'black' : 'white';
};
var SwatchesComponent = function () {
    return (react_1.default.createElement(Flex_1.Flex, { flexWrap: "wrap" }, Object.entries(theme_1.default.colors).map(function (_a) {
        var key = _a[0], value = _a[1];
        return (react_1.default.createElement(Flex_1.Flex, { flexDirection: "column", mr: 5, mb: 3 },
            react_1.default.createElement(Heading_1.Heading.h4, { bold: true }, key),
            react_1.default.createElement(Flex_1.Flex, null, Object.entries(value).map(function (_a) {
                var colorKey = _a[0], colorValue = _a[1];
                return (react_1.default.createElement(Flex_1.Flex, { width: "100px", height: "100px", bg: colorValue, alignItems: "center", justifyContent: "center" },
                    react_1.default.createElement(Txt_1.Txt, { color: getContrast(colorValue) }, colorKey)));
            }))));
    })));
};
var Template = (0, utils_1.createTemplate)(SwatchesComponent);
exports.Default = (0, utils_1.createStory)(Template, {});
