"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SurroundingOverlay = exports.getBoundingContainerRect = void 0;
var react_1 = __importDefault(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var Layer = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: absolute;\n\tz-index: 20;\n\t", "\n"], ["\n\tposition: absolute;\n\tz-index: 20;\n\t", "\n"])), function (props) {
    var _a;
    return "\n\t\topacity: ".concat((_a = props.opacity) !== null && _a !== void 0 ? _a : 0.5, ";\n    background: ").concat(props.layerColor || 'white', ";\n    top: ").concat(props.top || 0, "px;\n    bottom: ").concat(props.bottom || 0, "px;\n    left: ").concat(props.left || 0, "px;\n    right: ").concat(props.right || 0, "px;\n    height: ").concat(props.height != null ? props.height + 'px' : 'auto', ";\n  ");
});
var getBoundingContainerRect = function (element) {
    var _a;
    if (!element) {
        return null;
    }
    var parent = (_a = element.offsetParent) !== null && _a !== void 0 ? _a : document.body;
    var top = element.offsetTop + parent.offsetTop;
    var left = element.offsetLeft + parent.offsetLeft;
    var height = element.clientHeight;
    return {
        top: top,
        bottom: top + height,
        left: left,
        right: left + element.clientWidth,
        height: height,
        width: element.clientWidth,
        x: top,
        y: left,
    };
};
exports.getBoundingContainerRect = getBoundingContainerRect;
var SurroundingOverlay = function (_a) {
    var _b, _c, _d, _e;
    var rect = _a.rect, layerColor = _a.layerColor, _f = _a.padding, padding = _f === void 0 ? 0 : _f, opacity = _a.opacity;
    if (!rect) {
        return null;
    }
    var top = (_b = rect.top) !== null && _b !== void 0 ? _b : 0;
    var left = (_c = rect.left) !== null && _c !== void 0 ? _c : 0;
    var height = (_d = rect.height) !== null && _d !== void 0 ? _d : 0;
    var width = (_e = rect.width) !== null && _e !== void 0 ? _e : 0;
    var topDistance = top + height + padding;
    var lateralLayersTop = Math.max(top - padding, 0);
    var lateralLayersRight = left + width + padding;
    var lateralLayersHeight = topDistance - lateralLayersTop;
    var layers = {
        topLayer: {
            height: lateralLayersTop,
        },
        bottomLayer: {
            top: topDistance,
        },
        rightLayer: {
            top: lateralLayersTop,
            left: lateralLayersRight,
            height: lateralLayersHeight,
        },
        leftLayer: {
            top: lateralLayersTop,
            right: lateralLayersRight,
            height: lateralLayersHeight,
        },
    };
    return (react_1.default.createElement(react_1.default.Fragment, null, Object.values(layers).map(function (layerProps, index) { return (react_1.default.createElement(Layer, __assign({ key: index }, layerProps, { layerColor: layerColor, opacity: opacity }))); })));
};
exports.SurroundingOverlay = SurroundingOverlay;
var templateObject_1;
