"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableBase = exports.DEFAULT_ITEMS_PER_PAGE = void 0;
var faSort_1 = require("@fortawesome/free-solid-svg-icons/faSort");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var isPlainObject_1 = __importDefault(require("lodash/isPlainObject"));
var sortBy_1 = __importDefault(require("lodash/sortBy"));
var memoizee_1 = __importDefault(require("memoizee"));
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var Button_1 = require("../Button");
var theme_1 = __importDefault(require("../../theme"));
var utils_1 = require("../../utils");
var Checkbox_1 = require("../Checkbox");
var Pager_1 = require("../Pager");
var TableRow_1 = require("./TableRow");
var highlightStyle = "\n\tbackground-color: ".concat(theme_1.default.colors.info.light, ";\n");
var BaseTableWrapper = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\toverflow-x: auto;\n\tmax-width: 100%;\n\tborder-bottom: 1px solid ", ";\n"], ["\n\toverflow-x: auto;\n\tmax-width: 100%;\n\tborder-bottom: 1px solid ", ";\n"])), function (props) { return props.theme.colors.quartenary.main; });
exports.DEFAULT_ITEMS_PER_PAGE = 50;
var Base = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tdisplay: table;\n\twidth: 100%;\n\tborder-spacing: 0;\n\n\t> [data-display='table-head'] {\n\t\tdisplay: table-header-group;\n\t\tbackground-color: ", ";\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\tborder-bottom: 1px solid\n\t\t\t\t\t", ";\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 5px 20px;\n\t\t\t\tfont-size: ", ";\n\t\t\t\tfont-weight: normal;\n\t\t\t\twhite-space: nowrap;\n\t\t\t}\n\n\t\t\t", ";\n\t\t}\n\t}\n\n\t> [data-display='table-body'] {\n\t\tdisplay: table-row-group;\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\t\t\ttext-decoration: none;\n\t\t\tcolor: ", ";\n\t\t\tbackground-color: #fff;\n\t\t\tfont-size: ", ";\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 5px 20px;\n\t\t\t\ttext-decoration: none;\n\t\t\t\tcolor: inherit;\n\t\t\t\twhite-space: nowrap;\n\t\t\t}\n\n\t\t\t", ";\n\n\t\t\t> a[data-display='table-cell'] {\n\t\t\t\tcursor: ", ";\n\t\t\t}\n\n\t\t\t&:nth-of-type(even) {\n\t\t\t\tbackground-color: ", ";\n\t\t\t}\n\n\t\t\t&:hover {\n\t\t\t\ttext-decoration: none;\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t&[data-highlight='true'] {\n\t\t\t\t", " > [data-display=\"table-cell\"]:first-child {\n\t\t\t\t\tbox-shadow: inset 3px 0px 0 ", ";\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n"], ["\n\tdisplay: table;\n\twidth: 100%;\n\tborder-spacing: 0;\n\n\t> [data-display='table-head'] {\n\t\tdisplay: table-header-group;\n\t\tbackground-color: ", ";\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\tborder-bottom: 1px solid\n\t\t\t\t\t", ";\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 5px 20px;\n\t\t\t\tfont-size: ", ";\n\t\t\t\tfont-weight: normal;\n\t\t\t\twhite-space: nowrap;\n\t\t\t}\n\n\t\t\t", ";\n\t\t}\n\t}\n\n\t> [data-display='table-body'] {\n\t\tdisplay: table-row-group;\n\n\t\t> [data-display='table-row'] {\n\t\t\tdisplay: table-row;\n\t\t\ttext-decoration: none;\n\t\t\tcolor: ", ";\n\t\t\tbackground-color: #fff;\n\t\t\tfont-size: ", ";\n\n\t\t\t> [data-display='table-cell'] {\n\t\t\t\tdisplay: table-cell;\n\t\t\t\ttext-align: left;\n\t\t\t\tvertical-align: middle;\n\t\t\t\tpadding: 5px 20px;\n\t\t\t\ttext-decoration: none;\n\t\t\t\tcolor: inherit;\n\t\t\t\twhite-space: nowrap;\n\t\t\t}\n\n\t\t\t", ";\n\n\t\t\t> a[data-display='table-cell'] {\n\t\t\t\tcursor: ", ";\n\t\t\t}\n\n\t\t\t&:nth-of-type(even) {\n\t\t\t\tbackground-color: ", ";\n\t\t\t}\n\n\t\t\t&:hover {\n\t\t\t\ttext-decoration: none;\n\t\t\t\t", ";\n\t\t\t}\n\n\t\t\t&[data-highlight='true'] {\n\t\t\t\t", " > [data-display=\"table-cell\"]:first-child {\n\t\t\t\t\tbox-shadow: inset 3px 0px 0 ", ";\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n"])), function (props) { return props.theme.colors.quartenary.semilight; }, function (props) { return props.theme.colors.quartenary.main; }, function (props) { return (0, utils_1.px)(props.theme.fontSizes[2]); }, function (props) {
    return props.hasCheckbox
        ? "\n\t\t\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\t\t\twidth: 60px;\n\t\t\t\t\t}"
        : "\n\t\t\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\t\t\tpadding-left: 40px;\n\t\t\t\t\t}\n\t\t\t\t\t> [data-display='table-cell']:last-child {\n\t\t\t\t\t\tpadding-right: 40px;\n\t\t\t\t\t}";
}, function (props) { return props.theme.colors.secondary.main; }, function (props) { return (0, utils_1.px)(props.theme.fontSizes[2]); }, function (props) {
    return props.hasCheckbox
        ? "\n\t\t\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\t\t\twidth: 60px;\n\t\t\t\t\t}"
        : "\n\t\t\t\t\t> [data-display='table-cell']:first-child {\n\t\t\t\t\t\tpadding-left: 40px;\n\t\t\t\t\t}\n\t\t\t\t\t> [data-display='table-cell']:last-child {\n\t\t\t\t\t\tpadding-right: 40px;\n\t\t\t\t\t}";
}, function (props) {
    return props.hasRowClick || props.hasGetRowRef ? 'pointer' : 'auto';
}, function (props) { return props.theme.colors.quartenary.light; }, function (props) {
    return props.hasRowClick || props.hasGetRowRef || props.hasCheckbox
        ? highlightStyle
        : '';
}, highlightStyle, function (props) { return props.theme.colors.info.main; });
var TableBase = (function (_super) {
    __extends(TableBase, _super);
    function TableBase(props) {
        var _this = this;
        var _a;
        _this = _super.call(this, props) || this;
        _this.$getSelectedIdentifiersSet = (0, memoizee_1.default)(function (selectedRows, rowKey) {
            if (!rowKey) {
                return new Set();
            }
            return new Set((selectedRows !== null && selectedRows !== void 0 ? selectedRows : []).map(function (x) { return x[rowKey]; }));
        }, { max: 1 });
        _this.$getHighlightedRowIdentifiers = (0, memoizee_1.default)(function (highlightedRows) {
            return new Set(highlightedRows);
        }, { max: 1 });
        _this.$getDisabledRowIdentifiers = (0, memoizee_1.default)(function (disabledRows) {
            return new Set(disabledRows);
        }, { max: 1 });
        _this.$getValidatedCheckedItems = (0, memoizee_1.default)(function (data, selectedKeys, rowKey, checkedItems) {
            var newCheckedItems = !data || !rowKey || selectedKeys.size === 0
                ? []
                : data.filter(function (x) { return selectedKeys.has(x[rowKey]); });
            for (var i = 0; i < Math.max(checkedItems.length, newCheckedItems.length); i++) {
                if (checkedItems[i] !== newCheckedItems[i]) {
                    return newCheckedItems;
                }
            }
            return checkedItems;
        }, { max: 1 });
        _this.getSelectedRows = function (selectedRows) {
            var _a = _this.props, rowKey = _a.rowKey, data = _a.data, pagination = _a.pagination;
            var checkedItems;
            if (!(pagination === null || pagination === void 0 ? void 0 : pagination.serverSide)) {
                var selectedKeys = _this.$getSelectedIdentifiersSet(selectedRows, rowKey);
                checkedItems = _this.$getValidatedCheckedItems(data, selectedKeys, rowKey, selectedRows);
            }
            else {
                checkedItems = selectedRows;
            }
            var checkedState = _this.howManyRowsChecked(checkedItems);
            return { checkedItems: checkedItems, checkedState: checkedState };
        };
        _this.setRowSelection = function (selectedRows) {
            var newState = _this.getSelectedRows(selectedRows);
            var hasCheckedItemsChanged = newState.checkedItems !== _this.state.checkedItems;
            _this.setState(newState);
            if (_this.props.onCheck && hasCheckedItemsChanged) {
                _this.props.onCheck(newState.checkedItems, _this.state.checkedState);
            }
        };
        _this.toggleCheckedState = function (checkedState) {
            return checkedState === 'none' ? 'all' : 'none';
        };
        _this.toggleAllChecked = function () {
            var _a;
            var _b = _this.props, data = _b.data, onCheck = _b.onCheck, rowKey = _b.rowKey, pagination = _b.pagination;
            var checkedItems = !(pagination === null || pagination === void 0 ? void 0 : pagination.serverSide)
                ? []
                : undefined;
            if (data &&
                ((_a = _this.state.checkedItems) === null || _a === void 0 ? void 0 : _a.length) === 0 &&
                !(pagination === null || pagination === void 0 ? void 0 : pagination.serverSide)) {
                var disabledRowsSet_1 = _this.getDisabledRowIdentifiers();
                checkedItems =
                    rowKey && disabledRowsSet_1.size > 0
                        ? data.filter(function (r) { return !disabledRowsSet_1.has(r[rowKey]); })
                        : data.slice();
            }
            _this.setState(function (_a) {
                var checkedState = _a.checkedState;
                var newCheckedState = (pagination === null || pagination === void 0 ? void 0 : pagination.serverSide)
                    ? _this.toggleCheckedState(checkedState)
                    : _this.howManyRowsChecked(checkedItems);
                onCheck === null || onCheck === void 0 ? void 0 : onCheck(checkedItems, newCheckedState);
                return {
                    lastSelected: null,
                    checkedState: newCheckedState,
                    checkedItems: checkedItems,
                };
            });
        };
        _this.toggleChecked = function (e) {
            var _a;
            var _b = _this.props, rowKey = _b.rowKey, data = _b.data, pagination = _b.pagination;
            var key = e.currentTarget.dataset.key;
            if (!rowKey || !key || !data) {
                return false;
            }
            var sortedData = _this.sortData(data);
            var item = _this.getElementFromKey(key);
            if (!item) {
                return;
            }
            var identifier = item[rowKey];
            var newIsChecked;
            var storedCheckedItems = (_a = (_this.props.checkedItems || _this.state.checkedItems)) !== null && _a !== void 0 ? _a : [];
            if ((pagination === null || pagination === void 0 ? void 0 : pagination.serverSide) && _this.state.checkedState === 'all') {
                storedCheckedItems = sortedData;
                newIsChecked = false;
            }
            else {
                newIsChecked = !_this.getCheckedRowIdentifiers().has(identifier);
            }
            var checkedItemsMap = new Map(storedCheckedItems.map(function (item) { return [item[rowKey], item]; }));
            var keysToFind = [identifier];
            if (_this.state.lastSelected != null &&
                e.nativeEvent.shiftKey) {
                keysToFind.push(_this.state.lastSelected);
            }
            var _loop_1 = function (index) {
                var foundKey = false;
                var currentItemKey = sortedData[index][rowKey];
                if (keysToFind.includes(currentItemKey)) {
                    keysToFind = keysToFind.filter(function (keyToFind) { return keyToFind !== currentItemKey; });
                    foundKey = true;
                }
                if (foundKey ||
                    (e.nativeEvent.shiftKey &&
                        keysToFind.length === 1 &&
                        _this.state.lastSelected != null)) {
                    var itemIsChecked = checkedItemsMap.has(currentItemKey);
                    if (newIsChecked && !itemIsChecked) {
                        checkedItemsMap.set(currentItemKey, sortedData[index]);
                    }
                    else if (!newIsChecked && itemIsChecked) {
                        checkedItemsMap.delete(currentItemKey);
                    }
                }
            };
            for (var index = 0; index < sortedData.length && !!keysToFind.length; index++) {
                _loop_1(index);
            }
            var checkedItems = Array.from(checkedItemsMap.values());
            if (_this.props.onCheck) {
                _this.props.onCheck(checkedItems, _this.state.checkedState);
            }
            _this.setState({
                lastSelected: identifier,
                checkedState: _this.howManyRowsChecked(checkedItems),
                checkedItems: checkedItems,
            });
        };
        _this.toggleSort = function (e) {
            var _a = e.currentTarget.dataset, field = _a.field, refScheme = _a.refScheme;
            var sort = _this.state.sort;
            if (!field) {
                return;
            }
            var nextSort = {
                field: field,
                refScheme: refScheme,
                reverse: false,
            };
            if (sort.field === field) {
                nextSort = { field: sort.field, refScheme: refScheme, reverse: !sort.reverse };
            }
            _this.setState({ sort: nextSort });
            if (_this.props.onSort) {
                _this.props.onSort(nextSort);
            }
        };
        _this.onRowClick = function (e) {
            if (!_this.props.onRowClick) {
                return;
            }
            if (!_this.props.rowKey) {
                return console.warn('onRowClick requires that you provide a `rowKey` property');
            }
            var key = e.currentTarget.dataset.key;
            if (!key) {
                return console.warn('onRowClick called on an element without a key set');
            }
            var row = _this.getElementFromKey(key);
            if (row) {
                _this.props.onRowClick(row, e);
            }
        };
        _this.setPage = function (change) {
            var _a, _b, _c;
            var pagination = _this.props.pagination;
            var itemsPerPage = (_a = _this.props.itemsPerPage) !== null && _a !== void 0 ? _a : pagination === null || pagination === void 0 ? void 0 : pagination.itemsPerPage;
            (_c = (_b = _this.props).onPageChange) === null || _c === void 0 ? void 0 : _c.call(_b, change, itemsPerPage !== null && itemsPerPage !== void 0 ? itemsPerPage : exports.DEFAULT_ITEMS_PER_PAGE);
            _this.setState({ page: change });
        };
        _this.resetPager = function () {
            _this.setPage(0);
        };
        _this.incrementPage = function () {
            _this.setPage(_this.state.page + 1);
        };
        _this.decrementPage = function () {
            _this.setPage(_this.state.page - 1);
        };
        if (props.onCheck && !props.rowKey) {
            throw new Error('A `rowKey` property must be provided if using `onCheck` with a Table component');
        }
        var sortState = props.sort || {
            reverse: false,
            field: null,
        };
        _this.state = __assign({ sort: sortState, page: 0, lastSelected: null }, _this.getSelectedRows((_a = props.checkedItems) !== null && _a !== void 0 ? _a : []));
        return _this;
    }
    TableBase.prototype.componentDidUpdate = function (prevProps) {
        var _a, _b;
        var _c = this.props, sort = _c.sort, checkedItems = _c.checkedItems, data = _c.data, pagination = _c.pagination, rowKey = _c.rowKey;
        var serverSide = pagination === null || pagination === void 0 ? void 0 : pagination.serverSide;
        if (sort && !(0, isEqual_1.default)(prevProps.sort, sort)) {
            this.setState({
                sort: sort,
            });
        }
        if (checkedItems &&
            (prevProps.checkedItems !== checkedItems ||
                prevProps.rowKey !== rowKey ||
                data !== prevProps.data)) {
            this.setRowSelection(checkedItems);
        }
        var totalItems = serverSide ? pagination === null || pagination === void 0 ? void 0 : pagination.totalItems : (_a = data === null || data === void 0 ? void 0 : data.length) !== null && _a !== void 0 ? _a : 0;
        var currentPage = serverSide ? pagination === null || pagination === void 0 ? void 0 : pagination.currentPage : this.state.page;
        var itemsPerPage = (_b = this.props.itemsPerPage) !== null && _b !== void 0 ? _b : pagination === null || pagination === void 0 ? void 0 : pagination.itemsPerPage;
        if (currentPage !== 0 &&
            totalItems <= currentPage * (itemsPerPage !== null && itemsPerPage !== void 0 ? itemsPerPage : exports.DEFAULT_ITEMS_PER_PAGE)) {
            this.resetPager();
        }
    };
    TableBase.prototype.getCheckedRowIdentifiers = function () {
        var rowKey = this.props.rowKey;
        if (!rowKey) {
            return new Set();
        }
        return this.$getSelectedIdentifiersSet(this.state.checkedItems, rowKey);
    };
    TableBase.prototype.isChecked = function (item) {
        return (this.props.rowKey &&
            this.getCheckedRowIdentifiers().has(item[this.props.rowKey]));
    };
    TableBase.prototype.getHighlightedRowIdentifiers = function () {
        if (!this.props.highlightedRows || !this.props.rowKey) {
            return new Set();
        }
        return this.$getHighlightedRowIdentifiers(this.props.highlightedRows);
    };
    TableBase.prototype.isHighlighted = function (item) {
        return (this.props.rowKey &&
            this.getHighlightedRowIdentifiers().has(item[this.props.rowKey]));
    };
    TableBase.prototype.getDisabledRowIdentifiers = function () {
        if (!this.props.disabledRows || !this.props.rowKey) {
            return new Set();
        }
        return this.$getDisabledRowIdentifiers(this.props.disabledRows);
    };
    TableBase.prototype.isDisabled = function (item) {
        return (this.props.rowKey &&
            this.getDisabledRowIdentifiers().has(item[this.props.rowKey]));
    };
    TableBase.prototype.componentWillUnmount = function () {
        this.$getHighlightedRowIdentifiers.clear();
        this.$getDisabledRowIdentifiers.clear();
        this.$getSelectedIdentifiersSet.clear();
        this.$getValidatedCheckedItems.clear();
    };
    TableBase.prototype.howManyRowsChecked = function (checkedItems) {
        var _a = this.props, rowKey = _a.rowKey, data = _a.data, pagination = _a.pagination;
        if (!rowKey || !data) {
            return 'none';
        }
        return ((pagination === null || pagination === void 0 ? void 0 : pagination.serverSide) &&
            checkedItems.length === pagination.totalItems) ||
            (!(pagination === null || pagination === void 0 ? void 0 : pagination.serverSide) && data.length === checkedItems.length)
            ? 'all'
            : checkedItems.length > 0
                ? 'some'
                : 'none';
    };
    TableBase.prototype.sortData = function (data) {
        var sort = this.state.sort;
        if (!sort || sort.field === null) {
            return data;
        }
        var column = this.props.columns.find(function (c) { return c.field === sort.field; });
        if (!column) {
            return data;
        }
        var collection;
        var columnAny = column || {};
        if ('sortable' in columnAny && typeof columnAny.sortable === 'function') {
            collection = data.slice().sort(columnAny.sortable);
        }
        else {
            collection = (0, sortBy_1.default)(data.slice(), function (item) {
                var sortableValue = item[sort.field];
                return (0, isPlainObject_1.default)(sortableValue)
                    ? sortableValue.value
                    : sortableValue;
            });
        }
        if (sort.reverse) {
            collection.reverse();
        }
        return collection;
    };
    TableBase.prototype.getElementFromKey = function (key) {
        var _a = this.props, data = _a.data, rowKey = _a.rowKey;
        if (!data) {
            return;
        }
        if (rowKey) {
            return data.find(function (element) { return "".concat(element[rowKey]) === key; });
        }
        return data[Number(key)];
    };
    TableBase.prototype.render = function () {
        var _this = this;
        var _a, _b, _c;
        var _d = this.props, columns = _d.columns, data = _d.data, usePager = _d.usePager, pagerPosition = _d.pagerPosition, rowAnchorAttributes = _d.rowAnchorAttributes, rowKey = _d.rowKey, onCheck = _d.onCheck, onRowClick = _d.onRowClick, getRowHref = _d.getRowHref, getRowClass = _d.getRowClass, className = _d.className, fuzzyPager = _d.fuzzyPager, pagination = _d.pagination;
        var _e = this.state, page = _e.page, sort = _e.sort;
        var serverSide = pagination === null || pagination === void 0 ? void 0 : pagination.serverSide;
        var items = data || [];
        var totalItems = serverSide ? pagination === null || pagination === void 0 ? void 0 : pagination.totalItems : items.length;
        var itemsPerPage = (_b = (_a = this.props.itemsPerPage) !== null && _a !== void 0 ? _a : pagination === null || pagination === void 0 ? void 0 : pagination.itemsPerPage) !== null && _b !== void 0 ? _b : exports.DEFAULT_ITEMS_PER_PAGE;
        var _pagerPosition = pagerPosition || 'top';
        var sortedData = items;
        if (!serverSide) {
            var lowerBound = page * itemsPerPage;
            var upperBound = Math.min((page + 1) * itemsPerPage, items.length);
            sortedData = this.sortData(items).slice(lowerBound, upperBound);
        }
        var shouldShowPager = !!usePager && totalItems > 0;
        var checkedRowIdentifiers = this.getCheckedRowIdentifiers();
        var highlightedRowIdentifiers = this.getHighlightedRowIdentifiers();
        var disabledRowIdentifiers = this.getDisabledRowIdentifiers();
        var selectedItemCount = this.state.checkedState === 'all'
            ? totalItems
            : (_c = this.state.checkedItems) === null || _c === void 0 ? void 0 : _c.length;
        return (React.createElement(React.Fragment, null,
            shouldShowPager &&
                (_pagerPosition === 'top' || _pagerPosition === 'both') && (React.createElement(Pager_1.Pager, { fuzzy: fuzzyPager, totalItems: totalItems, itemsPerPage: itemsPerPage, page: serverSide ? pagination === null || pagination === void 0 ? void 0 : pagination.currentPage : page, nextPage: this.incrementPage, prevPage: this.decrementPage, mb: 2 })),
            React.createElement(BaseTableWrapper, null,
                React.createElement(Base, { className: className, hasRowClick: !!onRowClick, hasGetRowRef: !!getRowHref, hasCheckbox: !!onCheck },
                    React.createElement("div", { "data-display": "table-head" },
                        React.createElement("div", { "data-display": "table-row" },
                            onCheck && (React.createElement(TableRow_1.CheckboxWrapper, { "data-display": "table-cell", tooltip: selectedItemCount != null
                                    ? "Selected: ".concat(selectedItemCount)
                                    : undefined },
                                React.createElement(Checkbox_1.Checkbox, { checked: this.state.checkedState === 'all', indeterminate: this.state.checkedState === 'some', onChange: this.toggleAllChecked }))),
                            columns.map(function (item) {
                                if (item.sortable) {
                                    return (React.createElement("div", { "data-display": "table-cell", key: item.key || item.field },
                                        React.createElement(Button_1.Button, { "data-field": item.field, "data-ref-scheme": item.refScheme, plain: true, primary: sort.field === item.field, onClick: _this.toggleSort },
                                            item.label || item.field,
                                            "\u00A0",
                                            React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faSort_1.faSort, color: sort.field === item.field
                                                    ? theme_1.default.colors.info.main
                                                    : '' }))));
                                }
                                return (React.createElement("div", { "data-display": "table-cell", key: item.key || item.field }, item.label || item.field));
                            }))),
                    React.createElement("div", { "data-display": "table-body" },
                        this.props.tbodyPrefix,
                        sortedData.map(function (row, i) {
                            var isChecked = false;
                            var isHighlighted = false;
                            var isDisabled = false;
                            if (rowKey) {
                                var identifier = row[rowKey];
                                isChecked =
                                    _this.state.checkedState === 'all' ||
                                        (!!onCheck && checkedRowIdentifiers.has(identifier));
                                isHighlighted = highlightedRowIdentifiers.has(identifier);
                                isDisabled = disabledRowIdentifiers.has(identifier);
                            }
                            var key = rowKey ? row[rowKey] : i;
                            var href = !!getRowHref ? getRowHref(row) : undefined;
                            var classNamesList = typeof getRowClass === 'function' ? getRowClass(row) : [];
                            var className = Array.isArray(classNamesList)
                                ? classNamesList.join(' ')
                                : '';
                            return (React.createElement(TableRow_1.TableRow, { isChecked: isChecked, isHighlighted: isHighlighted, isDisabled: isDisabled, key: key, keyAttribute: key, href: href, data: row, showCheck: !!onCheck, columns: columns, attributes: rowAnchorAttributes, checkboxAttributes: _this.props.rowCheckboxAttributes, toggleChecked: _this.toggleChecked, onRowClick: _this.onRowClick, className: className }));
                        })))),
            shouldShowPager &&
                (_pagerPosition === 'bottom' || _pagerPosition === 'both') && (React.createElement(Pager_1.Pager, { fuzzy: fuzzyPager, totalItems: totalItems, itemsPerPage: itemsPerPage, page: page, nextPage: this.incrementPage, prevPage: this.decrementPage, mt: 2 }))));
    };
    return TableBase;
}(React.Component));
exports.TableBase = TableBase;
var templateObject_1, templateObject_2;
