"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableColumnSelector = exports.getNewTagTableColumnState = exports.TableColumnStateStoredProps = void 0;
var faCog_1 = require("@fortawesome/free-solid-svg-icons/faCog");
var faCheck_1 = require("@fortawesome/free-solid-svg-icons/faCheck");
var faPlus_1 = require("@fortawesome/free-solid-svg-icons/faPlus");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var clone_1 = __importDefault(require("lodash/clone"));
var reduce_1 = __importDefault(require("lodash/reduce"));
var without_1 = __importDefault(require("lodash/without"));
var DropDownButton_1 = require("../DropDownButton");
var Flex_1 = require("../Flex");
var utils_1 = require("../../utils");
var theme_1 = __importDefault(require("../../theme"));
var Txt_1 = require("../Txt");
var SmallFontAwesomeIcon = (0, styled_components_1.default)(react_fontawesome_1.FontAwesomeIcon)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t& {\n\t\tfont-size: inherit !important;\n\t}\n"], ["\n\t& {\n\t\tfont-size: inherit !important;\n\t}\n"])));
var ItemIcon = styled_components_1.default.span(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tdisplay: flex;\n\theight: 14px;\n\twidth: 14px;\n\tmargin-right: ", "px;\n\tfont-size: 13px;\n\n\t& svg {\n\t\ttransform: translateY(-1px);\n\t}\n"], ["\n\tdisplay: flex;\n\theight: 14px;\n\twidth: 14px;\n\tmargin-right: ", "px;\n\tfont-size: 13px;\n\n\t& svg {\n\t\ttransform: translateY(-1px);\n\t}\n"])), function (props) { return props.theme.space[2]; });
exports.TableColumnStateStoredProps = ['key', 'selected', 'type', 'tagKey'];
var getNewTagTableColumnState = function (tagKey) {
    if (tagKey) {
        return {
            title: tagKey,
            key: "tag_key: ".concat(tagKey),
            selected: true,
            type: 'tag',
            tagKey: tagKey,
        };
    }
    return {
        title: '',
        key: 'tag_key: Not Set',
        selected: true,
        type: 'tag',
        tagKey: undefined,
    };
};
exports.getNewTagTableColumnState = getNewTagTableColumnState;
var TableColumnSelector = function (props) {
    var columns = props.columns, tagKeys = props.tagKeys, addTagColumn = props.addTagColumn, setColumns = props.setColumns;
    var toggleSelectedColumn = function (column) {
        var columnIndex = columns.indexOf(column);
        if (columnIndex < 0) {
            return;
        }
        var columnsCopy = columns.slice();
        column = (0, clone_1.default)(column);
        column.selected = !column.selected;
        var shouldRemoveColumn = column.type === 'tag' && !column.selected;
        if (shouldRemoveColumn) {
            columnsCopy.splice(columnIndex, 1);
        }
        else {
            columnsCopy.splice(columnIndex, 1, column);
        }
        setColumns(columnsCopy);
    };
    var existingTagColumnKeys = (0, reduce_1.default)(columns, function (acc, c) {
        if (c.type === 'tag' && c.tagKey) {
            acc.push(c.tagKey);
        }
        return acc;
    }, []);
    var canAddColumnRules = [
        {
            test: function () { return !(tagKeys || []).length; },
            message: 'No tags available.',
        },
        {
            test: function () { return existingTagColumnKeys.includes(undefined); },
            message: 'Unconfigured tag column already exists',
        },
        {
            test: function () { return !without_1.default.apply(void 0, __spreadArray([tagKeys || []], existingTagColumnKeys, false)).length; },
            message: 'All tags used',
        },
    ];
    var failedAddColumnRule = canAddColumnRules.find(function (rule) { return rule.test(); });
    var canAddTagColumn = !failedAddColumnRule;
    var addTagColumnTitle = failedAddColumnRule && failedAddColumnRule.message;
    var memoizedItems = React.useMemo(function () {
        var items = [
            columns
                .filter(function (col) { return !col.locked; })
                .map(function (col) { return ({
                content: (React.createElement(Flex_1.Flex, { key: col.key, alignItems: "center", color: !col.selected ? theme_1.default.colors.text.light : undefined },
                    React.createElement(ItemIcon, null, col.selected ? React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faCheck_1.faCheck }) : null),
                    col.type !== 'tag' ? (col.title) : (React.createElement(Txt_1.Txt, null,
                        "Tag : ",
                        col.title ? React.createElement("strong", null, col.title) : 'Not set')))),
                onClick: function (e) {
                    toggleSelectedColumn(col);
                    (0, utils_1.stopEvent)(e);
                },
            }); }),
        ];
        if (tagKeys) {
            items.push([
                {
                    content: (React.createElement(Flex_1.Flex, { alignItems: "center" },
                        React.createElement(ItemIcon, null,
                            React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faPlus_1.faPlus })), addTagColumnTitle !== null && addTagColumnTitle !== void 0 ? addTagColumnTitle : 'Add Tag Column')),
                    onClick: function () { return canAddTagColumn && addTagColumn(); },
                    disabled: !canAddTagColumn,
                },
            ]);
        }
        return items;
    }, [columns, tagKeys, addTagColumn]);
    return (React.createElement(DropDownButton_1.DropDownButton, { joined: true, alignRight: true, primary: true, plain: true, label: React.createElement(SmallFontAwesomeIcon, { icon: faCog_1.faCog }), items: memoizedItems, keepOpenOnItemClick: true }));
};
exports.TableColumnSelector = TableColumnSelector;
var templateObject_1, templateObject_2;
