import * as React from 'react';
import { CheckboxProps } from '../Checkbox';
export declare const CheckboxWrapper: import("styled-components").StyledComponent<React.ForwardRefExoticComponent<import("../Box").BoxProps & React.RefAttributes<HTMLDivElement>>, any, {}, never>;
export type TableSortFunction<T> = (a: T, b: T) => number;
export interface TableBaseColumn<T> {
    cellAttributes?: React.AnchorHTMLAttributes<HTMLAnchorElement> | ((value: any, row: T) => React.AnchorHTMLAttributes<HTMLAnchorElement>);
    field: Extract<keyof T, string>;
    key?: string;
    icon?: string;
    label?: string | JSX.Element;
    render?: (value: any, row: T) => string | number | JSX.Element | null | undefined;
    sortable?: boolean | TableSortFunction<T>;
    refScheme?: string;
}
export interface TableRowProps<T> {
    className?: string;
    isChecked: boolean;
    isHighlighted: boolean;
    isDisabled: boolean;
    keyAttribute: string | number;
    onRowClick: (e: any) => void;
    toggleChecked: (e: any) => void;
    showCheck: boolean;
    columns: Array<TableBaseColumn<T>>;
    href?: string;
    data: T;
    attributes?: React.AnchorHTMLAttributes<HTMLAnchorElement>;
    checkboxAttributes?: CheckboxProps;
}
export declare class TableRow<T> extends React.PureComponent<TableRowProps<T>, {}> {
    render(): React.JSX.Element;
}
