"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Default = void 0;
var react_1 = __importDefault(require("react"));
var useTranslation_1 = require("../../hooks/useTranslation");
var _1 = require(".");
var utils_1 = require("../../stories/utils");
var Button_1 = require("../Button");
var items = [
    {
        id: 1,
        name: 'item-with-tag-1',
        tag_field: [
            {
                tag_key: 'tag1-key',
                value: 'tag-value',
            },
            {
                tag_key: 'tag2-key',
                value: 'tag3-value',
            },
            {
                tag_key: 'tag3-key',
                value: 'tag3-value',
            },
        ],
    },
    {
        id: 2,
        name: 'item-with-tag-2',
        tag_field: [
            {
                tag_key: 'tag1-key',
                value: 'tag-value',
            },
            {
                tag_key: 'tag2-key',
                value: 'tag3-value',
            },
        ],
    },
];
var TagManagement = function (props) {
    var _a = react_1.default.useState(false), isModalOpen = _a[0], setIsModalOpen = _a[1];
    var t = (0, useTranslation_1.useTranslation)().t;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Button_1.Button, { onClick: function () { return setIsModalOpen(true); }, primary: true }, t('labels.tags')),
        isModalOpen && (react_1.default.createElement(_1.TagManagementModal, __assign({}, props, { cancel: function () { return setIsModalOpen(false); }, done: function () { return setIsModalOpen(false); } })))));
};
exports.default = {
    title: 'Core/TagManagementModal',
    component: _1.TagManagementModal,
};
var Template = (0, utils_1.createTemplate)(TagManagement);
exports.Default = (0, utils_1.createStory)(Template, {
    items: items,
    itemType: 'tag',
    titleField: 'name',
    tagField: 'tag_field',
    done: function () { return null; },
    cancel: function () { return null; },
});
