"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NoninteractiveTerminal = exports.Default = void 0;
var React = __importStar(require("react"));
var utils_1 = require("../../stories/utils");
var _1 = require(".");
var tty_output_1 = require("../../stories/assets/tty-output");
var repl_1 = require("../../stories/assets/repl");
var outputArray = tty_output_1.output1.split('\n');
var Logger = (function (_super) {
    __extends(Logger, _super);
    function Logger(props) {
        var _this = _super.call(this, props) || this;
        _this.lines = outputArray.slice();
        return _this;
    }
    Logger.prototype.componentDidMount = function () {
        var _this = this;
        this.interval = setInterval(function () {
            if (!_this.term) {
                return;
            }
            if (_this.lines.length) {
                _this.term.writeln(_this.lines.shift());
            }
            else {
                window.clearInterval(_this.interval);
                _this.interval = null;
            }
        }, 300);
    };
    Logger.prototype.componentWillUnmount = function () {
        if (this.interval) {
            window.clearInterval(this.interval);
        }
    };
    Logger.prototype.render = function () {
        var _this = this;
        return (React.createElement(_1.Terminal, __assign({ ref: function (term) { return (_this.term = term); } }, this.props.termProps)));
    };
    return Logger;
}(React.Component));
var InteractiveTerm = (function (_super) {
    __extends(InteractiveTerm, _super);
    function InteractiveTerm(props) {
        var _this = _super.call(this, props) || this;
        _this.input = '';
        return _this;
    }
    InteractiveTerm.prototype.componentDidMount = function () {
        var _this = this;
        setTimeout(function () {
            _this.term.tty.setOption('bellStyle', 'visual');
        }, 2000);
        if (!this.props.ttyInstance) {
            this.term.tty._repl = new repl_1.Repl(function (line) {
                if (_this.term.tty) {
                    _this.term.writeln(line);
                    _this.term.tty.prompt();
                }
            });
            this.term.tty.prompt = function () {
                _this.term.tty.write('\u001b[33m$ \u001b[0m');
            };
            this.term.tty.writeln('\u001b[32mThis is a basic interactive representation of a web browser javascript console\u001b[0m');
            this.term.tty.writeln('\u001b[32mType some keys and commands to play around\u001b[0m');
            this.term.tty.prompt();
            this.term.tty.onKey(function (_a) {
                var key = _a.key, domEvent = _a.domEvent;
                var printable = !domEvent.altKey &&
                    !domEvent.altGraphKey &&
                    !domEvent.ctrlKey &&
                    !domEvent.metaKey;
                if (domEvent.code === 'ArrowUp' || domEvent.code === 'ArrowDown') {
                    return;
                }
                if (domEvent.keyCode === 13) {
                    _this.term.write('\r\n');
                    _this.term.tty._repl.process(_this.input);
                    _this.input = '';
                }
                else if (domEvent.keyCode === 8) {
                    if (_this.term.tty.buffer.active.cursorX > 2) {
                        _this.term.tty.write('\b \b');
                        _this.input = _this.input.slice(0, -1);
                    }
                }
                else if (printable) {
                    _this.input += key;
                    _this.term.tty.write(key);
                }
            });
        }
        else {
            this.term = this.props.ttyInstance;
        }
    };
    InteractiveTerm.prototype.componentWillUnmount = function () {
        if (!this.props.persistent) {
            this.term.tty._repl.destroy();
        }
    };
    InteractiveTerm.prototype.render = function () {
        var _this = this;
        return (React.createElement(_1.Terminal, __assign({ ref: function (term) { return (_this.term = term); } }, this.props.termProps)));
    };
    return InteractiveTerm;
}(React.Component));
exports.default = {
    title: 'Core/Terminal',
    component: _1.Terminal,
    decorators: [
        function (Story) { return (React.createElement("div", { style: { height: 500 } },
            React.createElement(Story, null))); },
    ],
};
var InteractiveTermTemplate = (0, utils_1.createTemplate)(InteractiveTerm);
exports.Default = (0, utils_1.createStory)(InteractiveTermTemplate, {});
var NoninteractiveTermTemplate = (0, utils_1.createTemplate)(Logger);
exports.NoninteractiveTerminal = (0, utils_1.createStory)(NoninteractiveTermTemplate, {
    nonInteractive: true,
});
