import * as React from 'react';
import { RenditionSystemProps, StyledSystemProps, Theme } from '../../common-types';
export declare const code: (props: Pick<ThemedTxtProps, 'theme' | 'code'>) => import("styled-components").FlattenInterpolation<import("styled-components").ThemeProps<any>> | null;
export declare const underline: (props: Pick<ThemedTxtProps, 'theme' | 'underline'>) => import("styled-components").FlattenSimpleInterpolation | null;
export declare const whitespace: (props: Pick<ThemedTxtProps, 'theme' | 'whitespace'>) => import("styled-components").FlattenSimpleInterpolation | null;
export declare const caps: (props: Pick<ThemedTxtProps, 'theme' | 'caps'>) => import("styled-components").FlattenSimpleInterpolation | null;
export declare const italic: (props: Pick<ThemedTxtProps, 'theme' | 'italic'>) => import("styled-components").FlattenSimpleInterpolation | null;
export declare const bold: (props: Pick<ThemedTxtProps, 'theme' | 'bold'>) => import("styled-components").FlattenSimpleInterpolation | null;
export declare const truncate: (props: ThemedTxtProps) => false | import("styled-components").FlattenSimpleInterpolation | undefined;
export declare const align: {
    [cssProp: string]: string;
};
export declare const BaseTxt: import("styled-components").StyledComponent<"div", any, InternalTxtProps & StyledSystemProps & import("../../common-types").Tooltip, never>;
export type Whitespace = 'normal' | 'nowrap' | 'pre' | 'pre-line' | 'pre-wrap' | 'initial' | 'inherit';
export type Align = 'left' | 'right' | 'center' | 'justify' | 'justify-all' | 'start' | 'end' | 'match-parent' | 'inherit' | 'initial' | 'unset';
export interface InternalTxtProps extends Omit<React.HTMLAttributes<HTMLElement>, 'onCopy'> {
    monospace?: boolean;
    underline?: boolean;
    bold?: boolean;
    italic?: boolean;
    code?: boolean;
    caps?: boolean;
    whitespace?: Whitespace;
    align?: Align;
    truncate?: boolean;
    copy?: string | number;
    showCopyMode?: 'hover' | 'always';
    onCopy?: React.EventHandler<React.ClipboardEvent<HTMLElement> | React.MouseEvent<HTMLElement>>;
}
export interface ThemedTxtProps extends InternalTxtProps {
    theme: Theme;
}
export type TxtProps = InternalTxtProps & RenditionSystemProps;
export declare const Txt: React.FunctionComponent<TxtProps> & {
    p: React.FunctionComponent<TxtProps>;
    span: React.FunctionComponent<TxtProps>;
};
