"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Txt = exports.BaseTxt = exports.align = exports.truncate = exports.bold = exports.italic = exports.caps = exports.whitespace = exports.underline = exports.code = void 0;
var React = __importStar(require("react"));
var styled_components_1 = __importStar(require("styled-components"));
var styled_system_1 = require("styled-system");
var asRendition_1 = __importStar(require("../../asRendition"));
var utils_1 = require("../../utils");
var Copy_1 = require("../Copy");
var difference_1 = __importDefault(require("lodash/difference"));
var pick_1 = __importDefault(require("lodash/pick"));
var styledPropsKeys = asRendition_1.styledSystemProps.filter(function (s) { return !['bg', 'color', 'background', 'fontSize'].includes(s); });
var code = function (props) {
    return props.code
        ? (0, styled_components_1.css)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t\t\t\tfont-family: ", ";\n\t\t\t\tpadding: 2px 4px;\n\t\t\t\tfont-size: 1em;\n\t\t\t\tcolor: #c7254e;\n\t\t\t\tbackground-color: #f9f2f4;\n\t\t  "], ["\n\t\t\t\tfont-family: ", ";\n\t\t\t\tpadding: 2px 4px;\n\t\t\t\tfont-size: 1em;\n\t\t\t\tcolor: #c7254e;\n\t\t\t\tbackground-color: #f9f2f4;\n\t\t  "])), function (props) { return props.theme.monospace; }) : null;
};
exports.code = code;
var underline = function (props) {
    return props.underline
        ? (0, styled_components_1.css)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t\t\t\ttext-decoration: underline;\n\t\t  "], ["\n\t\t\t\ttext-decoration: underline;\n\t\t  "]))) : null;
};
exports.underline = underline;
var whitespace = function (props) {
    return props.whitespace
        ? (0, styled_components_1.css)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\t\t\t\twhite-space: ", ";\n\t\t  "], ["\n\t\t\t\twhite-space: ", ";\n\t\t  "])), props.whitespace) : null;
};
exports.whitespace = whitespace;
var caps = function (props) {
    return props.caps
        ? (0, styled_components_1.css)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\t\t\t\ttext-transform: uppercase;\n\t\t\t\tletter-spacing: 0.2em;\n\t\t  "], ["\n\t\t\t\ttext-transform: uppercase;\n\t\t\t\tletter-spacing: 0.2em;\n\t\t  "]))) : null;
};
exports.caps = caps;
var italic = function (props) {
    return props.italic
        ? (0, styled_components_1.css)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\t\t\t\tfont-style: italic;\n\t\t  "], ["\n\t\t\t\tfont-style: italic;\n\t\t  "]))) : null;
};
exports.italic = italic;
var bold = function (props) {
    return props.bold
        ? (0, styled_components_1.css)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n\t\t\t\tfont-weight: ", ";\n\t\t  "], ["\n\t\t\t\tfont-weight: ", ";\n\t\t  "])), props.theme.weights[props.theme.weights.length - 1]) : null;
};
exports.bold = bold;
var truncate = function (props) {
    return props.truncate && (0, styled_components_1.css)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n\t\toverflow: hidden;\n\t\ttext-overflow: ellipsis;\n\t\twhite-space: nowrap;\n\t"], ["\n\t\toverflow: hidden;\n\t\ttext-overflow: ellipsis;\n\t\twhite-space: nowrap;\n\t"])));
};
exports.truncate = truncate;
exports.align = (0, styled_system_1.style)({
    key: 'text-align',
    prop: 'align',
    cssProperty: 'text-align',
});
exports.BaseTxt = styled_components_1.default.div(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n"], ["\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n"])), exports.align, utils_1.monospace, exports.whitespace, exports.code, exports.caps, exports.bold, exports.italic, exports.truncate, exports.underline);
var Factory = function (tag) {
    return (0, asRendition_1.default)(function (props) {
        if (props.copy == null) {
            return React.createElement(exports.BaseTxt, __assign({ as: tag }, props));
        }
        var styledProps = (0, pick_1.default)(props, styledPropsKeys);
        var otherPropsKeys = (0, difference_1.default)(Object.keys(props), styledPropsKeys);
        var otherProps = (0, pick_1.default)(props, otherPropsKeys);
        return (React.createElement(Copy_1.Copy, __assign({ show: props.showCopyMode || 'hover', content: props.copy, onCopy: props.onCopy }, styledProps),
            React.createElement(exports.BaseTxt, __assign({ as: tag }, otherProps))));
    }, [], styledPropsKeys);
};
var Base = Factory();
Base.displayName = 'Txt';
Base.span = Factory('span');
Base.p = Factory('p');
exports.Txt = Base;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8;
