"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var date_fns_1 = require("date-fns");
exports.default = (function (data) {
    var _a;
    var untilDate = new Date(new Date().setDate(new Date().getDate() - 90));
    var versionDateStringMatches = (_a = data.match(/^# v\d+\.\d+\.\d+\n## \(([0-9]{4}-[0-1][0-9]-[0-3][0-9])\)/gm)) !== null && _a !== void 0 ? _a : [];
    var firstOlderDateIndex = Infinity;
    var foundMatch = false;
    for (var i = 0; i < versionDateStringMatches.length; i++) {
        foundMatch = true;
        var firstOlderDateString = versionDateStringMatches[i];
        if ((0, date_fns_1.isBefore)(new Date(firstOlderDateString.split('(')[1].split(')')[0]), untilDate)) {
            firstOlderDateIndex = i;
            break;
        }
    }
    if (!foundMatch) {
        throw new Error("Could not find any changes from the last 90 days in the changelog");
    }
    var firstVersionIndex = data.search(/# v\d+\.\d+\.\d+/);
    var lastVersionIndex = data.indexOf(versionDateStringMatches[i]);
    return data.slice(firstVersionIndex, lastVersionIndex);
});
