"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MermaidWidget = void 0;
var grommet_1 = require("grommet");
var React = __importStar(require("react"));
var Link_1 = require("../../components/Link");
var Textarea_1 = require("../../components/Textarea");
var theme_1 = __importDefault(require("../../theme"));
var Mermaid_1 = require("../Mermaid");
var MermaidWidget = function (_a) {
    var options = _a.options, id = _a.id, onChange = _a.onChange, onBlur = _a.onBlur, onFocus = _a.onFocus, value = _a.value, readonly = _a.readonly, disabled = _a.disabled, autofocus = _a.autofocus, schema = _a.schema, formContext = _a.formContext, inputProps = __rest(_a, ["options", "id", "onChange", "onBlur", "onFocus", "value", "readonly", "disabled", "autofocus", "schema", "formContext"]);
    var handleChange = function (_a) {
        var value = _a.target.value;
        return onChange(value === '' ? options.emptyValue : value);
    };
    var handleBlur = function (event) {
        if (onBlur) {
            onBlur(id, event.target.value);
        }
    };
    var handleFocus = function (event) {
        if (onFocus) {
            onFocus(id, event.target.value);
        }
    };
    return (React.createElement(React.Fragment, null,
        React.createElement(grommet_1.Tabs, { justify: "start" },
            React.createElement(grommet_1.Tab, { title: "Write" },
                React.createElement(Textarea_1.Textarea, __assign({ placeholder: "This text supports mermaid charts", readOnly: readonly, disabled: disabled, autoFocus: autofocus, value: value || '' }, inputProps, { onChange: handleChange, onBlur: handleBlur, onFocus: handleFocus, rows: 5 }))),
            React.createElement(grommet_1.Tab, { title: "Preview" },
                React.createElement(Mermaid_1.Mermaid, { bg: theme_1.default.colors.gray.light, p: 3, style: {
                        borderRadius: theme_1.default.radius,
                        width: '100%',
                        minHeight: 180,
                    }, value: value }))),
        React.createElement(Link_1.Link, { fontSize: 0, href: 'https://mermaidjs.github.io/', blank: true }, "About mermaid")));
};
exports.MermaidWidget = MermaidWidget;
exports.MermaidWidget.displayName = 'Mermaid';
