"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WithDecorators = exports.Customized = exports.Default = void 0;
var defaults_1 = __importDefault(require("lodash/defaults"));
var cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
var React = __importStar(require("react"));
var utils_1 = require("../../stories/utils");
var __1 = require("../..");
var _1 = require(".");
var markdownSample_1 = __importStar(require("../../stories/assets/markdownSample"));
var generateTableData = function () {
    return markdownSample_1.customizationSamples.map(function (_a, index) {
        var markdown = _a.markdown, sanitizerOptions = _a.sanitizerOptions;
        var customSanitizerOptions = (0, defaults_1.default)((0, cloneDeep_1.default)(sanitizerOptions || {}), _1.defaultSanitizerOptions);
        return {
            id: index,
            'Specific Sanitizer Options': (React.createElement("pre", null, JSON.stringify(sanitizerOptions, null, 2))),
            Original: (React.createElement(__1.Card, { small: true },
                React.createElement(_1.Markdown, null, markdown))),
            Customized: (React.createElement(__1.Card, { small: true },
                React.createElement(_1.Markdown, { sanitizerOptions: customSanitizerOptions }, markdown))),
        };
    });
};
exports.default = {
    title: 'Extra/Markdown',
    component: _1.Markdown,
};
var Template = (0, utils_1.createTemplate)(_1.Markdown);
exports.Default = (0, utils_1.createStory)(Template, {
    children: markdownSample_1.default,
});
exports.Customized = (0, utils_1.createStory)(Template, {});
var cellAttributes = { style: { verticalAlign: 'top' } };
var columns = [
    { field: 'Specific Sanitizer Options', cellAttributes: cellAttributes },
    { field: 'Original', cellAttributes: cellAttributes },
    { field: 'Customized', cellAttributes: cellAttributes },
];
exports.Customized.decorators = [
    function () { return React.createElement(__1.Table, { columns: columns, data: generateTableData() }); },
];
exports.WithDecorators = (0, utils_1.createStory)(Template, {
    decorators: [
        {
            match: new RegExp("(\\s|^)((@{1,2}|#|!{1,2})[a-z\\d-_\\/]+(\\.[a-z\\d-_\\/]+)*)(\\s|$)", 'gmi'),
            captureGroupIndex: 2,
            component: 'span',
            properties: {
                style: {
                    color: 'green',
                },
            },
        },
    ],
    children: markdownSample_1.decoratorSample,
});
