import * as React from 'react';
import { TxtProps } from '../../components/Txt';
import unified from 'unified';
import gh from 'hast-util-sanitize/lib/github.json';
import { Decorator } from './plugins/decorator';
export { gh as defaultSanitizerOptions };
type components = {
    [element: string]: (props: any) => JSX.Element | React.ReactElement | Element;
};
export declare const getProcessor: (componentOverrides?: components, sanitizerOptions?: any, disableRawHtml?: boolean, disableCodeHighlight?: boolean, disableAutoHeadingLinking?: boolean, decorators?: Decorator[] | undefined) => unified.Processor<unified.Settings>;
export type MarkdownProps = TxtProps & {
    children: string;
    componentOverrides?: components;
    sanitizerOptions?: any;
    disableRawHtml?: boolean;
    disableCodeHighlight?: boolean;
    decorators?: Decorator[];
    disableAutoHeadingLinking?: boolean;
};
export declare const Markdown: ({ children, componentOverrides, sanitizerOptions, disableRawHtml, disableCodeHighlight, decorators, disableAutoHeadingLinking, ...rest }: MarkdownProps) => React.JSX.Element;
