"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBreakpoint = void 0;
var React = __importStar(require("react"));
var BreakpointContext_1 = require("../contexts/BreakpointContext");
var theme_1 = require("../theme");
var useBreakpoint = function (value) {
    var normalizedValue = Array.isArray(value) ? value : [value];
    if (normalizedValue.length > theme_1.breakpoints.length) {
        throw new Error("There should be no more than ".concat(theme_1.breakpoints.length, " value entries"));
    }
    var currentBreakpoint = React.useContext(BreakpointContext_1.BreakpointContext).currentBreakpoint;
    var missingValues = Array(theme_1.breakpoints.length - normalizedValue.length).fill(normalizedValue[normalizedValue.length - 1]);
    var newValues = __spreadArray(__spreadArray([], normalizedValue, true), missingValues, true);
    return newValues[currentBreakpoint];
};
exports.useBreakpoint = useBreakpoint;
