"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRequest = void 0;
var React = __importStar(require("react"));
var poll_1 = require("../utils/poll");
var useRequest = function (action, deps, options) {
    var _a, _b, _c;
    var polling = options.polling, pollInterval = options.pollInterval, stopExecution = options.stopExecution;
    var _d = React.useState(true), loading = _d[0], setLoading = _d[1];
    var _e = React.useState(), error = _e[0], setError = _e[1];
    var _f = React.useState(), data = _f[0], setData = _f[1];
    var _g = React.useState(true), isVisible = _g[0], setIsVisible = _g[1];
    var pollRef = React.useRef();
    var loadDataDeps = 'persist' in deps || 'reset' in deps
        ? __spreadArray(__spreadArray([], ((_a = deps.persist) !== null && _a !== void 0 ? _a : []), true), ((_b = deps.reset) !== null && _b !== void 0 ? _b : []), true) : deps;
    React.useEffect(function () {
        var handleVisibilityChange = function () { return setIsVisible(!document.hidden); };
        document.addEventListener('visibilitychange', handleVisibilityChange);
        return function () {
            return document.removeEventListener('visibilitychange', handleVisibilityChange);
        };
    });
    var loadData = React.useCallback(function (poll) { return __awaiter(void 0, void 0, void 0, function () {
        var response, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, 3, 4]);
                    return [4, action(poll)];
                case 1:
                    response = _a.sent();
                    setData(response);
                    return [3, 4];
                case 2:
                    e_1 = _a.sent();
                    if (e_1 instanceof Error) {
                        setError(e_1);
                    }
                    else {
                        setError(new Error(typeof e_1 === 'string' ? e_1 : 'Unknown error'));
                    }
                    setData([]);
                    return [3, 4];
                case 3:
                    setLoading(false);
                    return [7];
                case 4: return [2];
            }
        });
    }); }, loadDataDeps);
    var forcePoll = React.useCallback(function () {
        setLoading(true);
        if (pollRef.current) {
            pollRef.current.poll({ forced: true });
        }
        else {
            loadData();
        }
    }, [pollRef, loadData]);
    React.useEffect(function () {
        if (stopExecution) {
            return pollRef.current && pollRef.current.stop();
        }
        if (!polling) {
            loadData();
            return;
        }
        pollRef.current = (0, poll_1.createPoll)(loadData, pollInterval, isVisible);
        pollRef.current.start();
        return function () {
            if (pollRef.current) {
                pollRef.current.destroy();
                pollRef.current = undefined;
            }
        };
    }, [polling, loadData, pollInterval, stopExecution, isVisible]);
    React.useEffect(function () {
        if (!polling) {
            return;
        }
        setData(undefined);
    }, __spreadArray(__spreadArray([], ('reset' in deps ? (_c = deps.reset) !== null && _c !== void 0 ? _c : [] : deps), true), [
        polling,
    ], false));
    React.useEffect(function () {
        if (!polling) {
            return;
        }
        forcePoll();
    }, loadDataDeps);
    var result = [data, loading, error, forcePoll];
    result.data = data;
    result.isLoading = loading;
    result.error = error;
    result.forcePoll = forcePoll;
    return result;
};
exports.useRequest = useRequest;
