"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decoratorSample = exports.customizationSamples = void 0;
var GitHub_Mark_120px_plus_png_1 = __importDefault(require("./GitHub-Mark-120px-plus.png"));
exports.customizationSamples = [
    {
        markdown: "<h1>A title</h1><img src='https://via.placeholder.com/150'><p>A paragraph</p>",
        sanitizerOptions: {
            tagNames: ['p'],
        },
    },
    {
        markdown: "<h1>A title</h1><img src='https://via.placeholder.com/150'><p>A paragraph</p>",
        sanitizerOptions: {
            tagNames: ['img'],
            attributes: { '*': ['src'] },
        },
    },
    {
        markdown: "<h1>A title</h1><img src='https://via.placeholder.com/150'><p>A paragraph</p>",
        sanitizerOptions: {
            tagNames: ['h1'],
        },
    },
];
exports.decoratorSample = "\n@good foo @bad@bad [@good](https://github.com) bar@bad baz qux. `Is @bad inside code` @good\n\n@good\n";
exports.default = "\n# Markdown\nA simple component for rendering *GitHub flavored markdown*.\n\n## Headers\n\n# This is an `<h1>` tag\n## This is an `<h2>` tag\n###### This is an `<h6>` tag\n\n## Emphasis\n\n*This text will be italic*\n_This will also be italic_\n\n**This text will be bold**\n__This will also be bold__\n\n_You **can** combine them_\n\n## Lists\n\n### Unordered\n\n* Item 1\n* Item 2\n  * Item 2a\n  * Item 2b\n\n### Ordered\n\n1. Item 1\n1. Item 2\n1. Item 3\n   1. Item 3a\n   1. Item 3b\n\n## Images\n\n![Example Image](".concat(GitHub_Mark_120px_plus_png_1.default, ")\n\n## Links\n\nhttp://github.com - automatic!\n\n[GitHub](http://github.com)\n\n## Blockquotes\n\nAs Ash Ketchum said:\n\n> Do you always need a reason to help somebody?\n\n## Inline code\n\nI think you should use an\n`<addr>` element here instead.\n\n## Code blocks\n\n```\n// This is plaintext with a very long line that won't wrap but should cause a horizontal scrollbar to appear so that the code block doesn't overflow it's container and make a mockery of your website. It really needs to be a very long line to ensure it forces the scrollbar to appear on the React Storybook display, especially on large monitor resolutions which can display a super-wide code block!\nconst foo = () => {\n  return 'bar'\n}\n```\n\n```javascript\n// This is javascript\nconst foo = () => {\n  return 'bar'\n}\n```\n\n## Task Lists\n\n- [x] list syntax required (any unordered or ordered list supported)\n- [x] this is a complete item\n- [ ] this is an incomplete item\n\n## Tables\n\nFirst Header | Second Header\n------------ | -------------\nContent from cell 1 | Content from cell 2\nContent in the first column | Content in the second column\n\n\n## Strikethrough\n\n~~Crossed out~~\n\nAny word wrapped with two tildes (like `~~this~~`) will appear crossed out.\n\n## Inline HTML\n\n<strong>An image:</strong>\n<br>\n<img src=\"").concat(GitHub_Mark_120px_plus_png_1.default, "\" />\n<br>\n<em>A link:</em>\n<a target=\"_blank\" href=\"http://github.com/\">http://github.com/</a>\n\n## Keyboard keys\n\n<kbd>cmd</kbd> + <kbd>alt</kbd> + <kbd>shift</kbd> + <kbd>a</kbd>\n");
