"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApplicationInstructions = exports.getUserOs = void 0;
var React = __importStar(require("react"));
var Flex_1 = require("../../components/Flex");
var Box_1 = require("../../components/Box");
var Txt_1 = require("../../components/Txt");
var Tabs_1 = require("../../components/Tabs");
var Link_1 = require("../../components/Link");
var List_1 = require("../../components/List");
var Heading_1 = require("../../components/Heading");
var useTranslation_1 = require("../../hooks/useTranslation");
var utils_1 = require("./utils");
var getUserOs = function () {
    var platform = window.navigator.platform.toLowerCase();
    if (platform.includes('win')) {
        return 'Windows';
    }
    if (platform.includes('mac')) {
        return 'MacOS';
    }
    if (platform.includes('x11') || platform.includes('linux')) {
        return 'Linux';
    }
    return 'Unknown';
};
exports.getUserOs = getUserOs;
var dtJsonTocontractOsKeyMap = {
    windows: 'Windows',
    osx: 'MacOS',
    linux: 'Linux',
};
exports.ApplicationInstructions = React.memo(function (_a) {
    var _b, _c, _d;
    var deviceType = _a.deviceType, templateData = _a.templateData;
    var t = (0, useTranslation_1.useTranslation)().t;
    var _e = React.useState((0, exports.getUserOs)()), currentOs = _e[0], setCurrentOs = _e[1];
    var instructions = React.useMemo(function () {
        if ((deviceType === null || deviceType === void 0 ? void 0 : deviceType.instructions) == null ||
            Array.isArray(deviceType.instructions) ||
            typeof deviceType.instructions !== 'object') {
            return deviceType === null || deviceType === void 0 ? void 0 : deviceType.instructions;
        }
        var instructionsByOs = deviceType.instructions;
        return Object.fromEntries(Object.entries(instructionsByOs).map(function (_a) {
            var key = _a[0], value = _a[1];
            var normalizedKey = key in dtJsonTocontractOsKeyMap
                ? dtJsonTocontractOsKeyMap[key]
                : key;
            return [normalizedKey, value];
        }));
    }, [deviceType === null || deviceType === void 0 ? void 0 : deviceType.instructions]);
    var hasOsSpecificInstructions = instructions != null &&
        !Array.isArray(instructions) &&
        typeof instructions === 'object';
    var normalizedOs = currentOs === 'Unknown' ? 'Linux' : currentOs;
    React.useEffect(function () {
        if (hasOsSpecificInstructions) {
            var oses = Object.keys(instructions);
            if (!oses.includes(currentOs) && oses.length > 0) {
                setCurrentOs(oses[0]);
            }
        }
    }, [currentOs, setCurrentOs, instructions, hasOsSpecificInstructions]);
    if (!deviceType || !instructions) {
        return React.createElement(Txt_1.Txt, null, t('no_data.no_instructions_found'));
    }
    var interpolatedInstructions = (_b = (hasOsSpecificInstructions
        ? instructions[normalizedOs]
        : instructions)) === null || _b === void 0 ? void 0 : _b.map(function (instruction) {
        return (0, utils_1.interpolateMustache)(templateData, instruction.replace(/<a/, '<a target="_blank"'));
    });
    var hasConfigDownloadOnly = ((_c = deviceType.yocto) === null || _c === void 0 ? void 0 : _c.deployArtifact) === 'docker-image';
    var finalInstructions = interpolatedInstructions
        ? __spreadArray(__spreadArray([
            hasConfigDownloadOnly
                ? t('actions.use_form_to_download_configuration')
                : t('actions.use_from_to_configure_and_download')
        ], interpolatedInstructions, true), [
            t('actions_messages.appearance_device_explanation'),
        ], false) : null;
    return (React.createElement(Flex_1.Flex, { flexDirection: "column", alignItems: "flex-start" },
        React.createElement(Heading_1.Heading.h5, { mb: 3 }, t('labels.instructions')),
        hasOsSpecificInstructions && (React.createElement(Box_1.Box, { mb: 3 },
            React.createElement(Tabs_1.Tabs, { activeIndex: (_d = Object.keys(instructions).indexOf(currentOs)) !== null && _d !== void 0 ? _d : 0, onActive: function (index) {
                    var _a;
                    return setCurrentOs((_a = Object.keys(instructions)[index]) !== null && _a !== void 0 ? _a : 'Unknown');
                } }, Object.keys(instructions).map(function (os) {
                return React.createElement(Tabs_1.Tab, { key: os, title: os });
            })))),
        finalInstructions != null && (React.createElement(InstructionsList, { instructions: finalInstructions })),
        React.createElement(Flex_1.Flex, { mt: 4 },
            React.createElement(Txt_1.Txt, null,
                "For more details please refer to our",
                ' ',
                React.createElement(Link_1.Link, { blank: true, href: "https://www.balena.io/docs/learn/getting-started/".concat(deviceType.slug, "/nodejs/") }, "Getting Started Guide"),
                "."))));
});
var InstructionsItem = function (_a) {
    var node = _a.node;
    return React.createElement("span", { dangerouslySetInnerHTML: { __html: node } });
};
var InstructionsList = function (_a) {
    var instructions = _a.instructions;
    return (React.createElement(List_1.List, { ordered: true, fontSize: 14 }, instructions.map(function (item, i) {
        return React.createElement(InstructionsItem, { key: "".concat(item, "_").concat(i), node: item });
    })));
};
