"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeviceTypeSelector = void 0;
var React = __importStar(require("react"));
var useTranslation_1 = require("../../hooks/useTranslation");
var Flex_1 = require("../../components/Flex");
var Select_1 = require("../../components/Select");
var Txt_1 = require("../../components/Txt");
var DownloadImageModal_1 = require("./DownloadImageModal");
var utils_1 = require("./utils");
var DeviceTypeOption = function (_a) {
    var _b, _c, _d;
    var deviceType = _a.deviceType, isSelected = _a.isSelected, emphasized = _a.emphasized, _e = _a.isOption, isOption = _e === void 0 ? false : _e;
    var t = (0, useTranslation_1.useTranslation)().t;
    var typeDisplayName = (_b = deviceType === null || deviceType === void 0 ? void 0 : deviceType.name) !== null && _b !== void 0 ? _b : t('placeholders.choose_device_type');
    var logoSrc = (_c = deviceType === null || deviceType === void 0 ? void 0 : deviceType.logo) !== null && _c !== void 0 ? _c : utils_1.FALLBACK_LOGO_UNKNOWN_DEVICE;
    var defaultDisplayName = (_d = deviceType === null || deviceType === void 0 ? void 0 : deviceType.name) !== null && _d !== void 0 ? _d : '-';
    return (React.createElement(Flex_1.Flex, { style: { height: emphasized ? 46 : 36 }, py: 2, pl: 3, width: "100%", alignItems: "center" },
        React.createElement(DownloadImageModal_1.DeviceLogo, { src: logoSrc, title: defaultDisplayName }),
        React.createElement(Txt_1.Txt, { className: isOption ? 'e2e-device-type-option' : '', ml: 2, bold: isSelected }, typeDisplayName)));
};
var DeviceTypeSelectorBase = function (_a) {
    var deviceTypeOptions = _a.deviceTypeOptions, selectedDeviceType = _a.selectedDeviceType, selectDeviceTypeOption = _a.selectDeviceTypeOption, emphasized = _a.emphasized, id = _a.id;
    var _b = React.useState(''), query = _b[0], setQuery = _b[1];
    var _c = React.useState([]), filteredDeviceTypes = _c[0], setFilteredDeviceTypes = _c[1];
    React.useEffect(function () {
        var filtered = deviceTypeOptions.filter(function (s) { return s.name.toLowerCase().indexOf(query.toLowerCase()) >= 0; });
        setFilteredDeviceTypes(filtered);
    }, [deviceTypeOptions, query]);
    React.useEffect(function () {
        if (deviceTypeOptions.length === 0) {
            return;
        }
        if (!deviceTypeOptions.some(function (dt) { return dt.slug === selectedDeviceType.slug; })) {
            selectDeviceTypeOption(null);
        }
    }, [deviceTypeOptions, selectedDeviceType, selectDeviceTypeOption]);
    return (React.createElement(Select_1.Select, { id: id, emphasized: emphasized, options: filteredDeviceTypes, valueKey: "slug", labelKey: "name", value: selectedDeviceType || {}, placeholder: React.createElement(DeviceTypeOption, { emphasized: emphasized }), valueLabel: React.createElement(DeviceTypeOption, { emphasized: emphasized, deviceType: selectedDeviceType }), onChange: function (_a) {
            var option = _a.option;
            selectDeviceTypeOption(option);
            setQuery('');
        }, onSearch: setQuery }, function (option) { return (React.createElement(DeviceTypeOption, { deviceType: option, isSelected: option.slug === selectedDeviceType.slug, isOption: true })); }));
};
exports.DeviceTypeSelector = React.memo(DeviceTypeSelectorBase);
