import * as React from 'react';
import { ModalAction } from './ImageForm';
import { OsVersionsByDeviceType, Application, DeviceType } from './models';
import { Dictionary } from '../../common-types';
import { FormModel } from './FormModel';
import { IconProp } from '@fortawesome/fontawesome-svg-core';
export declare const DeviceLogo: import("styled-components").StyledComponent<{
    ({ fallback, src, ...props }: import("../../components/Img").ImgProps): React.JSX.Element;
    displayName: string;
}, any, {
    small?: boolean | undefined;
}, never>;
export interface DownloadOptionsBase {
    appId: number;
    releaseId?: number;
    deviceType: string;
    provisioningKeyName?: string;
    provisioningKeyExpiryDate?: string;
    downloadConfigOnly?: boolean;
    version: string;
    developmentMode?: boolean;
}
export interface DownloadOptions extends DownloadOptionsBase, FormModel {
}
export interface UnstableTempDownloadImageModalProps {
    application: Application;
    releaseId?: number;
    compatibleDeviceTypes: DeviceType[] | null;
    initialDeviceType?: DeviceType;
    initialOsVersions?: OsVersionsByDeviceType;
    isInitialDefault?: boolean;
    downloadUrl: string;
    onDownloadStart?: (downloadConfigOnly: boolean, downloadOptions: DownloadOptions) => void;
    getSupportedOsVersions?: () => Promise<OsVersionsByDeviceType>;
    getSupportedOsTypes?: (applicationId: number, deviceTypeSlug: string) => Promise<string[]>;
    downloadConfig?: (deviceType: DeviceType, rawVersion: string | null, model: FormModel) => Promise<void>;
    getDownloadSize?: (deviceType: DeviceType, rawVersion: string | null) => Promise<string> | undefined;
    getDockerArtifact: (deviceTypeSlug: string, rawVersion: string) => string;
    hasEsrVersions?: (deviceTypeSlugs: string[]) => Promise<Dictionary<boolean>>;
    onClose: () => void;
    modalActions?: ModalAction[];
    authToken?: string;
    docsIcon?: IconProp;
    onFieldChange?: (fields: {
        [key: string]: any;
    }) => void;
}
export declare const UnstableTempDownloadImageModal: ({ downloadUrl, application, releaseId, compatibleDeviceTypes, initialDeviceType, initialOsVersions, isInitialDefault, onDownloadStart, getSupportedOsVersions, getSupportedOsTypes, getDockerArtifact, hasEsrVersions, downloadConfig, getDownloadSize, onClose, modalActions, authToken, docsIcon, onFieldChange, }: UnstableTempDownloadImageModalProps) => React.JSX.Element | null;
