"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DocsLink = exports.OsConfiguration = exports.lineColors = exports.DownloadImageLabel = void 0;
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var faExclamationTriangle_1 = require("@fortawesome/free-solid-svg-icons/faExclamationTriangle");
var faFileAlt_1 = require("@fortawesome/free-regular-svg-icons/faFileAlt");
var Alert_1 = require("../../components/Alert");
var Badge_1 = require("../../components/Badge");
var Box_1 = require("../../components/Box");
var Checkbox_1 = require("../../components/Checkbox");
var Flex_1 = require("../../components/Flex");
var Link_1 = require("../../components/Link");
var Select_1 = require("../../components/Select");
var RadioButton_1 = require("../../components/RadioButton");
var Txt_1 = require("../../components/Txt");
var QuestionMark_1 = require("./QuestionMark");
var DeviceTypeSelector_1 = require("./DeviceTypeSelector");
var OsTypeSelector_1 = require("./OsTypeSelector");
var versions_1 = require("./versions");
var useTranslation_1 = require("../../hooks/useTranslation");
var utils_1 = require("./utils");
var useTheme_1 = require("../../hooks/useTheme");
exports.DownloadImageLabel = styled_components_1.default.label(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: flex;\n\tflex-direction: row;\n\talign-items: center;\n\theight: 21px;\n\tfont-size: 12px;\n\tmargin-bottom: 8px;\n\tfont-weight: normal;\n"], ["\n\tdisplay: flex;\n\tflex-direction: row;\n\talign-items: center;\n\theight: 21px;\n\tfont-size: 12px;\n\tmargin-bottom: 8px;\n\tfont-weight: normal;\n"])));
exports.lineColors = {
    next: 1,
    current: 0,
    sunset: 12,
    outdated: 5,
};
var BuildVariants = ['dev', 'prod'];
var getCategorizedVersions = function (deviceTypeOsVersions, deviceType, osType) {
    var _a;
    var osVersions = (_a = deviceTypeOsVersions[deviceType.slug]) !== null && _a !== void 0 ? _a : [];
    var deviceOsVersions = osType
        ? osVersions.filter(function (osVersion) { return osVersion.osType === osType; })
        : osVersions;
    var selectionOpts = (0, versions_1.transformVersions)(deviceOsVersions);
    var preferredSelectionOpts = (0, versions_1.getPreferredVersionOpts)(selectionOpts);
    return {
        selectionOpts: selectionOpts,
        preferredSelectionOpts: preferredSelectionOpts,
    };
};
var VariantSelector = function (_a) {
    var version = _a.version, variant = _a.variant, onVariantChange = _a.onVariantChange, t = _a.t;
    var _b = BuildVariants.map(function (vrnt) {
        var label = React.createElement(Txt_1.Txt.span, { bold: true }, (0, utils_1.getOsVariantDisplayText)(vrnt));
        if (vrnt === 'dev') {
            label = (React.createElement(React.Fragment, null,
                label,
                React.createElement(Alert_1.Alert, { ml: 3, info: true, plaintext: true }, t('info.recommended_for_new_users'))));
        }
        return {
            label: label,
            disabled: version == null ||
                (version.hasPrebuiltVariants && !version.rawVersions[vrnt]),
            checked: vrnt === variant,
            onChange: function () { return onVariantChange(vrnt); },
        };
    }), devOpts = _b[0], prodOpts = _b[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(RadioButton_1.RadioButton, __assign({}, devOpts)),
        React.createElement(Txt_1.Txt.p, { fontSize: 1, mt: 1, mb: 3, color: "tertiary.main" },
            t('info.development_images_for_local_development_1'),
            ' ',
            React.createElement(Link_1.Link, { href: "https://balena.io/docs/development/local-mode/", blank: true }, t('info.development_images_for_local_development_2')),
            ' ',
            t('info.development_images_for_local_development_3'),
            ' ',
            React.createElement("strong", null, t('info.development_images_for_local_development_4'))),
        React.createElement(RadioButton_1.RadioButton, __assign({}, prodOpts)),
        React.createElement(Txt_1.Txt.p, { fontSize: 1, mt: 1, color: "tertiary.main" }, t('info.production_images_not_for_local_development'))));
};
var VersionSelectOption = function (_a) {
    var _b, _c;
    var t = _a.t, option = _a.option, theme = _a.theme;
    return (React.createElement(Flex_1.Flex, { alignItems: "center", py: 2, pl: 3, tooltip: (_b = option.knownIssueList) !== null && _b !== void 0 ? _b : undefined, maxWidth: "445px" },
        React.createElement(Txt_1.Txt, { mr: 2 }, option.title),
        ' ',
        !!option.line && (React.createElement(Badge_1.Badge, { ml: 1, shade: (_c = exports.lineColors[option.line]) !== null && _c !== void 0 ? _c : 0 }, option.line)),
        !!option.isRecommended && (React.createElement(Badge_1.Badge, { ml: 1, shade: 20 }, t('labels.recommended'))),
        !!option.knownIssueList && (React.createElement(Box_1.Box, { ml: 2, tooltip: option.knownIssueList, display: "contents", style: { lineHeight: 'normal' } },
            React.createElement(react_fontawesome_1.FontAwesomeIcon, { color: theme.colors.warning.main, icon: faExclamationTriangle_1.faExclamationTriangle }),
            React.createElement(Txt_1.Txt, { ml: 1, truncate: true }, option.knownIssueList)))));
};
var OsConfiguration = function (_a) {
    var deviceTypeOsVersions = _a.deviceTypeOsVersions, compatibleDeviceTypes = _a.compatibleDeviceTypes, selectedDeviceType = _a.selectedDeviceType, osTypes = _a.osTypes, hasEsrVersions = _a.hasEsrVersions, selectedOsType = _a.selectedOsType, isInitialDefault = _a.isInitialDefault, onSelectedVersionChange = _a.onSelectedVersionChange, onSelectedDevelopmentMode = _a.onSelectedDevelopmentMode, onSelectedDeviceTypeChange = _a.onSelectedDeviceTypeChange, onSelectedOsTypeChange = _a.onSelectedOsTypeChange, docsIcon = _a.docsIcon;
    var theme = (0, useTheme_1.useTheme)();
    var t = (0, useTranslation_1.useTranslation)().t;
    var _b = React.useState(false), showAllVersions = _b[0], setShowAllVersions = _b[1];
    var _c = React.useState(), version = _c[0], setVersion = _c[1];
    var _d = React.useState('prod'), variant = _d[0], setVariant = _d[1];
    var _e = getCategorizedVersions(deviceTypeOsVersions, selectedDeviceType, selectedOsType), selectionOpts = _e.selectionOpts, preferredSelectionOpts = _e.preferredSelectionOpts;
    var versionSelectionOpts = showAllVersions
        ? selectionOpts
        : preferredSelectionOpts;
    var showAllVersionsToggle = preferredSelectionOpts.length < selectionOpts.length;
    React.useEffect(function () {
        if (!version) {
            return;
        }
        var versionWithVariant = version.hasPrebuiltVariants
            ? version.rawVersions[variant]
            : version.rawVersion;
        if (versionWithVariant) {
            onSelectedVersionChange(versionWithVariant);
            onSelectedDevelopmentMode(variant === 'dev');
        }
        if (version.hasPrebuiltVariants && !version.rawVersions[variant]) {
            setVariant(variant === 'dev' ? 'prod' : 'dev');
        }
    }, [version, variant]);
    var handleShowAllVersions = function (e) {
        var _a;
        var isChecked = e.target.checked;
        setShowAllVersions(isChecked);
        if (isChecked || !version) {
            return;
        }
        var selectedValueIsPreferred = preferredSelectionOpts.some(function (ver) { return ver.value === version.value; });
        if (selectedValueIsPreferred) {
            return;
        }
        var preferred = (_a = preferredSelectionOpts.find(function (ver) { return ver.isRecommended; })) !== null && _a !== void 0 ? _a : preferredSelectionOpts === null || preferredSelectionOpts === void 0 ? void 0 : preferredSelectionOpts[0];
        if (preferred) {
            setVersion(preferred);
        }
    };
    var handleSelectedDeviceTypeChange = React.useCallback(function (dt) {
        if ((selectedDeviceType === null || selectedDeviceType === void 0 ? void 0 : selectedDeviceType.slug) === dt.slug) {
            return;
        }
        var newDeviceType = compatibleDeviceTypes === null || compatibleDeviceTypes === void 0 ? void 0 : compatibleDeviceTypes.find(function (cdt) { return cdt.slug === dt.slug; });
        if (!newDeviceType) {
            return;
        }
        onSelectedDeviceTypeChange(newDeviceType);
    }, [compatibleDeviceTypes, selectedDeviceType]);
    React.useEffect(function () {
        var _a;
        setVersion((_a = versionSelectionOpts.find(function (ver) { return ver.isRecommended; })) !== null && _a !== void 0 ? _a : versionSelectionOpts[0]);
    }, [selectedDeviceType, selectedOsType]);
    return (React.createElement(React.Fragment, null,
        React.createElement(Flex_1.Flex, { mb: 3, mx: -2 },
            compatibleDeviceTypes.length > 1 && (React.createElement(Box_1.Box, { flex: 3, mx: 2 },
                React.createElement(exports.DownloadImageLabel, null,
                    t('placeholders.select_device_type'),
                    React.createElement(QuestionMark_1.QuestionMark, { tooltip: t('info.applications_support_devices_with_same_architecture') })),
                React.createElement(DeviceTypeSelector_1.DeviceTypeSelector, { deviceTypeOptions: compatibleDeviceTypes, selectedDeviceType: selectedDeviceType, selectDeviceTypeOption: handleSelectedDeviceTypeChange }))),
            (!isInitialDefault || !selectedOsType) && hasEsrVersions && (React.createElement(Box_1.Box, { flex: 2, mx: 2 },
                React.createElement(exports.DownloadImageLabel, null,
                    t('placeholders.select_os_type_status'),
                    ' ',
                    React.createElement(exports.DocsLink, { href: "https://www.balena.io/docs/reference/OS/extended-support-release", docsIcon: docsIcon })),
                React.createElement(OsTypeSelector_1.OsTypeSelector, { supportedOsTypes: osTypes, hasEsrVersions: hasEsrVersions, selectedOsTypeSlug: selectedOsType, onSelectedOsTypeChange: onSelectedOsTypeChange })))),
        (!isInitialDefault || !version) && (React.createElement(Box_1.Box, { mb: 3 },
            React.createElement(exports.DownloadImageLabel, null, t('placeholders.select_version')),
            React.createElement(Flex_1.Flex, { alignItems: "center", mx: -2 },
                React.createElement(Box_1.Box, { flex: 3, mx: 2 },
                    React.createElement(Select_1.Select, { id: "e2e-download-image-versions-list", valueKey: "value", labelKey: "title", emptySearchMessage: "No version available for this application type", value: version, valueLabel: version && (React.createElement(VersionSelectOption, { t: t, option: version, theme: theme })), placeholder: 'Choose a version...', onChange: function (_a) {
                            var option = _a.option;
                            setVersion(option);
                        }, options: versionSelectionOpts }, function (option) { return (React.createElement(VersionSelectOption, { t: t, option: option, theme: theme })); })),
                showAllVersionsToggle && (React.createElement(Box_1.Box, { flex: 2, mx: 2 },
                    React.createElement(Checkbox_1.Checkbox, { checked: showAllVersions, label: 'Show outdated versions', onChange: handleShowAllVersions, className: "e2e-show-outdated-images" })))))),
        (!isInitialDefault || !variant) && (React.createElement(Box_1.Box, null,
            React.createElement(exports.DownloadImageLabel, null, t('placeholders.select_edition')),
            React.createElement(Box_1.Box, null,
                React.createElement(VariantSelector, { t: t, version: version, variant: variant, onVariantChange: setVariant }))))));
};
exports.OsConfiguration = OsConfiguration;
var DocsLink = function (_a) {
    var href = _a.href, docsIcon = _a.docsIcon;
    return (React.createElement(Link_1.Link, { blank: true, href: href, fontSize: 2, ml: 2 }, docsIcon ? (React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: docsIcon })) : (React.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faFileAlt_1.faFileAlt }))));
};
exports.DocsLink = DocsLink;
var templateObject_1;
