"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getOsVariantDisplayText = exports.getOsTypeName = exports.interpolateMustache = exports.stripVersionBuild = exports.getExpanded = exports.OS_VARIANT_FULL_DISPLAY_TEXT_MAP = exports.FALLBACK_LOGO_UNKNOWN_DEVICE = void 0;
var template_1 = __importDefault(require("lodash/template"));
var models_1 = require("./models");
exports.FALLBACK_LOGO_UNKNOWN_DEVICE = 'https://dashboard.balena-cloud.com/img/unknown-device.svg';
exports.OS_VARIANT_FULL_DISPLAY_TEXT_MAP = {
    dev: 'Development',
    prod: 'Production',
};
var getExpanded = function (obj) {
    return (Array.isArray(obj) && obj[0]) || undefined;
};
exports.getExpanded = getExpanded;
var stripVersionBuild = function (version) {
    return version.replace(/(\.dev|\.prod)/, '');
};
exports.stripVersionBuild = stripVersionBuild;
var interpolateMustache = function (data, tpl) { return (0, template_1.default)(tpl, { interpolate: /{{([\s\S]+?)}}/g })(data); };
exports.interpolateMustache = interpolateMustache;
var getOsTypeName = function (osTypeSlug) {
    switch (osTypeSlug) {
        case models_1.OsTypesEnum.DEFAULT:
            return 'balenaOS';
        case models_1.OsTypesEnum.ESR:
            return 'balenaOS ESR';
        default:
            return 'unknown';
    }
};
exports.getOsTypeName = getOsTypeName;
var getOsVariantDisplayText = function (variant) {
    return exports.OS_VARIANT_FULL_DISPLAY_TEXT_MAP[variant] || variant;
};
exports.getOsVariantDisplayText = getOsVariantDisplayText;
