import { ButtonProps as GrommetButtonProps } from 'grommet';
import * as React from 'react';
import { Coloring, RenditionSystemProps, ResponsiveStyle, Sizing, Theme } from '../../common-types';
import { ConfirmOptions } from '../../internal/Confirm';
interface ButtonBaseProps extends Coloring, Sizing {
    width?: ResponsiveStyle;
    bg?: string;
    outline?: boolean;
    underline?: boolean;
    light?: boolean;
    compact?: boolean[];
}
export interface InternalButtonProps extends ButtonBaseProps, Omit<React.HTMLAttributes<HTMLElement>, 'dir' | 'color'>, GrommetButtonProps {
    type?: 'submit' | 'reset' | 'button';
    confirmation?: ConfirmOptions | string;
}
export type ButtonProps = InternalButtonProps & RenditionSystemProps;
export interface ThemedButtonProps extends ButtonProps {
    theme: Theme;
}
export declare const Button: React.ForwardRefExoticComponent<InternalButtonProps & import("../../common-types").StyledSystemProps & import("../../common-types").Tooltip & React.RefAttributes<any>>;
export {};
