import React from 'react';
import { mount } from 'enzyme';
import sinon from 'sinon';
import { Button, Provider } from '../../';
test('onClick is called after confirmation', function () {
    var handleClick = sinon.spy();
    var component = mount(React.createElement(Provider, null,
        React.createElement(Button, { confirmation: 'Sure?', onClick: handleClick, m: 2 }, "Click me")));
    expect(component.find('Popover Box[children="Sure?"]')).toHaveLength(0);
    component.find('button[children="Click me"]').simulate('click');
    expect(component.find('div[children="Sure?"]')).toHaveLength(1);
    component.find('button[children="Cancel"]').simulate('click');
    expect(handleClick.callCount).toEqual(0);
    component.find('button[children="Click me"]').simulate('click');
    component.find('button[children="OK"]').simulate('click');
    expect(handleClick.callCount).toEqual(1);
    expect(handleClick.lastCall.args[0]).toHaveProperty('target');
});
