import { __assign } from "tslib";
import React from 'react';
import { faExpand } from '@fortawesome/free-solid-svg-icons/faExpand';
import { faRecycle } from '@fortawesome/free-solid-svg-icons/faRecycle';
import { faSpinner } from '@fortawesome/free-solid-svg-icons/faSpinner';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { createTemplate, createStory } from '../../stories/utils';
import { Button } from '../Button';
import { ButtonGroup } from '.';
export default {
    title: 'Core/ButtonGroup',
    component: ButtonGroup,
    subcomponents: { Button: Button },
};
var OptionsDemoTemplate = function (props) {
    if (!('options' in props)) {
        return null;
    }
    if (typeof props.value !== 'object') {
        return null;
    }
    var _a = React.useState(props.value), selected = _a[0], setSelected = _a[1];
    return (React.createElement(ButtonGroup, __assign({}, props, { options: props.options, onGroupChange: setSelected, value: selected })));
};
var Template = createTemplate(ButtonGroup);
var OptionsTemplate = createTemplate(OptionsDemoTemplate);
export var Default = createStory(Template, {
    children: (React.createElement(React.Fragment, null,
        React.createElement(Button, null, "First"),
        React.createElement(Button, null, "Second"),
        React.createElement(Button, null, "Third"))),
});
export var GroupSelect = createStory(OptionsTemplate, {
    options: [
        { label: 'option 1', value: 'option1' },
        { label: 'option 2', value: 'option2' },
        { label: 'option 3', value: 'option3' },
    ],
    value: { label: 'option 2', value: 'option2' },
});
export var WithIconButton = createStory(Template, {
    children: (React.createElement(React.Fragment, null,
        React.createElement(Button, { icon: React.createElement(FontAwesomeIcon, { fixedWidth: true, icon: faExpand }) }),
        React.createElement(Button, { icon: React.createElement(FontAwesomeIcon, { fixedWidth: true, icon: faRecycle }) }),
        React.createElement(Button, { icon: React.createElement(FontAwesomeIcon, { fixedWidth: true, icon: faSpinner }) }))),
});
