import { __assign, __makeTemplateObject, __rest } from "tslib";
import React from 'react';
import styled from 'styled-components';
import { Flex } from '../Flex';
import { Button } from '../Button';
import { px } from '../../utils';
var ButtonGroupBase = styled(Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t", "\n\t", "\n"], ["\n\t", "\n\t", "\n"])), function (props) { return props.disabled && "cursor: not-allowed;"; }, function (props) {
    return props.isSelect
        ? "\n\t\t\tborder: 1px solid ".concat(props.theme.global.control.border.color, ";\n\t\t\twidth: fit-content;\n\t\t\tborder-radius: ").concat(props.theme.button.border.radius, ";\n\t\t\tpadding: 2px;\n\t\t\t> button {\n\t\t\t\tpadding: 2px 16px;\n\t\t\t\tborder: 0px;\n\t\t\t}\n\t\t")
        : "\n\t\t> * {\n\t\t\t&:first-child {\n\t\t\t\tborder-top-right-radius: 0;\n\t\t\t\tborder-bottom-right-radius: 0;\n\t\t\t\tpadding-left: ".concat(px(props.theme.space[3]), ";\n\t\t\t}\n\t\n\t\t\t&:last-child {\n\t\t\t\tborder-top-left-radius: 0;\n\t\t\t\tborder-bottom-left-radius: 0;\n\t\t\t\tpadding-right: ").concat(px(props.theme.space[3]), ";\n\t\t\t}\n\t\n\t\t\t&:not(:last-child) {\n\t\t\t\tborder-right: 0;\n\t\t\t}\n\t\n\t\t\t&:not(:last-child):not(:first-child) {\n\t\t\t\tborder-radius: 0;\n\t\t\t}\n\t\n\t\t\t&:hover {\n\t\t\t\tz-index: 1;\n\t\t\t}\n\t\t");
});
export var ButtonGroup = function (props) {
    if ('options' in props) {
        var onGroupChange_1 = props.onGroupChange, height_1 = props.height, disabled_1 = props.disabled, otherProps = __rest(props, ["onGroupChange", "height", "disabled"]);
        return (React.createElement(ButtonGroupBase, __assign({ isSelect: true }, otherProps, { alignItems: "center", disabled: !!disabled_1, tooltip: disabled_1 }), props.options.map(function (option) {
            var label = typeof option !== 'object' ? option : option.label;
            return (React.createElement(Button, { key: "".concat(label), active: typeof option !== 'object'
                    ? option === props.value
                    : option.value === props.value, tooltip: typeof option === 'object' ? option.tooltip : undefined, onClick: function () {
                    if (onGroupChange_1) {
                        onGroupChange_1(option);
                    }
                }, height: height_1, disabled: !!disabled_1 }, label));
        })));
    }
    if ('children' in props) {
        return React.createElement(ButtonGroupBase, __assign({}, props), props.children);
    }
    return null;
};
var templateObject_1;
