import { __assign, __makeTemplateObject, __rest } from "tslib";
import * as React from 'react';
import { Button } from '../Button';
import { Flex } from '../Flex';
import { Txt } from '../Txt';
import styled from 'styled-components';
import * as semver from 'semver';
import { ChangelogModal } from './ChangelogModal';
import { getFromLocalStorage, setToLocalStorage } from '../../utils';
var LAST_VIEWED_CHANGELOG_VERSION_STORAGE_KEY = 'last-viewed-changelog-version';
var NotificationBubble = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t", "\n\tborder-radius: 50%;\n\tpadding: 5px;\n\tposition: absolute;\n"], ["\n\t", "\n\tborder-radius: 50%;\n\tpadding: 5px;\n\tposition: absolute;\n"])), function (props) { return "\n\t\tbackground-color: ".concat(props.theme.colors.primary.main, ";\n\t"); });
export var ChangelogButton = function (_a) {
    var getChangelog = _a.getChangelog, latestChangelogVersion = _a.latestChangelogVersion, onClick = _a.onClick, style = _a.style, restProps = __rest(_a, ["getChangelog", "latestChangelogVersion", "onClick", "style"]);
    var _b = React.useState(false), showChangelogModal = _b[0], setShowChangelogModal = _b[1];
    var lastViewedChangelogVersion = React.useMemo(function () {
        return getFromLocalStorage(LAST_VIEWED_CHANGELOG_VERSION_STORAGE_KEY);
    }, [showChangelogModal]);
    React.useEffect(function () {
        if (!lastViewedChangelogVersion) {
            setToLocalStorage(LAST_VIEWED_CHANGELOG_VERSION_STORAGE_KEY, latestChangelogVersion);
        }
    }, []);
    React.useEffect(function () {
        if (showChangelogModal) {
            setToLocalStorage(LAST_VIEWED_CHANGELOG_VERSION_STORAGE_KEY, latestChangelogVersion);
        }
    }, [showChangelogModal]);
    React.useEffect(function () {
        if (lastViewedChangelogVersion &&
            latestChangelogVersion &&
            Number(lastViewedChangelogVersion.split('.')[0]) <
                Number(latestChangelogVersion.split('.')[0])) {
            setShowChangelogModal(true);
        }
    }, [lastViewedChangelogVersion]);
    return (React.createElement(Flex, { justifyContent: "flex-end" },
        React.createElement(Button, __assign({ color: "quartenary.main", onClick: function (e) {
                onClick === null || onClick === void 0 ? void 0 : onClick(e);
                setShowChangelogModal(true);
            }, style: __assign({ background: 'rgba(0, 0, 0, 0.1)', borderRadius: '2px', lineHeight: 1.1 }, style) }, restProps),
            React.createElement(Flex, { flexDirection: "column" },
                React.createElement(Txt, null, "Changelog"),
                latestChangelogVersion && React.createElement(Txt, null,
                    "v",
                    latestChangelogVersion))),
        lastViewedChangelogVersion &&
            latestChangelogVersion &&
            semver.lt(lastViewedChangelogVersion, latestChangelogVersion) && (React.createElement(NotificationBubble, null)),
        showChangelogModal && (React.createElement(ChangelogModal, { onDone: function () { return setShowChangelogModal(false); }, getChangelog: getChangelog }))));
};
var templateObject_1;
