import { __assign, __awaiter, __generator } from "tslib";
import * as React from 'react';
import { useRequest } from '../../hooks/useRequest';
import { Heading } from '../Heading';
import { Link } from '../Link';
import { Spinner } from '../Spinner';
var LazyMarkdown = React.lazy(function () { return __awaiter(void 0, void 0, void 0, function () {
    var importedModule;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, import('../../extra/Markdown')];
            case 1:
                importedModule = _a.sent();
                return [2, {
                        default: importedModule.Markdown,
                    }];
        }
    });
}); });
var markdownComponentOverrides = {
    a: function (props) { return React.createElement(Link, __assign({ blank: true }, props)); },
    h1: function (props) { return React.createElement(Heading.h1, __assign({}, props, { fontSize: "20px" })); },
    h2: function (props) { return React.createElement(Heading.h2, __assign({}, props, { fontSize: 3 })); },
    h3: function (props) { return React.createElement(Heading.h3, __assign({}, props, { fontSize: 2 })); },
    h4: function (props) { return React.createElement(Heading.h4, __assign({}, props, { fontSize: 1 })); },
};
export var Changelog = function (_a) {
    var getChangelog = _a.getChangelog;
    var _b = useRequest(function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4, getChangelog()];
            case 1: return [2, _a.sent()];
        }
    }); }); }, [], { polling: false }), changelog = _b[0], loading = _b[1];
    return (React.createElement(Spinner, { show: loading },
        React.createElement(React.Suspense, { fallback: null },
            React.createElement(LazyMarkdown, { componentOverrides: markdownComponentOverrides, disableAutoHeadingLinking: true, style: {
                    maxHeight: 'calc(100vh - 260px)',
                    overflowY: 'auto',
                } }, changelog !== null && changelog !== void 0 ? changelog : ''))));
};
