import { __assign } from "tslib";
import { normalizeDateTime } from './date-time-helpers';
export var operators = function () { return ({
    is: 'is',
    is_before: 'is before',
    is_after: 'is after',
}); };
export var createFilter = function (field, operator, value, schema) {
    var _a, _b, _c, _d;
    var operatorSlug = operator.slug;
    var type = schema.type;
    var normalizedValue = normalizeDateTime(value, type);
    if (value != null && normalizedValue == null) {
        return {};
    }
    if (operatorSlug === 'is') {
        return {
            properties: (_a = {},
                _a[field] = {
                    type: type !== null && type !== void 0 ? type : 'string',
                    format: 'date-time',
                    const: normalizedValue,
                },
                _a),
            required: [field],
        };
    }
    if (operatorSlug === 'is_not') {
        return {
            properties: (_b = {},
                _b[field] = {
                    type: type !== null && type !== void 0 ? type : 'string',
                    format: 'date-time',
                    not: {
                        const: normalizedValue,
                    },
                },
                _b),
            required: [field],
        };
    }
    if (operatorSlug === 'is_before') {
        var rule = type === 'number'
            ? { exclusiveMaximum: normalizedValue }
            : { formatMaximum: normalizedValue };
        return {
            properties: (_c = {},
                _c[field] = __assign({ type: type !== null && type !== void 0 ? type : 'string', format: 'date-time' }, rule),
                _c),
            required: [field],
        };
    }
    if (operatorSlug === 'is_after') {
        var rule = type === 'number'
            ? { exclusiveMinimum: normalizedValue }
            : { formatMinimum: normalizedValue };
        return {
            properties: (_d = {},
                _d[field] = __assign({ type: type !== null && type !== void 0 ? type : 'string', format: 'date-time' }, rule),
                _d),
            required: [field],
        };
    }
    return {};
};
