import { regexEscape } from '../../utils/index';
import { FULL_TEXT_SLUG } from '../Filters/SchemaSieve';
export var operators = function () { return ({
    is: 'is',
    is_not: 'is not',
}); };
export var createFilter = function (field, operator, value) {
    var _a, _b, _c;
    var operatorSlug = operator.slug;
    if (operatorSlug === FULL_TEXT_SLUG && typeof value === 'string') {
        return {
            properties: (_a = {},
                _a[field] = {
                    type: 'string',
                    regexp: {
                        pattern: regexEscape(value),
                        flags: 'i',
                    },
                },
                _a),
            required: [field],
        };
    }
    if (operatorSlug === 'is' || operatorSlug === FULL_TEXT_SLUG) {
        return {
            properties: (_b = {},
                _b[field] = {
                    const: value,
                },
                _b),
            required: [field],
        };
    }
    if (operatorSlug === 'is_not') {
        return {
            properties: (_c = {},
                _c[field] = {
                    not: {
                        const: value,
                    },
                },
                _c),
        };
    }
    return {};
};
