import * as arrayType from './array';
import * as booleanType from './boolean';
import * as dateTimeType from './date-time';
import * as enumType from './enum';
import * as numberType from './number';
import * as objectType from './object';
import * as oneOfType from './oneOf';
import * as stringType from './string';
export var isDateTimeFormat = function (format) {
    return format === null || format === void 0 ? void 0 : format.endsWith('date-time');
};
var typeMap = {
    array: arrayType,
    string: stringType,
    object: objectType,
    boolean: booleanType,
    number: numberType,
};
export var getDataModel = function (schema) {
    if (!schema) {
        return null;
    }
    var format = schema.format, type = schema.type;
    if (schema.enum) {
        return enumType;
    }
    if (schema.oneOf) {
        return oneOfType;
    }
    if (isDateTimeFormat(format)) {
        return dateTimeType;
    }
    var typeSet = Array.isArray(type) ? type : [type];
    var dataTypeKey = Object.keys(typeMap).find(function (t) { return typeSet.includes(t); });
    if (!dataTypeKey) {
        return null;
    }
    var dataType = typeMap[dataTypeKey];
    return dataType;
};
