import { FULL_TEXT_SLUG } from '../Filters/SchemaSieve';
export var operators = function () { return ({
    is: 'is',
    is_not: 'is not',
}); };
export var createFilter = function (field, operator, value, subSchema) {
    var _a, _b, _c;
    var _d;
    var operatorSlug = operator.slug;
    if (operatorSlug === FULL_TEXT_SLUG &&
        typeof value === 'string' &&
        ((_d = subSchema.oneOf) === null || _d === void 0 ? void 0 : _d.every(function (o) {
            return typeof o === 'object' &&
                typeof o.title === 'string' &&
                typeof o.const === 'string';
        }))) {
        var transformedEnum = subSchema.oneOf
            .filter(function (o) { return o.title.toLowerCase().includes(value.toLowerCase()); })
            .map(function (o) { return o.const; });
        if (transformedEnum.length) {
            return {
                properties: (_a = {},
                    _a[field] = {
                        enum: transformedEnum,
                    },
                    _a),
                required: [field],
            };
        }
    }
    if (operatorSlug === 'is' || operatorSlug === FULL_TEXT_SLUG) {
        return {
            properties: (_b = {},
                _b[field] = {
                    const: value,
                },
                _b),
            required: [field],
        };
    }
    if (operatorSlug === 'is_not') {
        return {
            properties: (_c = {},
                _c[field] = {
                    not: {
                        const: value,
                    },
                },
                _c),
        };
    }
    return {};
};
