import { regexEscape } from '../../utils';
import { FULL_TEXT_SLUG } from '../Filters/SchemaSieve';
export var operators = function () { return ({
    contains: 'contains',
    not_contains: 'does not contain',
    is: 'is',
    is_not: 'is not',
    matches_re: 'matches RegEx',
    not_matches_re: 'does not match RegEx',
}); };
export var createFilter = function (field, operator, value) {
    var _a, _b, _c, _d, _e, _f;
    var operatorSlug = operator.slug;
    if (operatorSlug === 'is') {
        return {
            properties: (_a = {},
                _a[field] = {
                    type: 'string',
                    const: value,
                },
                _a),
            required: [field],
        };
    }
    if (operatorSlug === 'is_not') {
        return {
            properties: (_b = {},
                _b[field] = {
                    type: 'string',
                    not: {
                        const: value,
                    },
                },
                _b),
            required: [field],
        };
    }
    if (operatorSlug === 'contains' || operatorSlug === FULL_TEXT_SLUG) {
        return {
            properties: (_c = {},
                _c[field] = {
                    type: 'string',
                    regexp: {
                        pattern: regexEscape(value),
                        flags: 'i',
                    },
                },
                _c),
            required: [field],
        };
    }
    if (operatorSlug === 'not_contains') {
        return {
            properties: (_d = {},
                _d[field] = {
                    not: {
                        type: 'string',
                        regexp: {
                            pattern: regexEscape(value),
                            flags: 'i',
                        },
                    },
                },
                _d),
        };
    }
    if (operatorSlug === 'matches_re') {
        return {
            properties: (_e = {},
                _e[field] = {
                    type: 'string',
                    pattern: value,
                },
                _e),
            required: [field],
        };
    }
    if (operatorSlug === 'not_matches_re') {
        return {
            properties: (_f = {},
                _f[field] = {
                    type: 'string',
                    not: {
                        pattern: value,
                    },
                },
                _f),
        };
    }
    return {};
};
