import { __assign, __spreadArray } from "tslib";
import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { DropDownButton } from '.';
import { Button } from '../Button';
import { Box } from '../Box';
import { Divider } from '../Divider';
var NonZeroOrderedButton = function (props) {
    var _a;
    if (!props.i) {
        return null;
    }
    return (React.createElement(Button, { plain: true }, (_a = props.children) !== null && _a !== void 0 ? _a : "Non-zero indexed item ".concat(props.i)));
};
var OddIndexedButton = function (props) {
    if (props.i % 2 === 0) {
        return null;
    }
    return (React.createElement(NonZeroOrderedButton, { i: props.i },
        "Odd indexed item ",
        props.i));
};
var sampleChildren = __spreadArray(__spreadArray(__spreadArray(__spreadArray([
    React.createElement(Button, { plain: true }, "Item")
], [0, 1, 2, 3].map(function (i) { return React.createElement(NonZeroOrderedButton, { i: i }); }), true), [
    React.createElement(Button, { plain: true }, "Item"),
    React.createElement(Divider, null),
    React.createElement(Button, { plain: true }, "Item")
], false), [0, 1, 2, 3].map(function (i) { return React.createElement(OddIndexedButton, { i: i }); }), true), [
    React.createElement(Button, { plain: true }, "Item"),
], false);
export default {
    title: 'Core/DropDownButton',
    component: DropDownButton,
};
var OpenUpStory = function (props) {
    return (React.createElement(Box, { mt: "300px" },
        React.createElement(DropDownButton, __assign({}, props))));
};
var OpenUpTemplate = createTemplate(OpenUpStory);
var Template = createTemplate(DropDownButton);
export var Default = createStory(Template, {
    label: 'Dropdown',
    children: sampleChildren,
});
export var BorderedList = createStory(Template, {
    label: 'Dropdown',
    border: true,
    children: sampleChildren,
});
export var Joined = createStory(Template, {
    label: 'Dropdown',
    joined: true,
    children: sampleChildren,
});
export var WithPrimaryButton = createStory(Template, {
    label: 'Dropdown',
    joined: true,
    primary: true,
    children: sampleChildren,
});
export var IconOnly = createStory(Template, {
    joined: true,
    primary: true,
    children: sampleChildren,
});
export var NoListFormatting = createStory(Template, {
    noListFormat: true,
    primary: true,
    children: sampleChildren,
});
export var DropUp = createStory(OpenUpTemplate, {
    label: 'Dropdown',
    dropUp: true,
    children: sampleChildren,
});
