import { __assign, __extends, __makeTemplateObject, __rest } from "tslib";
import { faChevronDown } from '@fortawesome/free-solid-svg-icons/faChevronDown';
import { faChevronUp } from '@fortawesome/free-solid-svg-icons/faChevronUp';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import * as React from 'react';
import styled from 'styled-components';
import asRendition from '../../asRendition';
import { useBreakpoint } from '../../hooks/useBreakpoint';
import { px, stopEvent } from '../../utils';
import { Box } from '../Box';
import { Button } from '../Button';
import { Divider } from '../Divider';
import { Fixed } from '../Fixed';
import { Flex } from '../Flex';
var TOGGLE_BUTTON_X_PADDING = 16;
var CHEVRON_ICON_WIDTH = 12;
var TOGGLE_BUTTON_WIDTH = 2 * TOGGLE_BUTTON_X_PADDING + CHEVRON_ICON_WIDTH;
var ToggleBase = styled(Button)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tmin-width: 0;\n\tborder-top-left-radius: 0;\n\tborder-bottom-left-radius: 0;\n\tborder-left: 0;\n\tmargin: 0;\n\tvertical-align: top;\n\tpadding: 0 ", ";\n\twidth: ", ";\n"], ["\n\tmin-width: 0;\n\tborder-top-left-radius: 0;\n\tborder-bottom-left-radius: 0;\n\tborder-left: 0;\n\tmargin: 0;\n\tvertical-align: top;\n\tpadding: 0 ", ";\n\twidth: ", ";\n"])), px(TOGGLE_BUTTON_X_PADDING), px(TOGGLE_BUTTON_WIDTH));
var ButtonBase = styled(Button)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tborder-top-right-radius: 0;\n\tborder-bottom-right-radius: 0;\n\tborder-right: 0;\n\tmargin: 0;\n\twidth: calc(100% - ", ");\n"], ["\n\tborder-top-right-radius: 0;\n\tborder-bottom-right-radius: 0;\n\tborder-right: 0;\n\tmargin: 0;\n\twidth: calc(100% - ", ");\n"])), px(TOGGLE_BUTTON_WIDTH));
var MenuBase = styled(Box)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tbackground: white;\n\tposition: absolute;\n\tborder-radius: ", ";\n\tborder: ", ";\n\tz-index: 1;\n\tmargin-top: ", ";\n\tmargin-bottom: ", ";\n\tbottom: ", ";\n\tleft: ", ";\n\tright: ", ";\n\twidth: 200px;\n\toverflow-y: auto;\n\toverflow-x: hidden;\n"], ["\n\tbackground: white;\n\tposition: absolute;\n\tborder-radius: ", ";\n\tborder: ", ";\n\tz-index: 1;\n\tmargin-top: ", ";\n\tmargin-bottom: ", ";\n\tbottom: ", ";\n\tleft: ", ";\n\tright: ", ";\n\twidth: 200px;\n\toverflow-y: auto;\n\toverflow-x: hidden;\n"])), function (props) { return px(props.theme.radius); }, function (props) { return '1px solid ' + props.theme.colors.gray.main; }, function (props) { return (props.dropUp ? 0 : '2px'); }, function (props) { return (props.dropUp ? '2px' : 0); }, function (props) { return (props.dropUp ? props.theme.button.height : 'auto'); }, function (props) { return (props.alignRight ? 'auto' : 0); }, function (props) { return (!props.alignRight ? 'auto' : 0); });
var Wrapper = styled(Box)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\tdisplay: inline-block;\n\tborder-radius: ", ";\n\tvertical-align: top;\n\tposition: relative;\n\n\tsvg {\n\t\twidth: ", ";\n\t\ttransform: translateY(1px);\n\t}\n"], ["\n\tdisplay: inline-block;\n\tborder-radius: ", ";\n\tvertical-align: top;\n\tposition: relative;\n\n\tsvg {\n\t\twidth: ", ";\n\t\ttransform: translateY(1px);\n\t}\n"])), function (props) { return px(props.theme.radius); }, px(CHEVRON_ICON_WIDTH));
var getHoverStyle = function (props) { return "\n\t".concat(props.hasActionFn &&
    "&:hover {\n\tbackground: #dde1f0; // This is the background color Select uses for entities on hover. We do not have it in our theme\n\tcursor: ".concat(props.disabled ? 'not-allowed' : 'pointer', ";}")); };
var getDangerStyle = function (props) { return "\n\t".concat(props.danger && "color: ".concat(props.theme.colors.danger.main, ";"), "\n\t"); };
var getDisabledStyle = function (props) { return "\n\t".concat(props.disabled && "opacity: 1; color: ".concat(props.theme.colors.gray.main, ";"), "\n\t"); };
var Item = styled(Box)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\t", "\n\t", "\n\t", "\n"], ["\n\t", "\n\t", "\n\t", "\n"])), getHoverStyle, getDangerStyle, getDisabledStyle);
var JoinedButton = styled(Button)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n\tmargin: 0;\n\twidth: 100%;\n"], ["\n\tmargin: 0;\n\twidth: 100%;\n"])));
var Toggle = function (_a) {
    var open = _a.open, handler = _a.handler, label = _a.label, joined = _a.joined, compact = _a.compact, items = _a.items, props = __rest(_a, ["open", "handler", "label", "joined", "compact", "items"]);
    var toggleProps = __assign(__assign({}, props), { type: 'button', onClick: handler });
    var icon = open ? faChevronUp : faChevronDown;
    var shouldCompact = useBreakpoint(compact || [false]);
    if (joined) {
        if (label || props.icon) {
            return (React.createElement(JoinedButton, __assign({}, toggleProps),
                React.createElement(Flex, { justifyContent: "space-between", alignItems: "center" },
                    !shouldCompact && React.createElement(Box, { mr: 2 }, label),
                    React.createElement(FontAwesomeIcon, { icon: icon }))));
        }
        return (React.createElement(JoinedButton, __assign({}, toggleProps, { icon: React.createElement(FontAwesomeIcon, { icon: icon }) })));
    }
    return React.createElement(ToggleBase, __assign({}, toggleProps, { icon: React.createElement(FontAwesomeIcon, { icon: icon }) }));
};
var BaseDropDownButton = (function (_super) {
    __extends(BaseDropDownButton, _super);
    function BaseDropDownButton(props) {
        var _this = _super.call(this, props) || this;
        _this.handleOutsideClick = function (e) {
            if (_this.dropdownNode && !_this.dropdownNode.contains(e.target)) {
                if (_this.state.open) {
                    _this.removeListener();
                    _this.setState({
                        open: false,
                    });
                }
            }
        };
        _this.toggle = function () {
            var isNextOpen = !_this.state.open;
            if (isNextOpen) {
                document.addEventListener('click', _this.handleOutsideClick);
            }
            else if (!_this.props.keepOpenOnItemClick) {
                _this.removeListener();
            }
            _this.setState({
                open: !_this.props.keepOpenOnItemClick ? isNextOpen : true,
            });
        };
        _this.removeListener = function () {
            document.removeEventListener('click', _this.handleOutsideClick);
        };
        _this.state = {
            open: false,
        };
        return _this;
    }
    BaseDropDownButton.prototype.componentWillUnmount = function () {
        if (this.state.open) {
            this.removeListener();
        }
    };
    BaseDropDownButton.prototype.render = function () {
        var _this = this;
        var _a;
        var _b = this.props, dropUp = _b.dropUp, alignRight = _b.alignRight, children = _b.children, label = _b.label, border = _b.border, joined = _b.joined, noListFormat = _b.noListFormat, outline = _b.outline, className = _b.className, onClick = _b.onClick, items = _b.items, props = __rest(_b, ["dropUp", "alignRight", "children", "label", "border", "joined", "noListFormat", "outline", "className", "onClick", "items"]);
        return (React.createElement(Wrapper, __assign({ className: className, onClick: joined ? onClick : undefined }, props, { ref: function (node) { return (_this.dropdownNode = node); } }),
            joined ? (React.createElement(Toggle, __assign({}, props, { onClick: onClick, outline: outline, joined: joined, label: label, handler: this.toggle, open: this.state.open, items: items }))) : (React.createElement("span", null,
                React.createElement(ButtonBase, __assign({}, props, { onClick: onClick, outline: outline }), label),
                React.createElement(Toggle, __assign({}, props, { outline: outline, onMouseEnter: stopEvent, handler: this.toggle, open: this.state.open, items: items })))),
            this.state.open && React.createElement(Fixed, { onClick: this.toggle }),
            this.state.open && (React.createElement(MenuBase, { dropUp: dropUp, alignRight: alignRight, onClick: function () { return (!items ? _this.toggle() : undefined); }, maxHeight: px((_a = this.props.listMaxHeight) !== null && _a !== void 0 ? _a : 300) }, items
                ? items.map(function (itemGroup, i) { return (React.createElement(Box, { key: i },
                    itemGroup.map(function (item, j) { return (React.createElement(Item, { px: 3, py: 1, onClick: function (event) {
                            if (!item.disabled && item.onClick) {
                                item.onClick(event);
                                _this.toggle();
                            }
                        }, tooltip: item.tooltip, disabled: item.disabled, danger: item.danger, hasActionFn: !!item.onClick, key: j }, item.content)); }),
                    i < items.length - 1 && React.createElement(Divider, null))); })
                : React.Children.map(children, function (child, i) {
                    if (noListFormat) {
                        return child;
                    }
                    if (!child) {
                        return;
                    }
                    if (child.type === Divider) {
                        return child;
                    }
                    return (React.createElement(Item, { px: 3, py: 1, hasActionFn: false, key: i }, child));
                })))));
    };
    return BaseDropDownButton;
}(React.Component));
export var DropDownButton = asRendition(BaseDropDownButton, [], ['color', 'bg', 'backgroundColor']);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;
