import { __assign, __rest } from "tslib";
import * as React from 'react';
import { Tag } from '../Tag';
import { findInObject } from '../../utils';
var parseFilter = function (filter) {
    if (!filter) {
        return {};
    }
    try {
        return JSON.parse(filter.description);
    }
    catch (err) {
        return { value: filter.description };
    }
};
var FilterDescription = function (_a) {
    var _b;
    var filter = _a.filter, props = __rest(_a, ["filter"]);
    var tagProps = ((_b = filter.anyOf) === null || _b === void 0 ? void 0 : _b.map(function (filterFragment, i) {
        var _a, _b;
        var parsedFilter = parseFilter(filterFragment);
        var format = findInObject(filterFragment, 'format');
        parsedFilter.name = parsedFilter.title;
        parsedFilter.operator = (_b = (_a = parsedFilter.operator) === null || _a === void 0 ? void 0 : _a.label) === null || _b === void 0 ? void 0 : _b.replace("".concat(parsedFilter.title, " "), '');
        if (parsedFilter.label) {
            parsedFilter.value = parsedFilter.label;
        }
        if (typeof parsedFilter.value === 'boolean') {
            parsedFilter.value = JSON.stringify(parsedFilter.value);
        }
        if (typeof parsedFilter.value === 'object') {
            parsedFilter.value = Object.entries(parsedFilter.value)
                .map(function (_a) {
                var key = _a[0], value = _a[1];
                return "".concat(key, ": ").concat(value);
            })
                .join(', ');
        }
        if (format === 'date-time') {
            var date = new Date(parsedFilter.value);
            parsedFilter.value = "".concat(date.toLocaleDateString(), " ").concat(date.toLocaleTimeString());
        }
        if (i > 0) {
            parsedFilter.prefix = 'or';
        }
        return parsedFilter;
    })) || [parseFilter(filter)];
    return React.createElement(Tag, __assign({ mt: 2, multiple: tagProps }, props));
};
export default FilterDescription;
