import React from 'react';
import { Button } from '../Button';
import { Flex } from '../Flex';
import { Form } from '../Form';
import { Modal } from '../Modal';
import { Txt } from '../Txt';
import FilterDescription from './FilterDescription';
var schema = {
    type: 'object',
    properties: {
        name: { type: 'string' },
    },
};
export var Summary = function (_a) {
    var filters = _a.filters, onEdit = _a.onEdit, onDelete = _a.onDelete, onClearFilters = _a.onClearFilters, showSaveView = _a.showSaveView, onSaveView = _a.onSaveView;
    var _b = React.useState(false), showViewForm = _b[0], setShowViewForm = _b[1];
    var _c = React.useState(), viewData = _c[0], setViewData = _c[1];
    return (React.createElement(React.Fragment, null,
        React.createElement(Flex, { flex: "1", flexDirection: "column" },
            React.createElement(Flex, { flex: "1", justifyContent: "space-between" },
                React.createElement(Flex, null,
                    React.createElement(Txt, { bold: true }, "Filters"),
                    React.createElement(Txt, { mr: 1 },
                        "(",
                        filters.length,
                        ")"),
                    React.createElement(Button, { plain: true, primary: true, onClick: onClearFilters }, "Clear all")),
                showSaveView && (React.createElement(Flex, null,
                    React.createElement(Button, { plain: true, primary: true, onClick: function () { return setShowViewForm(true); } }, "Save view")))),
            React.createElement(Flex, { flexWrap: "wrap" }, filters.map(function (filter, index) { return (React.createElement(FilterDescription, { key: filter.$id || index, filter: filter, onClick: function () {
                    onEdit(filter);
                }, onClose: function () { return onDelete(filter); } })); }))),
        showViewForm && (React.createElement(Modal, { title: "Save current view", cancel: function () { return setShowViewForm(false); }, done: function () {
                if (!(viewData === null || viewData === void 0 ? void 0 : viewData.name)) {
                    return;
                }
                onSaveView(viewData);
                setShowViewForm(false);
            }, action: "Save", primaryButtonProps: {
                disabled: !(viewData === null || viewData === void 0 ? void 0 : viewData.name),
            } },
            React.createElement(Form, { width: "100%", hideSubmitButton: true, liveValidate: true, onFormChange: function (_a) {
                    var formData = _a.formData;
                    return setViewData(formData);
                }, schema: schema, value: viewData })))));
};
