import React from 'react';
import type { JSONSchema7 as JSONSchema } from 'json-schema';
import { ButtonProps } from '../Button';
import { DropDownButtonProps } from '../DropDownButton';
import { Operator } from './SchemaSieve';
import { OperatorSlugs } from '../DataTypes';
export interface FilterSignature {
    title: string | undefined;
    field: string;
    operator: Operator<OperatorSlugs>;
    value: any;
    label?: string;
    refScheme?: string;
}
export interface FilterFieldOption {
    field: string;
    title: string;
}
export type FilterFieldCompareFn = (a: FilterFieldOption, b: FilterFieldOption) => number;
export type FilterRenderMode = 'all' | 'add' | 'search' | 'views' | 'summary';
export interface FiltersView {
    id: string;
    name: string;
    filters: JSONSchema[];
}
export interface FiltersProps {
    disabled?: boolean;
    filters?: JSONSchema[];
    views?: FiltersView[];
    onFiltersUpdate?: (filters: JSONSchema[]) => void;
    onViewsUpdate?: (views: FiltersView[]) => void;
    onSearch?: (searchTerm: string) => React.ReactElement | null;
    schema: JSONSchema;
    addFilterButtonProps?: ButtonProps;
    showSaveView?: boolean;
    viewsMenuButtonProps?: DropDownButtonProps;
    renderMode?: FilterRenderMode | FilterRenderMode[];
    dark?: boolean;
    compact?: boolean[];
    filterFieldCompareFn?: FilterFieldCompareFn;
}
export declare const Filters: ({ disabled, filters, views, schema, addFilterButtonProps, viewsMenuButtonProps, renderMode, dark, compact, showSaveView, onViewsUpdate, onFiltersUpdate, onSearch, }: FiltersProps) => React.JSX.Element;
