import { __assign } from "tslib";
import * as React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Box, Flex, Txt } from '../..';
import { Markdown } from '../../extra/Markdown';
import { Form } from '.';
window.RECAPTCHA_V2_API_KEY = '6Ld-faYUAAAAAF92j1FX-GgG0uNPbw9sCCmnbJ2D';
import zxcvbn from 'zxcvbn';
window.zxcvbn = zxcvbn;
var extraWidgetsReadme = "\n# Extra widgets\nAdditional widgets for handling different formats can be registered using the `Form.registerWidget` method.\nRendition contains widgets for rendering Markdown and Mermaid text formats that can be used in the following way:\n```js\nimport * as React from 'react'\nimport * as ReactDOM from 'react-dom'\nimport { Form } from 'rendition'\nimport { MermaidWidget } from 'rendition/dist/components/Form/mermaid'\nimport { MarkdownWidget } from 'rendition/dist/components/Form/markdown'\n\nconst schema = {\n  type: 'object',\n  properties: {\n    Markdown: {\n      format: 'markdown',\n      type: 'string'\n    },\n    Mermaid: {\n      format: 'mermaid',\n      type: 'string'\n    }\n  }\n}\n\nconst rootElement = document.getElementById('root')\nReactDOM.render(<Form schema={schema} extraFormats={[{name: 'markdown', format: '.*', widget: MarkdownWidget}, {name: 'mermaid', format: '.*', widget: MermaidWidget}]} />, rootElement)\n```\n";
var basicPokedexSchema = {
    type: 'object',
    title: 'Pokèmon',
    properties: {
        Name: {
            type: 'string',
            minLength: 5,
            examples: ['Pikachu', 'Snorlax', 'Charmander', 'Bulbasaur'],
        },
        Height: {
            type: 'number',
        },
        Weight: {
            type: 'number',
        },
        Description: {
            type: 'string',
        },
        Category: {
            type: 'string',
            maxLength: 20,
        },
        Abilities: {
            type: 'string',
        },
        pokedex_number: {
            title: 'National Pokèdex Number',
            type: 'number',
        },
        caught: {
            type: 'boolean',
        },
        first_seen: {
            title: 'First seen',
            description: 'The first time you saw this pokèmon',
            type: 'string',
            format: 'date-time',
        },
        poke_password: {
            title: 'Poke Password',
            description: "Password to access the pokèmon's abilities",
            type: 'string',
        },
        environment: {
            type: 'string',
            oneOf: [
                {
                    const: 'earth',
                    title: 'Earth',
                },
                {
                    const: 'water',
                    title: 'Water',
                },
                {
                    const: 'fire',
                    title: 'Fire',
                },
            ],
        },
        tags: {
            title: 'Tags',
            description: 'Add useful tags to your pokèmon',
            type: 'array',
            items: {
                type: 'string',
            },
        },
    },
};
var basicPokedexUiSchema = {
    'ui:order': ['Name', 'caught', 'Description', 'Abilities', '*'],
    Name: {
        'ui:autocomplete': 'on',
    },
    poke_password: {
        'ui:widget': 'password',
        'ui:options': {
            showPasswordStrengthMeter: true,
        },
    },
    Height: {
        'ui:options': {
            emphasized: true,
        },
    },
    environment: {
        'ui:options': {
            emphasized: true,
        },
    },
    Description: {
        'ui:widget': 'textarea',
        'ui:options': {
            rows: 5,
        },
    },
};
var FormDemo = function (props) {
    var _a;
    var _b = React.useState((_a = props.value) !== null && _a !== void 0 ? _a : {}), data = _b[0], setData = _b[1];
    return (React.createElement(Flex, null,
        React.createElement(Box, { flex: "1", m: 30 },
            React.createElement(Form, __assign({ onFormChange: function (_a) {
                    var formData = _a.formData;
                    return setData(formData);
                }, value: data }, props))),
        React.createElement(Box, { flex: "1", maxWidth: "50%", p: 30 },
            React.createElement(Txt, { monospace: true },
                React.createElement("pre", null, JSON.stringify(data, null, 4))))));
};
export default {
    title: 'Core/Form',
    component: Form,
};
var Template = createTemplate(FormDemo);
export var Default = createStory(Template, {
    schema: basicPokedexSchema,
});
export var HiddenSubmit = createStory(Template, {
    schema: basicPokedexSchema,
    hideSubmitButton: true,
});
export var SecondaryAction = createStory(Template, {
    schema: basicPokedexSchema,
    secondaryButtonProps: { children: 'Skip' },
});
export var Disabled = createStory(Template, {
    schema: basicPokedexSchema,
    disabled: true,
});
export var CustomSubmitText = createStory(Template, {
    schema: basicPokedexSchema,
    submitButtonText: 'Save',
});
export var WithUiSchema = createStory(Template, {
    schema: basicPokedexSchema,
    uiSchema: basicPokedexUiSchema,
    formData: {
        poke_password: 'Secret password',
    },
});
export var WithWarning = createStory(Template, {
    schema: basicPokedexSchema,
    uiSchema: __assign(__assign({}, basicPokedexUiSchema), { Name: {
            'ui:warning': 'Once the `Name` is set it cannot be changed',
        } }),
});
export var WithHelpText = createStory(Template, {
    schema: basicPokedexSchema,
    uiSchema: __assign(__assign({}, basicPokedexUiSchema), { Name: {
            'ui:help': 'Once the `Name` is set it cannot be changed',
        } }),
});
export var WithTitles = createStory(Template, {
    schema: {
        type: 'object',
        title: 'Networking',
        properties: {
            vpn: {
                type: 'object',
                title: 'Virtual Private Network',
                properties: {
                    endpoint: {
                        title: 'Endpoint',
                        type: 'string',
                    },
                    certificate: {
                        title: 'Certificate',
                        type: 'string',
                    },
                },
            },
            wifiNetwork: {
                type: 'object',
                title: 'WiFi Network',
                properties: {
                    wifi: {
                        type: 'object',
                        properties: {
                            ssid: {
                                title: 'Network SSID',
                                type: 'string',
                            },
                        },
                    },
                    wifiSecurity: {
                        type: 'object',
                        properties: {
                            psk: {
                                title: 'Network Passphrase',
                                type: 'string',
                            },
                        },
                    },
                },
            },
        },
    },
});
export var WithExtraWidgets = createStory(Template, {
    schema: {
        type: 'object',
        properties: {
            Mermaid: {
                type: 'string',
                format: 'mermaid',
            },
            Markdown: {
                type: 'string',
                format: 'markdown',
            },
            Captcha: {
                type: 'string',
                format: 'captcha',
            },
        },
    },
});
WithExtraWidgets.decorators = [
    function (Story) { return (React.createElement(React.Fragment, null,
        React.createElement(Box, { px: 30, pt: 30 },
            React.createElement(Markdown, null, extraWidgetsReadme)),
        React.createElement(Story, null))); },
];
export var WithPatternProperties = createStory(Template, {
    schema: {
        type: 'object',
        properties: {
            dynamicObject: {
                patternProperties: {
                    '^[0-9]+$': {
                        title: 'Rule',
                        type: 'string',
                    },
                },
                title: 'Rules',
                type: 'object',
            },
        },
    },
    formData: {
        dynamicObject: {
            123: 'foo',
        },
    },
});
var enumValues = ['First', 'Second', 'Third'];
export var WithDependants = createStory(Template, {
    schema: {
        type: 'object',
        properties: {
            application_config_variable: {
                title: 'Application configuration variables',
                type: 'array',
                items: {
                    type: 'object',
                    properties: {
                        name: {
                            title: 'Name',
                            enum: enumValues,
                        },
                    },
                    dependencies: {
                        name: {
                            oneOf: enumValues.map(function (name) {
                                return {
                                    description: 'Enter some value',
                                    properties: {
                                        name: {
                                            enum: [name],
                                        },
                                        value: {
                                            title: 'Value',
                                            enum: ['false', 'true'],
                                            default: 'true',
                                            description: undefined,
                                        },
                                    },
                                };
                            }),
                        },
                    },
                },
            },
            application_environment_variable: {
                type: 'array',
                title: 'Application environment variables',
                items: {
                    type: 'object',
                    properties: {
                        name: {
                            title: 'Name',
                            type: 'string',
                        },
                        value: {
                            title: 'Value',
                            type: 'string',
                        },
                    },
                },
            },
        },
    },
    uiSchema: {
        application_config_variable: {
            'ui:options': {
                orderable: false,
            },
            items: {
                'ui:options': {
                    responsive: true,
                    flex: ['2 2 200px', '1 1 100px'],
                },
            },
        },
        application_environment_variable: {
            'ui:options': {
                orderable: false,
            },
            items: {
                'ui:options': {
                    responsive: true,
                    flex: ['2 2 200px', '1 1 100px'],
                },
            },
        },
    },
    formData: {
        application_config_variable: [{}],
        application_environment_variable: [{}],
    },
});
