import { __assign } from "tslib";
import * as React from 'react';
import { Select } from '../../Select';
var SelectWidget = function (props) {
    var id = props.id, options = props.options, value = props.value, disabled = props.disabled, readonly = props.readonly, onChange = props.onChange;
    var enumOptions = options.enumOptions, enumDisabled = options.enumDisabled;
    if (!Array.isArray(enumOptions)) {
        return null;
    }
    var sanitizedEnumDisabled = Array.isArray(enumDisabled)
        ? enumDisabled
        : null;
    var selectOptions = enumOptions.map(function (option) {
        return __assign(__assign({}, option), { disabled: sanitizedEnumDisabled != null &&
                sanitizedEnumDisabled.includes(option.value) });
    });
    return (React.createElement(Select, { width: "100%", id: id, value: value !== undefined
            ? selectOptions.find(function (option) { return option.value === value; })
            : undefined, disabled: disabled || readonly, onChange: function (_a) {
            var option = _a.option;
            onChange(option.value);
        }, options: selectOptions, emphasized: options.emphasized, valueKey: "value", labelKey: "label", disabledKey: "disabled" }));
};
export default SelectWidget;
