import { TextInputProps as GrommetTextInputProps } from 'grommet';
import * as React from 'react';
import { Omit, RenditionSystemProps } from '../../common-types';
export interface InternalInputProps extends GrommetTextInputProps, Omit<React.HTMLAttributes<HTMLInputElement>, 'onSelect' | 'placeholder'> {
    onChange?: React.ChangeEventHandler<HTMLInputElement>;
    type?: string;
    autoFocus?: boolean;
    autoComplete?: string;
    readOnly?: boolean;
    disabled?: boolean;
    pattern?: string;
    maxLength?: number;
    form?: string;
    invalid?: boolean;
    valid?: boolean;
    emphasized?: boolean;
    monospace?: boolean;
    list?: string;
    min?: string | number;
    max?: string | number;
}
export type InputProps = InternalInputProps & RenditionSystemProps & {
    ref?: React.Ref<HTMLInputElement | null>;
};
export declare const Input: React.FunctionComponent<InputProps>;
