import { __assign, __makeTemplateObject } from "tslib";
import * as React from 'react';
import styled from 'styled-components';
import { useBreakpoint } from '../../hooks/useBreakpoint';
import { default as InternalErrorBoundary } from '../../internal/ErrorBoundary';
import { Box } from '../Box';
import { Sidebar } from '../Sidebar';
import { Header } from './Header';
var Grid = styled(Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: grid;\n\tgrid-template-areas: ", ";\n\tgrid-template-rows: ", ";\n\tgrid-template-columns: ", ";\n"], ["\n\tdisplay: grid;\n\tgrid-template-areas: ", ";\n\tgrid-template-rows: ", ";\n\tgrid-template-columns: ", ";\n"])), function (props) { return props.gridTemplateAreas; }, function (props) { return props.gridTemplateRows; }, function (props) { return props.gridTemplateColumns; });
var GridItem = styled(Box)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tgrid-area: ", ";\n"], ["\n\tgrid-area: ", ";\n"])), function (props) { return props.gridArea; });
export var Layout = function (_a) {
    var header = _a.header, footer = _a.footer, leftSider = _a.leftSider, contentHeader = _a.contentHeader, children = _a.children, ErrorBoundary = _a.ErrorBoundary, isSidebarCollapsed = _a.isSidebarCollapsed, setIsSidebarCollapsed = _a.setIsSidebarCollapsed;
    var templateAreas = "\n\t\t\"leftSider header\"\n\t\t\"leftSider contentHeader\"\n\t\t\"leftSider content\"\n\t\t\"footer footer\"\n\t";
    var templateRows = "\n\t\t[header header] max-content\n\t\t[contentHeader] max-content\n\t\t[content] minmax(0,1fr)\n\t\t[footer footer] max-content\n\t";
    var templateColumns = "\n\t\t[leftSider] max-content\n\t\t[content] minmax(0, 1fr)\n\t";
    var mobile = useBreakpoint([true, true, false]);
    var _b = React.useState(true), collapsed = _b[0], setCollapsed = _b[1];
    React.useEffect(function () {
        if (mobile) {
            (setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed)(true);
        }
        else {
            (setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed)(false);
        }
    }, [mobile]);
    var ErrorBoundaryComponent = React.useCallback(function (_a) {
        var children = _a.children;
        return ErrorBoundary ? (React.createElement(ErrorBoundary, null, children)) : (React.createElement(InternalErrorBoundary, null, children));
    }, [ErrorBoundary]);
    return (React.createElement(Grid, { bg: "transparent", height: "100%", gridTemplateAreas: templateAreas.trim(), gridTemplateRows: templateRows.trim(), gridTemplateColumns: templateColumns },
        header && (React.createElement(GridItem, { gridArea: "header" },
            React.createElement(ErrorBoundaryComponent, null, React.isValidElement(header) ? (header) : typeof header === 'object' ? (React.createElement(Header, __assign({ isSidebarCollapsed: isSidebarCollapsed !== null && isSidebarCollapsed !== void 0 ? isSidebarCollapsed : collapsed, setIsSidebarCollapsed: setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed }, header))) : (header(isSidebarCollapsed !== null && isSidebarCollapsed !== void 0 ? isSidebarCollapsed : collapsed, setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed))))),
        leftSider && (React.createElement(GridItem, { style: {
                overflowY: 'auto',
            }, gridArea: "leftSider" }, React.isValidElement(leftSider) ? (leftSider) : typeof leftSider === 'object' ? (React.createElement(ErrorBoundaryComponent, null,
            React.createElement(Sidebar, __assign({}, (!mobile && {
                isCollapsed: isSidebarCollapsed !== null && isSidebarCollapsed !== void 0 ? isSidebarCollapsed : collapsed,
                setIsCollapsed: setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed,
            }), leftSider)))) : (leftSider(isSidebarCollapsed !== null && isSidebarCollapsed !== void 0 ? isSidebarCollapsed : collapsed, setIsSidebarCollapsed !== null && setIsSidebarCollapsed !== void 0 ? setIsSidebarCollapsed : setCollapsed)))),
        contentHeader && (React.createElement(GridItem, { gridArea: "contentHeader" }, React.createElement(ErrorBoundaryComponent, null, contentHeader))),
        React.createElement(GridItem, { style: {
                flexDirection: 'column',
                display: 'flex',
                overflowY: 'auto',
            }, gridArea: "content" },
            React.createElement(ErrorBoundaryComponent, null, children)),
        footer && (React.createElement(GridItem, { gridArea: "footer" },
            React.createElement(ErrorBoundaryComponent, null, footer)))));
};
var templateObject_1, templateObject_2;
