import { __assign } from "tslib";
import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Box, Button, Heading, Txt } from '../../';
import { Modal } from '.';
import PokeDex from '../../stories/assets/pokedex';
var NestedModalDemo = function (props) {
    var _a = React.useState(false), show1 = _a[0], setShow1 = _a[1];
    var _b = React.useState(false), show2 = _b[0], setShow2 = _b[1];
    return (React.createElement(Box, null,
        React.createElement(Button, { primary: true, onClick: function () { return setShow1(true); } }, "Open Modal"),
        show1 && (React.createElement(Modal, __assign({ title: "First Modal" }, props, { cancel: function () {
                var _a;
                setShow1(false);
                (_a = props.cancel) === null || _a === void 0 ? void 0 : _a.call(props);
            }, done: function () {
                var _a;
                setShow2(true);
                (_a = props.done) === null || _a === void 0 ? void 0 : _a.call(props);
            }, action: "Open another modal" }), show2 && (React.createElement(Modal, __assign({ title: "Second Modal" }, props, { cancel: function () {
                var _a;
                setShow2(false);
                (_a = props.cancel) === null || _a === void 0 ? void 0 : _a.call(props);
            }, done: function () {
                var _a;
                setShow2(false);
                (_a = props.done) === null || _a === void 0 ? void 0 : _a.call(props);
            } })))))));
};
export default {
    title: 'Core/Modal',
    component: Modal,
};
var Template = createTemplate(NestedModalDemo);
export var Default = createStory(Template, {
    title: 'Modal title',
    children: (React.createElement(React.Fragment, null,
        React.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
export var CustomAction = createStory(Template, {
    title: 'Modal title',
    children: (React.createElement(React.Fragment, null,
        React.createElement("p", null, "Lorem ipsum dolor sit amet"))),
    action: 'Go!',
});
export var NoCancel = createStory(Template, {
    title: 'Modal title',
    children: (React.createElement(React.Fragment, null,
        React.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
export var WithTitleDetails = createStory(Template, {
    title: (React.createElement(React.Fragment, null,
        "Modal title",
        React.createElement(Txt, { mt: 3, fontSize: "initial" }, "Optional details"))),
    children: (React.createElement(React.Fragment, null,
        React.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
export var WithCustomWidth = createStory(Template, {
    title: (React.createElement(React.Fragment, null,
        "Modal title",
        React.createElement(Txt, { mt: 3, fontSize: "initial" }, "Optional details"))),
    width: ['auto', 500, 1000],
    children: (React.createElement(React.Fragment, null,
        React.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
export var WithMultielementTitle = createStory(Template, {
    title: (React.createElement(React.Fragment, null,
        React.createElement(Heading.h3, null, "Heading"),
        React.createElement(Button, { mt: 3, primary: true }, "A button"))),
    children: (React.createElement(React.Fragment, null,
        React.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
export var WithCustomizedButtons = createStory(Template, {
    title: 'Modal title',
    secondaryButtonProps: {
        children: 'Refresh',
        onClick: function () { return null; },
    },
    cancelButtonProps: {
        children: 'Abort',
        width: 150,
        style: {
            marginRight: 30,
        },
    },
    primaryButtonProps: {
        width: 150,
        danger: true,
        primary: false,
        disabled: true,
    },
    children: (React.createElement(React.Fragment, null,
        React.createElement("p", null, "Lorem ipsum dolor sit amet"))),
});
export var WithOverflowingContent = createStory(Template, {
    title: 'Modal title',
    children: (React.createElement(React.Fragment, null, PokeDex.map(function (x, i) { return (React.createElement("p", { key: i }, x.Description)); }))),
});
export var WithTooltip = createStory(Template, {
    title: 'Modal title',
    children: (React.createElement(React.Fragment, null,
        React.createElement(Heading.h5, { tooltip: { text: 'Good job!', trigger: 'hover' } }, "Hover me and a tooltip will be displayed."))),
});
export var Nested = createStory(Template, {
    title: 'Modal title',
    children: (React.createElement(React.Fragment, null,
        React.createElement(NestedModalDemo, null))),
});
