import * as React from 'react';
import { ResponsiveStyle, Theme } from '../../common-types';
import { ButtonProps } from '../Button';
export interface ModalProps extends Omit<React.HTMLAttributes<HTMLElement>, 'title'> {
    width?: ResponsiveStyle;
    position?: 'center' | 'top';
    title?: string | JSX.Element;
    action?: string | JSX.Element;
    cancel?: () => any;
    done: () => any;
    primaryButtonProps?: ButtonProps;
    secondaryButtonProps?: ButtonProps;
    cancelButtonProps?: ButtonProps;
}
export interface ThemedModalProps extends ModalProps {
    theme: Theme;
}
export declare const Modal: React.FunctionComponent<ModalProps>;
