import * as React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Box, Flex, Button, Txt } from '../..';
import { notifications, NotificationsContainer } from '.';
var textNotification = 'This is a notification';
var getContainerNotification = function (container) { return ({
    container: container,
    content: container,
}); };
var getTypeNotification = function (type) { return ({
    type: type,
    duration: 0,
    content: type,
}); };
var NotificationButton = function (_a) {
    var buttonText = _a.buttonText, notification = _a.notification;
    return (React.createElement(Button, { m: 2, minWidth: 150, onClick: function () { return notifications.addNotification(notification); } }, buttonText || notification.content));
};
var NotificationsStory = function () {
    React.useEffect(function () {
        notifications.addNotification(buttonNotification);
        notifications.addNotification(textNotification);
    }, []);
    return (React.createElement(Flex, { flexDirection: "column", p: 3, alignItems: "flex-start" },
        React.createElement(NotificationsContainer, null),
        React.createElement(NotificationButton, { buttonText: "Add text notification", notification: textNotification }),
        React.createElement(NotificationButton, { buttonText: "Add button notification", notification: buttonNotification })));
};
var NotificationTypeStory = function () {
    var typeNotifications = ['danger', 'success', 'warning', 'info'].map(getTypeNotification);
    React.useEffect(function () {
        typeNotifications.forEach(notifications.addNotification);
    }, []);
    return (React.createElement(Flex, { flexDirection: "column", p: 3, alignItems: "flex-start" },
        React.createElement(NotificationsContainer, null),
        typeNotifications.map(function (typeNotification, index) { return (React.createElement(NotificationButton, { key: index, notification: typeNotification })); })));
};
var NotificationPositionStory = function () {
    var containerNotifications = [
        'top-left',
        'top-center',
        'top-right',
        'center',
        'bottom-left',
        'bottom-center',
        'bottom-right',
    ].map(getContainerNotification);
    React.useEffect(function () {
        containerNotifications.forEach(notifications.addNotification);
    }, []);
    return (React.createElement(React.Fragment, null,
        React.createElement(NotificationsContainer, null),
        React.createElement(Flex, { pt: 6, flexDirection: "column", alignItems: "center", justifyContent: "center" },
            React.createElement(Flex, null,
                React.createElement(NotificationButton, { notification: containerNotifications[0] }),
                React.createElement(NotificationButton, { notification: containerNotifications[1] }),
                React.createElement(NotificationButton, { notification: containerNotifications[2] })),
            React.createElement(NotificationButton, { notification: containerNotifications[3] }),
            React.createElement(Flex, null,
                React.createElement(NotificationButton, { notification: containerNotifications[4] }),
                React.createElement(NotificationButton, { notification: containerNotifications[5] }),
                React.createElement(NotificationButton, { notification: containerNotifications[6] })))));
};
var buttonNotification = {
    onDismiss: function () { return null; },
    content: (React.createElement(Box, null,
        React.createElement(Txt, { mb: 2 }, "Some text for the user to read"),
        React.createElement(Button, null, "This is a button"))),
};
export default {
    title: 'Core/Notifications',
    component: NotificationsContainer,
};
var Template = createTemplate(NotificationsStory);
export var Default = createStory(Template, {});
var TypeTemplate = createTemplate(NotificationTypeStory);
export var Types = createStory(TypeTemplate, {});
var PositionTemplate = createTemplate(NotificationPositionStory);
export var Positioning = createStory(PositionTemplate, {});
