import { __makeTemplateObject } from "tslib";
import * as React from 'react';
import { ReactNotifications, Store } from 'react-notifications-component';
import styled from 'styled-components';
import { animations } from '../../animations';
import { Alert } from '../Alert';
import styles from './defaultStyle';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { faBan } from '@fortawesome/free-solid-svg-icons/faBan';
import { Txt } from '../Txt';
import theme from '../../theme';
var NOTIFICATION_WIDTH = 300;
var DEFAULT_NOTIFICATION_DURATION = 6000;
var DEFAULT_NOTIFICATION_CONTAINER = 'top-right';
var FullWidthContainer = styled(Alert)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\twidth: 100%;\n"], ["\n\twidth: 100%;\n"])));
var enterExitAnimation = {
    duration: 200,
    timingFunction: 'linear',
    delay: 0,
};
var generateNotificationId = function () {
    return Math.random().toString(36).substr(2, 9);
};
var NotificationContainer = function (_a) {
    var content = _a.content, type = _a.type, onDismiss = _a.onDismiss, id = _a.id, prefix = _a.prefix;
    return (React.createElement(FullWidthContainer, { emphasized: Boolean(type), success: type === 'success', danger: type === 'danger', warning: type === 'warning', info: type === 'info', onDismiss: function () {
            if (onDismiss) {
                onDismiss();
            }
            Store.removeNotification(id);
        }, prefix: prefix !== null && prefix !== void 0 ? prefix : (type === 'danger' ? (React.createElement(React.Fragment, null,
            React.createElement(Txt.span, { color: theme.colors.danger.main, mr: 2 },
                React.createElement(FontAwesomeIcon, { icon: faBan })),
            React.createElement(Txt.span, null, "Error!"))) : undefined) }, content));
};
export var NotificationsContainer = styled(ReactNotifications)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t", "\n\t", "\n\n\tposition: fixed;\n\tz-index: 9000;\n\tpointer-events: none;\n\twidth: 100%;\n\theight: 100%;\n\n\t/* This overrides the react-notification library's default container shadow */\n\t.rnc__notification-item {\n\t\tbox-shadow: none;\n\t}\n"], ["\n\t", "\n\t", "\n\n\tposition: fixed;\n\tz-index: 9000;\n\tpointer-events: none;\n\twidth: 100%;\n\theight: 100%;\n\n\t/* This overrides the react-notification library's default container shadow */\n\t.rnc__notification-item {\n\t\tbox-shadow: none;\n\t}\n"])), animations, styles);
var isNotificationOptions = function (options) {
    return typeof options === 'object' && !React.isValidElement(options);
};
export var notifications = {
    addNotification: function (options) {
        var _a, _b, _c;
        var transformedOptions = isNotificationOptions(options)
            ? options
            : { content: options };
        (_a = transformedOptions.id) !== null && _a !== void 0 ? _a : (transformedOptions.id = generateNotificationId());
        (_b = transformedOptions.duration) !== null && _b !== void 0 ? _b : (transformedOptions.duration = DEFAULT_NOTIFICATION_DURATION);
        (_c = transformedOptions.container) !== null && _c !== void 0 ? _c : (transformedOptions.container = DEFAULT_NOTIFICATION_CONTAINER);
        Store.addNotification({
            container: transformedOptions.container,
            animationIn: ['animated', 'fadeIn', 'faster'],
            animationOut: ['animated', 'fadeOut', 'faster'],
            slidingEnter: enterExitAnimation,
            slidingExit: enterExitAnimation,
            touchRevert: enterExitAnimation,
            touchSlidingExit: {
                swipe: enterExitAnimation,
                fade: enterExitAnimation,
            },
            dismiss: {
                duration: transformedOptions.duration,
                pauseOnHover: true,
                waitForAnimation: false,
                click: false,
                touch: false,
            },
            width: NOTIFICATION_WIDTH,
            id: transformedOptions.id,
            content: (React.createElement(NotificationContainer, { type: transformedOptions.type, onDismiss: transformedOptions.onDismiss, id: transformedOptions.id, content: transformedOptions.content, prefix: transformedOptions.prefix })),
        });
    },
    removeNotification: function (id) { return Store.removeNotification(id); },
};
var templateObject_1, templateObject_2;
