import { __assign, __rest } from "tslib";
jest.mock('mermaid', function () { return 'Mermaid'; });
import React from 'react';
import { render } from '@testing-library/react';
import forEach from 'lodash/forEach';
import { Provider } from '../..';
import { Renderer } from '.';
import allExamples, { CONTEXT_FUNCTIONS, EXTRA_FORMATS } from './examples';
describe('Renderer component', function () {
    var _aMermaidField = allExamples["A mermaid field"], _aDateTimeField = allExamples["A date time field"], exampledToTest = __rest(allExamples, ['A mermaid field', 'A date time field']);
    forEach(exampledToTest, function (example, label) {
        it(label, function () {
            var container = render(React.createElement(Provider, { widgets: {
                    renderer: {
                        formats: EXTRA_FORMATS,
                    },
                } },
                React.createElement(Renderer, __assign({ validate: true }, example, { extraContext: __assign(__assign({}, CONTEXT_FUNCTIONS), { root: example.value }) })))).container;
            expect(container).toMatchSnapshot();
        });
    });
});
