import { __assign, __rest } from "tslib";
import * as React from 'react';
import { Button } from '../../Button';
import { UiOption } from './ui-options';
import { widgetFactory } from './widget-util';
import { JsonTypes } from '../types';
var ButtonWidget = widgetFactory('Button', {
    href: UiOption.string,
    target: __assign(__assign({}, UiOption.string), { enum: ['_blank', '_self', '_parent', '_top'] }),
    disabled: UiOption.boolean,
    primary: UiOption.boolean,
    secondary: UiOption.boolean,
    tertiary: UiOption.boolean,
    quarternary: UiOption.boolean,
    danger: UiOption.boolean,
    warning: UiOption.boolean,
    success: UiOption.boolean,
    info: UiOption.boolean,
    light: UiOption.boolean,
    outline: UiOption.boolean,
    plain: UiOption.boolean,
    underline: UiOption.boolean,
}, [JsonTypes.string, JsonTypes.boolean, JsonTypes.integer, JsonTypes.boolean])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    if (value == null) {
        return null;
    }
    return React.createElement(Button, __assign({}, props), value.toString());
});
export default ButtonWidget;
