import { __assign, __rest } from "tslib";
import * as React from 'react';
import get from 'lodash/get';
import { HighlightedName } from '../../HighlightedName';
import { UiOption } from './ui-options';
import { widgetFactory } from './widget-util';
import { JsonTypes } from '../types';
import { generateColorFromString, isLight } from '../../../utils/colorUtils';
var HighlightedNameWidget = widgetFactory('HighlightedName', {
    bg: UiOption.string,
    color: UiOption.string,
}, [JsonTypes.string, JsonTypes.integer, JsonTypes.number, JsonTypes.boolean])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    if (value == null) {
        return null;
    }
    var bg = get(props, 'bg', generateColorFromString(value.toString()));
    var color = get(props, 'color', isLight(bg) ? '#000' : '#FFF');
    return (React.createElement(HighlightedName, __assign({}, props, { bg: bg, color: color }), value.toString()));
});
export default HighlightedNameWidget;
