import { __assign, __rest } from "tslib";
import * as React from 'react';
import { Img } from '../../Img';
import { UiOption } from './ui-options';
import { widgetFactory } from './widget-util';
import { JsonTypes } from '../types';
var ImgWidget = widgetFactory('Img', {
    alt: UiOption.string,
    height: UiOption.space,
    width: UiOption.space,
    crossorigin: __assign(__assign({}, UiOption.string), { enum: ['anonymous', 'use-credentials'] }),
    decoding: __assign(__assign({}, UiOption.string), { enum: ['sync', 'async', 'auto'] }),
    loading: __assign(__assign({}, UiOption.string), { enum: ['eager', 'lazy'] }),
    sizes: UiOption.string,
    srcset: UiOption.string,
}, [JsonTypes.string])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    if (value == null) {
        return null;
    }
    return React.createElement(Img, __assign({}, props, { src: value.toString() }));
});
export default ImgWidget;
