import { __assign, __rest } from "tslib";
import * as React from 'react';
import get from 'lodash/get';
import { widgetFactory, getObjectPropertyNames, } from './widget-util';
import { JsonTypes } from '../types';
import { Renderer } from '../index';
var ObjectWidget = widgetFactory('Object', undefined, [JsonTypes.object])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, rest = __rest(_a, ["value", "schema", "uiSchema"]);
    var propertyNames = getObjectPropertyNames({ value: value, schema: schema, uiSchema: uiSchema });
    return (React.createElement(React.Fragment, null, propertyNames.map(function (key) {
        var _a;
        var subProps = {
            value: (_a = get(value, key)) !== null && _a !== void 0 ? _a : null,
            schema: get(schema, ['properties', key]),
            uiSchema: get(uiSchema, key),
        };
        return (React.createElement(Renderer, __assign({ key: key, nested: true, valueKey: key }, subProps, rest)));
    })));
});
export default ObjectWidget;
