import { __assign, __rest } from "tslib";
import * as React from 'react';
import { ProgressBar } from '../../ProgressBar';
import { UiOption } from './ui-options';
import { widgetFactory } from './widget-util';
import { JsonTypes } from '../types';
var ProgressBarWidget = widgetFactory('ProgressBar', {
    background: UiOption.string,
    primary: UiOption.boolean,
    secondary: UiOption.boolean,
    tertiary: UiOption.boolean,
    quartenary: UiOption.boolean,
    danger: UiOption.boolean,
    warning: UiOption.boolean,
    success: UiOption.boolean,
    info: UiOption.boolean,
    emphasized: UiOption.boolean,
}, [JsonTypes.integer, JsonTypes.number])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, extraContext = _a.extraContext, extraFormats = _a.extraFormats, props = __rest(_a, ["value", "schema", "uiSchema", "extraContext", "extraFormats"]);
    if (value == null) {
        return null;
    }
    if (typeof value !== 'number') {
        throw new Error("ProgressBarWidget cannot be used to render a value of type '".concat(typeof value, "'"));
    }
    return (React.createElement(ProgressBar, __assign({}, props, { value: value }),
        value.toFixed(0),
        "%"));
});
export default ProgressBarWidget;
