import { __assign, __rest } from "tslib";
import * as React from 'react';
import { Tag } from '../../Tag';
import { UiOption } from './ui-options';
import { widgetFactory } from './widget-util';
import { JsonTypes } from '../types';
var TagWidget = widgetFactory('Tag', {
    operator: UiOption.boolean,
    name: UiOption.string,
}, [JsonTypes.string, JsonTypes.integer, JsonTypes.number])(function (_a) {
    var value = _a.value, schema = _a.schema, uiSchema = _a.uiSchema, props = __rest(_a, ["value", "schema", "uiSchema"]);
    if (value == null) {
        return null;
    }
    return React.createElement(Tag, __assign({}, props, { value: value.toString() }));
});
export default TagWidget;
