import { __spreadArray } from "tslib";
import ArrayWidget from './ArrayWidget';
import BadgeWidget from './BadgeWidget';
import ButtonGroupWidget from './ButtonGroupWidget';
import ButtonWidget from './ButtonWidget';
import CheckboxWidget from './CheckboxWidget';
import ColorWidget from './ColorWidget';
import DropDownButtonWidget from './DropDownButtonWidget';
import HeadingWidget from './HeadingWidget';
import HighlightedNameWidget from './HighlightedNameWidget';
import ImgWidget from './ImgWidget';
import LinkWidget from './LinkWidget';
import ListWidget from './ListWidget';
import ObjectWidget from './ObjectWidget';
import ProgressBarWidget from './ProgressBarWidget';
import TagWidget from './TagWidget';
import TxtWidget from './TxtWidget';
import { withOptionProps } from './widget-util';
import { ElapsedTimeWidget } from './ElapsedTimeWidget';
import { DurationWidget } from './DurationWidget';
import { CodeWidget } from './CodeWidget';
import { HashWidget } from './HashWidget';
import { TemperatureWidget } from './TemperatureWidget';
import { PercentageWidget } from './PercentageWidget';
import { DisabledTextWidget } from './DisabledTextWidget';
import { BooleanAsIconWidget } from './BooleanAsIconWidget';
import { PlaceholderTextWidget } from './PlaceholderTextWidget';
import { WrapWidget } from './WrapWidget';
export { WidgetWrapperUiOptions } from './ui-options';
export { getObjectPropertyNames, widgetFactory as WidgetFactory, } from './widget-util';
export { default as WidgetMeta } from './WidgetMeta';
export var defaultFormats = __spreadArray([
    {
        name: 'color',
        format: '.*',
        widget: ColorWidget,
    },
    {
        name: 'uri',
        format: '.*',
        widget: LinkWidget,
    },
    {
        name: 'email',
        format: '.*',
        widget: LinkWidget,
    },
    {
        name: 'elapsed-date-time',
        format: '.*',
        widget: ElapsedTimeWidget,
    },
    {
        name: 'duration',
        format: '.*',
        widget: DurationWidget,
    },
    {
        name: 'code',
        format: '.*',
        widget: CodeWidget,
    },
    {
        name: 'hash',
        format: '.*',
        widget: HashWidget,
    },
    {
        name: 'temperature',
        format: '.*',
        widget: TemperatureWidget,
    },
    {
        name: 'percentage',
        format: '.*',
        widget: PercentageWidget,
    },
    {
        name: 'disabled-text',
        format: '.*',
        widget: DisabledTextWidget,
    },
    {
        name: 'wrap',
        format: '.*',
        widget: WrapWidget,
    },
    {
        name: 'boolean-as-icon',
        format: '.*',
        widget: BooleanAsIconWidget,
    },
    {
        name: 'placeholder-text',
        format: '.*',
        widget: PlaceholderTextWidget,
    }
], [
    ArrayWidget,
    BadgeWidget,
    ButtonGroupWidget,
    ButtonWidget,
    CheckboxWidget,
    ColorWidget,
    DropDownButtonWidget,
    HeadingWidget,
    HighlightedNameWidget,
    ImgWidget,
    LinkWidget,
    ListWidget,
    ObjectWidget,
    ProgressBarWidget,
    TagWidget,
    TxtWidget,
].map(function (widget) { return ({
    name: widget.displayName,
    format: '.*',
    widget: widget.uiOptions
        ? withOptionProps(widget.uiOptions)(widget)
        : widget,
}); }), true);
export var typeWidgets = {
    object: ObjectWidget,
    string: TxtWidget,
    null: TxtWidget,
    integer: TxtWidget,
    number: TxtWidget,
    boolean: TxtWidget,
    array: ArrayWidget,
    default: TxtWidget,
};
