import { __makeTemplateObject } from "tslib";
import { faSearch } from '@fortawesome/free-solid-svg-icons/faSearch';
import { faTimes } from '@fortawesome/free-solid-svg-icons/faTimes';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import * as React from 'react';
import styled from 'styled-components';
import asRendition from '../../asRendition';
import { px } from '../../utils';
import { Flex } from '../Flex';
import { Button } from '../Button';
import { Keyboard } from 'grommet';
var Wrapper = styled(Flex)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: relative;\n\twidth: 100%;\n\tborder-bottom: 1px solid ", ";\n\tpadding-left: 24px;\n\tpadding-top: 4px;\n\n\t.search-icon {\n\t\tcolor: ", ";\n\t\tposition: absolute;\n\t\ttop: 50%;\n\t\tleft: ", ";\n\t\ttransform: translateY(-50%);\n\t}\n\t.clear-icon {\n\t\tcolor: ", ";\n\t\tposition: absolute;\n\t\ttop: 50%;\n\t\tright: ", ";\n\t\ttransform: translateY(-50%);\n\t}\n\tinput {\n\t\toutline: none;\n\t\tbackground: transparent;\n\t\tbox-shadow: none;\n\t\tborder: none;\n\t\twidth: 100%;\n\t\tfont-size: inherit;\n\t\tpadding: 4px;\n\t\theight: auto;\n\t\tfont-family: ", ";\n\n\t\t&:hover {\n\t\t\tbox-shadow: none;\n\t\t}\n\t\t::placeholder {\n\t\t\tcolor: ", ";\n\t\t\tfont-family: ", ";\n\t\t}\n\t}\n"], ["\n\tposition: relative;\n\twidth: 100%;\n\tborder-bottom: 1px solid ", ";\n\tpadding-left: 24px;\n\tpadding-top: 4px;\n\n\t.search-icon {\n\t\tcolor: ", ";\n\t\tposition: absolute;\n\t\ttop: 50%;\n\t\tleft: ", ";\n\t\ttransform: translateY(-50%);\n\t}\n\t.clear-icon {\n\t\tcolor: ", ";\n\t\tposition: absolute;\n\t\ttop: 50%;\n\t\tright: ", ";\n\t\ttransform: translateY(-50%);\n\t}\n\tinput {\n\t\toutline: none;\n\t\tbackground: transparent;\n\t\tbox-shadow: none;\n\t\tborder: none;\n\t\twidth: 100%;\n\t\tfont-size: inherit;\n\t\tpadding: 4px;\n\t\theight: auto;\n\t\tfont-family: ", ";\n\n\t\t&:hover {\n\t\t\tbox-shadow: none;\n\t\t}\n\t\t::placeholder {\n\t\t\tcolor: ", ";\n\t\t\tfont-family: ", ";\n\t\t}\n\t}\n"])), function (props) { return props.theme.colors.quartenary.main; }, function (props) { return props.theme.colors.tertiary.semilight; }, function (props) { return px(props.theme.space[2]); }, function (props) { return props.theme.colors.tertiary.semilight; }, function (props) { return px(props.theme.space[2]); }, function (props) { return props.theme.font; }, function (props) { return props.theme.colors.tertiary.semilight; }, function (props) { return props.theme.font; });
var BaseSearch = React.forwardRef(function (_a, ref) {
    var className = _a.className, dark = _a.dark, disabled = _a.disabled, placeholder = _a.placeholder, value = _a.value, onChange = _a.onChange, onEnter = _a.onEnter;
    return (React.createElement(Wrapper, { className: className },
        React.createElement(Keyboard, { onEnter: onEnter },
            React.createElement("input", { style: { color: dark ? '#fff' : undefined }, disabled: disabled, placeholder: placeholder || 'Search entries...', value: value, onChange: onChange, ref: ref })),
        React.createElement(FontAwesomeIcon, { icon: faSearch, className: "search-icon" }),
        !!value && (React.createElement(Button, { plain: true, className: "clear-icon", onClick: function () {
                if (onChange) {
                    onChange({ target: { value: '' } });
                }
            } },
            React.createElement(FontAwesomeIcon, { icon: faTimes })))));
});
export var Search = asRendition(BaseSearch);
var templateObject_1;
