import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Badge } from '../../';
import { Select } from '.';
export default {
    title: 'Core/Select',
    component: Select,
};
var Template = createTemplate(Select);
export var Default = createStory(Template, {
    options: ['Option 1', 'Option 2', 'Option 3'],
});
export var WithPlaceholder = createStory(Template, {
    options: ['Option 1', 'Option 2', 'Option 3'],
    placeholder: 'Select one...',
});
export var WithCustomOption = createStory(Template, {
    value: 'Option 1',
    options: ['Option 1', 'Option 2', 'Option 3'],
    children: function (option) { return React.createElement(Badge, { m: 1 }, option); },
});
export var Emphasized = createStory(Template, {
    value: 'Option 1',
    options: ['Option 1', 'Option 2', 'Option 3'],
    emphasized: true,
});
export var Invalid = createStory(Template, {
    value: 'Option 1',
    options: ['Option 1', 'Option 2', 'Option 3'],
    invalid: true,
});
export var ObjectOptions = createStory(Template, {
    options: [
        { title: 'Object 1', value: '1' },
        { title: 'Object 2', value: '2' },
        { title: 'Object 3', value: '3' },
    ],
    labelKey: 'title',
    valueKey: 'value',
    value: { title: 'Object 1', value: '1' },
});
