import { mount } from 'enzyme';
import noop from 'lodash/noop';
import sinon from 'sinon';
import React from 'react';
import { Provider, Select } from '../../';
describe('Select component', function () {
    describe('value property', function () {
        it('should set the value of the select element', function () {
            var component = mount(React.createElement(Provider, null,
                React.createElement(Select, { value: 'Option 1', onChange: noop, options: ['Option 1', 'Option 2', 'Option 3'] })));
            expect(component.find('input[value="Option 1"]')).toHaveLength(1);
        });
    });
    describe('onChange property', function () {
        it('should set be called when the select element value is changed', function () {
            var value = 'Option 2';
            var spy = sinon.spy();
            var component = mount(React.createElement(Provider, null,
                React.createElement(Select, { onChange: spy, options: ['Option 1', 'Option 2', 'Option 3'] })));
            component.find('button').at(0).simulate('click');
            component.find('button').at(2).simulate('click');
            expect(spy.callCount).toEqual(1);
            expect(spy.firstCall.args[0].option).toEqual(value);
        });
    });
});
