import { __assign } from "tslib";
import React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Sidebar } from '.';
import { Flex } from '../Flex';
import { Txt } from '../Txt';
var menuItems = [
    {
        title: 'MenuItem 1',
        href: 'menuitem1',
        component: React.createElement(React.Fragment, null, "Menu item 1"),
    },
    {
        title: 'MenuItem 2',
        href: 'menuitem2',
        component: React.createElement(React.Fragment, null, "Menu item 2"),
    },
    {
        title: 'MenuItem 3',
        href: 'menuitem3',
        component: React.createElement(React.Fragment, null, "Menu item 3"),
    },
];
var SidebarDemo = function (props) {
    return (React.createElement(Flex, { width: "90vw", height: "90vh" },
        React.createElement(Sidebar, __assign({}, props, { width: 300, height: "100%" })),
        React.createElement(Flex, null, menuItems.map(function (_item, index) { return (React.createElement("div", null,
            "Page - ",
            index)); }))));
};
export default {
    title: 'Core/Sidebar',
    component: Sidebar,
};
var Template = createTemplate(SidebarDemo);
export var Default = createStory(Template, {
    crumbs: [
        {
            text: 'MenuItem 1',
            href: 'menuitem1',
        },
        {
            text: 'Summary',
        },
    ],
    menuItems: menuItems,
    showBreadcrumbs: true,
});
export var WithAdditionalComponents = createStory(Template, {
    crumbs: [
        {
            text: 'MenuItem 1',
            href: 'menuitem1',
        },
        {
            text: 'Summary',
        },
    ],
    menuItems: menuItems,
    showBreadcrumbs: true,
    additionalComponents: React.createElement(Txt, { color: "white" }, "Another component can go here"),
});
