import * as React from 'react';
import { FlexProps } from '../Flex';
import { Crumb } from '../Breadcrumbs';
import { MenuItem } from './Menu';
import { ChangelogProps } from '../Changelog';
export interface SidebarProps extends FlexProps {
    menuItems: MenuItem[];
    navLink: React.FC<{
        to: string;
    }>;
    crumbs?: Crumb[];
    showBreadcrumbs?: boolean;
    isCollapsed?: boolean;
    additionalComponents?: JSX.Element | null;
    setIsCollapsed?: (isCollapsed: boolean) => void;
    getChangelog?: ChangelogProps['getChangelog'];
    onChangelogClick?: () => void;
    latestChangelogVersion?: string;
}
export declare const Sidebar: ({ menuItems, crumbs, showBreadcrumbs, isCollapsed, additionalComponents, setIsCollapsed, navLink, getChangelog, onChangelogClick, latestChangelogVersion, ...props }: SidebarProps) => React.JSX.Element;
