import React from 'react';
import { faMicrochip } from '@fortawesome/free-solid-svg-icons/faMicrochip';
import { faMemory } from '@fortawesome/free-solid-svg-icons/faMemory';
import { faHdd } from '@fortawesome/free-solid-svg-icons/faHdd';
import { createTemplate, createStory } from '../../stories/utils';
import { StatsBar, StatsTitle, ValueWithMaxTitle } from '.';
export default {
    title: 'Core/StatsBar',
    component: StatsBar,
};
var Template = createTemplate(StatsBar);
export var CpuUsage = createStory(Template, {
    title: React.createElement(StatsTitle, { icon: faMicrochip, title: "CPU" }),
    labelFormatter: function (_a) {
        var value = _a.value;
        return "~".concat(value, "%");
    },
    value: 23,
    max: 100,
    numSlices: 5,
});
export var CpuTemp = createStory(Template, {
    title: React.createElement(StatsTitle, { icon: faMicrochip, title: "Temperature" }),
    labelFormatter: function (_a) {
        var value = _a.value;
        return "~".concat(value, "C");
    },
    value: 34,
    max: 100,
});
export var Memory = createStory(Template, {
    title: React.createElement(StatsTitle, { icon: faMemory, title: "Memory" }),
    labelFormatter: function () { return React.createElement(ValueWithMaxTitle, { value: "453 MB", max: "1 GB" }); },
    value: 453,
    max: 1000,
});
export var Storage = createStory(Template, {
    title: (React.createElement(StatsTitle, { icon: faHdd, title: "Storage", description: "Storage block device" })),
    labelFormatter: function () { return React.createElement(ValueWithMaxTitle, { value: "623 MB", max: "1 GB" }); },
    value: 623,
    max: 1000,
});
