import { __assign, __rest } from "tslib";
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import range from 'lodash/range';
import React from 'react';
import { Box } from '../Box';
import { Flex } from '../Flex';
import { ProgressBar } from '../ProgressBar';
import { Txt } from '../Txt';
export var ValueWithMaxTitle = function (_a) {
    var value = _a.value, max = _a.max;
    return (React.createElement(React.Fragment, null,
        React.createElement(Txt.span, null, value),
        "/",
        React.createElement(Txt.span, { color: "tertiary.main" }, max)));
};
var getDiscreteBarValue = function (value, numSlices, index) {
    var highlightedNumSlices = Math.ceil(value / (100 / numSlices));
    if (numSlices <= 1) {
        return value;
    }
    return highlightedNumSlices > index ? 100 : 0;
};
var DiscreteBar = function (_a) {
    var value = _a.value, numSlices = _a.numSlices, props = __rest(_a, ["value", "numSlices"]);
    return (React.createElement(Flex, { flexDirection: "row" }, range(numSlices).map(function (idx, i) { return (React.createElement(Box, { key: i, flex: 1, mr: idx === numSlices - 1 ? 0 : 2 },
        React.createElement(ProgressBar, __assign({ value: getDiscreteBarValue(value, numSlices, idx) }, props)))); })));
};
export var StatsTitle = function (_a) {
    var icon = _a.icon, title = _a.title, description = _a.description;
    return (React.createElement(Flex, { flexDirection: "column", alignItems: "flex-start", justifyContent: "flex-start" },
        React.createElement(Box, null,
            React.createElement(Txt.span, { mr: 1, color: "tertiary.semilight" },
                React.createElement(FontAwesomeIcon, { icon: icon })),
            React.createElement(Txt.span, null, title)),
        React.createElement(Txt.span, { color: "tertiary.main", style: { lineHeight: 1 }, fontSize: 0 }, description || '\u200b')));
};
export var StatsBar = function (_a) {
    var title = _a.title, labelFormatter = _a.labelFormatter, value = _a.value, max = _a.max, numSlices = _a.numSlices, props = __rest(_a, ["title", "labelFormatter", "value", "max", "numSlices"]);
    var percentage = (value / (max !== null && max !== void 0 ? max : 100)) * 100;
    var bg = __assign(__assign(__assign({}, (percentage <= 60 ? { success: true } : {})), (percentage > 60 && percentage <= 80 ? { warning: true } : {})), (percentage > 80 ? { danger: true } : {}));
    return (React.createElement(Flex, __assign({ flex: 1, minWidth: 152, flexDirection: "column" }, props),
        React.createElement(Flex, { mb: 2, flexDirection: "row", alignItems: "flex-start", justifyContent: "space-between" },
            React.createElement(Txt.span, null, title),
            React.createElement(Txt.span, null, labelFormatter ? labelFormatter({ value: value, max: max }) : value)),
        React.createElement(DiscreteBar, __assign({ numSlices: numSlices !== null && numSlices !== void 0 ? numSlices : 1, value: percentage }, bg))));
};
