import React from 'react';
import { faMapSigns } from '@fortawesome/free-solid-svg-icons/faMapSigns';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import { createTemplate, createStory } from '../../stories/utils';
import { Step, Steps } from '.';
export default {
    title: 'Core/Steps',
    component: Steps,
    subcomponents: { Step: Step },
};
var Template = createTemplate(Steps);
export var Default = createStory(Template, {
    children: [
        React.createElement(Step, { status: "completed" }, "These are"),
        React.createElement(Step, { status: "completed" }, "all completed"),
        React.createElement(Step, { status: "completed" }, "and not clickable"),
    ],
});
export var WithCustomTitle = createStory(Template, {
    titleIcon: React.createElement(FontAwesomeIcon, { icon: faMapSigns }),
    titleText: 'Beginners Guide',
    children: [
        React.createElement(Step, { status: "completed" }, "These are"),
        React.createElement(Step, { status: "completed" }, "all completed"),
        React.createElement(Step, { status: "completed" }, "and not clickable"),
    ],
});
export var WithoutBorders = createStory(Template, {
    bordered: false,
    children: [
        React.createElement(Step, { status: "completed", onClick: function () { return null; } }, "Doesn't have"),
        React.createElement(Step, { status: "pending", onClick: function () { return null; } }, "Title or dismiss button"),
        React.createElement(Step, { status: "none", onClick: function () { return null; } }, "That's it (no icon)"),
    ],
});
export var Ordered = createStory(Template, {
    ordered: true,
    activeStepIndex: 1,
    children: [
        React.createElement(Step, { status: "completed" }, "These are"),
        React.createElement(Step, { status: "pending" }, "all completed"),
        React.createElement(Step, { status: "pending" }, "and not clickable"),
    ],
});
