import { __makeTemplateObject, __spreadArray } from "tslib";
import { faCog } from '@fortawesome/free-solid-svg-icons/faCog';
import { faCheck } from '@fortawesome/free-solid-svg-icons/faCheck';
import { faPlus } from '@fortawesome/free-solid-svg-icons/faPlus';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import * as React from 'react';
import styled from 'styled-components';
import clone from 'lodash/clone';
import reduce from 'lodash/reduce';
import without from 'lodash/without';
import { DropDownButton } from '../DropDownButton';
import { Flex } from '../Flex';
import { stopEvent } from '../../utils';
import theme from '../../theme';
import { Txt } from '../Txt';
var SmallFontAwesomeIcon = styled(FontAwesomeIcon)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t& {\n\t\tfont-size: inherit !important;\n\t}\n"], ["\n\t& {\n\t\tfont-size: inherit !important;\n\t}\n"])));
var ItemIcon = styled.span(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tdisplay: flex;\n\theight: 14px;\n\twidth: 14px;\n\tmargin-right: ", "px;\n\tfont-size: 13px;\n\n\t& svg {\n\t\ttransform: translateY(-1px);\n\t}\n"], ["\n\tdisplay: flex;\n\theight: 14px;\n\twidth: 14px;\n\tmargin-right: ", "px;\n\tfont-size: 13px;\n\n\t& svg {\n\t\ttransform: translateY(-1px);\n\t}\n"])), function (props) { return props.theme.space[2]; });
export var TableColumnStateStoredProps = ['key', 'selected', 'type', 'tagKey'];
export var getNewTagTableColumnState = function (tagKey) {
    if (tagKey) {
        return {
            title: tagKey,
            key: "tag_key: ".concat(tagKey),
            selected: true,
            type: 'tag',
            tagKey: tagKey,
        };
    }
    return {
        title: '',
        key: 'tag_key: Not Set',
        selected: true,
        type: 'tag',
        tagKey: undefined,
    };
};
export var TableColumnSelector = function (props) {
    var columns = props.columns, tagKeys = props.tagKeys, addTagColumn = props.addTagColumn, setColumns = props.setColumns;
    var toggleSelectedColumn = function (column) {
        var columnIndex = columns.indexOf(column);
        if (columnIndex < 0) {
            return;
        }
        var columnsCopy = columns.slice();
        column = clone(column);
        column.selected = !column.selected;
        var shouldRemoveColumn = column.type === 'tag' && !column.selected;
        if (shouldRemoveColumn) {
            columnsCopy.splice(columnIndex, 1);
        }
        else {
            columnsCopy.splice(columnIndex, 1, column);
        }
        setColumns(columnsCopy);
    };
    var existingTagColumnKeys = reduce(columns, function (acc, c) {
        if (c.type === 'tag' && c.tagKey) {
            acc.push(c.tagKey);
        }
        return acc;
    }, []);
    var canAddColumnRules = [
        {
            test: function () { return !(tagKeys || []).length; },
            message: 'No tags available.',
        },
        {
            test: function () { return existingTagColumnKeys.includes(undefined); },
            message: 'Unconfigured tag column already exists',
        },
        {
            test: function () { return !without.apply(void 0, __spreadArray([tagKeys || []], existingTagColumnKeys, false)).length; },
            message: 'All tags used',
        },
    ];
    var failedAddColumnRule = canAddColumnRules.find(function (rule) { return rule.test(); });
    var canAddTagColumn = !failedAddColumnRule;
    var addTagColumnTitle = failedAddColumnRule && failedAddColumnRule.message;
    var memoizedItems = React.useMemo(function () {
        var items = [
            columns
                .filter(function (col) { return !col.locked; })
                .map(function (col) { return ({
                content: (React.createElement(Flex, { key: col.key, alignItems: "center", color: !col.selected ? theme.colors.text.light : undefined },
                    React.createElement(ItemIcon, null, col.selected ? React.createElement(FontAwesomeIcon, { icon: faCheck }) : null),
                    col.type !== 'tag' ? (col.title) : (React.createElement(Txt, null,
                        "Tag : ",
                        col.title ? React.createElement("strong", null, col.title) : 'Not set')))),
                onClick: function (e) {
                    toggleSelectedColumn(col);
                    stopEvent(e);
                },
            }); }),
        ];
        if (tagKeys) {
            items.push([
                {
                    content: (React.createElement(Flex, { alignItems: "center" },
                        React.createElement(ItemIcon, null,
                            React.createElement(FontAwesomeIcon, { icon: faPlus })), addTagColumnTitle !== null && addTagColumnTitle !== void 0 ? addTagColumnTitle : 'Add Tag Column')),
                    onClick: function () { return canAddTagColumn && addTagColumn(); },
                    disabled: !canAddTagColumn,
                },
            ]);
        }
        return items;
    }, [columns, tagKeys, addTagColumn]);
    return (React.createElement(DropDownButton, { joined: true, alignRight: true, primary: true, plain: true, label: React.createElement(SmallFontAwesomeIcon, { icon: faCog }), items: memoizedItems, keepOpenOnItemClick: true }));
};
var templateObject_1, templateObject_2;
