import { __assign, __makeTemplateObject, __rest } from "tslib";
import { faCopy } from '@fortawesome/free-solid-svg-icons/faCopy';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import copyToClipboard from 'copy-to-clipboard';
import * as React from 'react';
import styled from 'styled-components';
import { useTranslation } from '../../hooks/useTranslation';
import { stopEvent } from '../../utils';
import { Txt } from '../Txt';
var Label = styled(Txt.span)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tdisplay: inline-flex;\n\talign-items: stretch;\n\tjustify-content: stretch;\n\tmax-width: 100%;\n\theight: 30px;\n\tpadding: 7px;\n\tborder: 0.5px solid ", ";\n\tfont-size: 11px;\n\tfont-weight: bold;\n\tborder-radius: 3px;\n\tcolor: ", ";\n\tbackground-color: ", ";\n\tposition: relative;\n"], ["\n\tdisplay: inline-flex;\n\talign-items: stretch;\n\tjustify-content: stretch;\n\tmax-width: 100%;\n\theight: 30px;\n\tpadding: 7px;\n\tborder: 0.5px solid ", ";\n\tfont-size: 11px;\n\tfont-weight: bold;\n\tborder-radius: 3px;\n\tcolor: ", ";\n\tbackground-color: ", ";\n\tposition: relative;\n"])), function (props) { return props.theme.colors.info.main; }, function (props) { return props.theme.colors.info.main; }, function (props) { return props.theme.colors.info.light; });
var TagText = styled(Txt.span)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tdisplay: inline-block;\n\tmax-width: 100%;\n\toverflow: hidden;\n\ttext-overflow: ellipsis;\n\twhite-space: nowrap;\n\n\t", ":hover & {\n\t\topacity: 0.5;\n\t}\n"], ["\n\tdisplay: inline-block;\n\tmax-width: 100%;\n\toverflow: hidden;\n\ttext-overflow: ellipsis;\n\twhite-space: nowrap;\n\n\t", ":hover & {\n\t\topacity: 0.5;\n\t}\n"])), Label);
var TagValue = styled.span(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tfont-weight: normal;\n"], ["\n\tfont-weight: normal;\n"])));
var CopyButton = styled.span(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\tposition: absolute;\n\ttop: 0;\n\tright: 0;\n\tbottom: 0;\n\tleft: 0;\n\tdisplay: flex;\n\talign-items: center;\n\tjustify-content: center;\n\tcolor: ", ";\n\tuser-select: none;\n\tcursor: pointer;\n\tvisibility: hidden;\n\n\t", ":hover & {\n\t\tvisibility: visible;\n\t}\n"], ["\n\tposition: absolute;\n\ttop: 0;\n\tright: 0;\n\tbottom: 0;\n\tleft: 0;\n\tdisplay: flex;\n\talign-items: center;\n\tjustify-content: center;\n\tcolor: ", ";\n\tuser-select: none;\n\tcursor: pointer;\n\tvisibility: hidden;\n\n\t", ":hover & {\n\t\tvisibility: visible;\n\t}\n"])), function (props) { return props.theme.colors.text.main; }, Label);
var FaCopyBase = function (props) { return React.createElement(FontAwesomeIcon, __assign({ icon: faCopy }, props)); };
var FaCopy = styled(FaCopyBase)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\tbackground-color: ", ";\n\tbox-shadow: 0 0 1px 3px ", ";\n"], ["\n\tbackground-color: ", ";\n\tbox-shadow: 0 0 1px 3px ", ";\n"])), function (props) { return props.theme.colors.info.light; }, function (props) { return props.theme.colors.info.light; });
var getTagCompositeText = function (tag) {
    var text = tag.tag_key;
    if (tag.value) {
        text = "".concat(text, " : ").concat(tag.value);
    }
    return text;
};
export var TagLabel = function (props) {
    var t = useTranslation().t;
    var tag = props.tag, maxValueLength = props.maxValueLength, wrapValue = props.wrapValue, _a = props.showTagKey, showTagKey = _a === void 0 ? true : _a, _b = props.placeholder, placeholder = _b === void 0 ? t('no_data.no_value') : _b, restProps = __rest(props, ["tag", "maxValueLength", "wrapValue", "showTagKey", "placeholder"]);
    if (!tag) {
        return null;
    }
    var compositeTagString = getTagCompositeText(tag);
    var tagCopyValue = showTagKey
        ? compositeTagString
        : tag.value || placeholder;
    return (React.createElement(Label, __assign({ onClick: stopEvent, title: compositeTagString }, restProps),
        React.createElement(TagText, { tooltip: {
                text: t('actions_messages.copied'),
                trigger: 'click',
            } },
            showTagKey && tag.tag_key,
            showTagKey && tag.value && ': ',
            tag.value && (React.createElement(TagValue, { style: { whiteSpace: wrapValue ? 'normal' : 'nowrap' } }, maxValueLength && tag.value.length > maxValueLength
                ? "".concat(tag.value.substring(0, maxValueLength), "...")
                : tag.value)),
            !showTagKey && !tag.value && (React.createElement(TagValue, null,
                React.createElement("i", null, placeholder))),
            React.createElement(CopyButton, { onClick: function () { return copyToClipboard(tagCopyValue); } },
                React.createElement(FaCopy, null)))));
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
