import { __assign } from "tslib";
import React from 'react';
import { useTranslation } from '../../hooks/useTranslation';
import { TagManagementModal } from '.';
import { createTemplate, createStory } from '../../stories/utils';
import { Button } from '../Button';
var items = [
    {
        id: 1,
        name: 'item-with-tag-1',
        tag_field: [
            {
                tag_key: 'tag1-key',
                value: 'tag-value',
            },
            {
                tag_key: 'tag2-key',
                value: 'tag3-value',
            },
            {
                tag_key: 'tag3-key',
                value: 'tag3-value',
            },
        ],
    },
    {
        id: 2,
        name: 'item-with-tag-2',
        tag_field: [
            {
                tag_key: 'tag1-key',
                value: 'tag-value',
            },
            {
                tag_key: 'tag2-key',
                value: 'tag3-value',
            },
        ],
    },
];
var TagManagement = function (props) {
    var _a = React.useState(false), isModalOpen = _a[0], setIsModalOpen = _a[1];
    var t = useTranslation().t;
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { onClick: function () { return setIsModalOpen(true); }, primary: true }, t('labels.tags')),
        isModalOpen && (React.createElement(TagManagementModal, __assign({}, props, { cancel: function () { return setIsModalOpen(false); }, done: function () { return setIsModalOpen(false); } })))));
};
export default {
    title: 'Core/TagManagementModal',
    component: TagManagementModal,
};
var Template = createTemplate(TagManagement);
export var Default = createStory(Template, {
    items: items,
    itemType: 'tag',
    titleField: 'name',
    tagField: 'tag_field',
    done: function () { return null; },
    cancel: function () { return null; },
});
