import { ResourceTagBase, ResourceTagInfo, ResourceTagSubmitInfo, SubmitInfo, TaggedResource } from './models';
export declare const TAGS_COLUMN_KEY = "Tags";
export declare const getTagKeyValueComposite: (tagKey: string, value: string) => string;
export declare const getResourceTags: <T extends {}, P extends keyof T>(item: T, tagField: P) => ResourceTagBase[];
export declare const groupResourcesByTags: <T extends TaggedResource, P extends keyof T>(items: T[], tagField: P) => ResourceTagInfo<T>[];
export interface ResourceTagModelService {
    submit(tagSubmitInfo: SubmitInfo<ResourceTagSubmitInfo, ResourceTagSubmitInfo>): Promise<void>;
}
export declare const getResourceTagSubmitInfo: <T extends TaggedResource>(tags: ResourceTagInfo<T>[]) => SubmitInfo<ResourceTagSubmitInfo, ResourceTagSubmitInfo>;
