import { __assign, __makeTemplateObject } from "tslib";
import * as React from 'react';
import styled, { css } from 'styled-components';
import { style } from 'styled-system';
import asRendition, { styledSystemProps } from '../../asRendition';
import { monospace } from '../../utils';
import { Copy } from '../Copy';
import difference from 'lodash/difference';
import pick from 'lodash/pick';
var styledPropsKeys = styledSystemProps.filter(function (s) { return !['bg', 'color', 'background', 'fontSize'].includes(s); });
export var code = function (props) {
    return props.code
        ? css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\t\t\t\tfont-family: ", ";\n\t\t\t\tpadding: 2px 4px;\n\t\t\t\tfont-size: 1em;\n\t\t\t\tcolor: #c7254e;\n\t\t\t\tbackground-color: #f9f2f4;\n\t\t  "], ["\n\t\t\t\tfont-family: ", ";\n\t\t\t\tpadding: 2px 4px;\n\t\t\t\tfont-size: 1em;\n\t\t\t\tcolor: #c7254e;\n\t\t\t\tbackground-color: #f9f2f4;\n\t\t  "])), function (props) { return props.theme.monospace; }) : null;
};
export var underline = function (props) {
    return props.underline
        ? css(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t\t\t\ttext-decoration: underline;\n\t\t  "], ["\n\t\t\t\ttext-decoration: underline;\n\t\t  "]))) : null;
};
export var whitespace = function (props) {
    return props.whitespace
        ? css(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\t\t\t\twhite-space: ", ";\n\t\t  "], ["\n\t\t\t\twhite-space: ", ";\n\t\t  "])), props.whitespace) : null;
};
export var caps = function (props) {
    return props.caps
        ? css(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\t\t\t\ttext-transform: uppercase;\n\t\t\t\tletter-spacing: 0.2em;\n\t\t  "], ["\n\t\t\t\ttext-transform: uppercase;\n\t\t\t\tletter-spacing: 0.2em;\n\t\t  "]))) : null;
};
export var italic = function (props) {
    return props.italic
        ? css(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\t\t\t\tfont-style: italic;\n\t\t  "], ["\n\t\t\t\tfont-style: italic;\n\t\t  "]))) : null;
};
export var bold = function (props) {
    return props.bold
        ? css(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n\t\t\t\tfont-weight: ", ";\n\t\t  "], ["\n\t\t\t\tfont-weight: ", ";\n\t\t  "])), props.theme.weights[props.theme.weights.length - 1]) : null;
};
export var truncate = function (props) {
    return props.truncate && css(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n\t\toverflow: hidden;\n\t\ttext-overflow: ellipsis;\n\t\twhite-space: nowrap;\n\t"], ["\n\t\toverflow: hidden;\n\t\ttext-overflow: ellipsis;\n\t\twhite-space: nowrap;\n\t"])));
};
export var align = style({
    key: 'text-align',
    prop: 'align',
    cssProperty: 'text-align',
});
export var BaseTxt = styled.div(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n"], ["\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n\t", "\n"])), align, monospace, whitespace, code, caps, bold, italic, truncate, underline);
var Factory = function (tag) {
    return asRendition(function (props) {
        if (props.copy == null) {
            return React.createElement(BaseTxt, __assign({ as: tag }, props));
        }
        var styledProps = pick(props, styledPropsKeys);
        var otherPropsKeys = difference(Object.keys(props), styledPropsKeys);
        var otherProps = pick(props, otherPropsKeys);
        return (React.createElement(Copy, __assign({ show: props.showCopyMode || 'hover', content: props.copy, onCopy: props.onCopy }, styledProps),
            React.createElement(BaseTxt, __assign({ as: tag }, otherProps))));
    }, [], styledPropsKeys);
};
var Base = Factory();
Base.displayName = 'Txt';
Base.span = Factory('span');
Base.p = Factory('p');
export var Txt = Base;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8;
