import { __assign, __rest } from "tslib";
import { Tab, Tabs } from 'grommet';
import * as React from 'react';
import { Link } from '../../components/Link';
import { Textarea } from '../../components/Textarea';
import Theme from '../../theme';
import { Mermaid } from '../Mermaid';
export var MermaidWidget = function (_a) {
    var options = _a.options, id = _a.id, onChange = _a.onChange, onBlur = _a.onBlur, onFocus = _a.onFocus, value = _a.value, readonly = _a.readonly, disabled = _a.disabled, autofocus = _a.autofocus, schema = _a.schema, formContext = _a.formContext, inputProps = __rest(_a, ["options", "id", "onChange", "onBlur", "onFocus", "value", "readonly", "disabled", "autofocus", "schema", "formContext"]);
    var handleChange = function (_a) {
        var value = _a.target.value;
        return onChange(value === '' ? options.emptyValue : value);
    };
    var handleBlur = function (event) {
        if (onBlur) {
            onBlur(id, event.target.value);
        }
    };
    var handleFocus = function (event) {
        if (onFocus) {
            onFocus(id, event.target.value);
        }
    };
    return (React.createElement(React.Fragment, null,
        React.createElement(Tabs, { justify: "start" },
            React.createElement(Tab, { title: "Write" },
                React.createElement(Textarea, __assign({ placeholder: "This text supports mermaid charts", readOnly: readonly, disabled: disabled, autoFocus: autofocus, value: value || '' }, inputProps, { onChange: handleChange, onBlur: handleBlur, onFocus: handleFocus, rows: 5 }))),
            React.createElement(Tab, { title: "Preview" },
                React.createElement(Mermaid, { bg: Theme.colors.gray.light, p: 3, style: {
                        borderRadius: Theme.radius,
                        width: '100%',
                        minHeight: 180,
                    }, value: value }))),
        React.createElement(Link, { fontSize: 0, href: 'https://mermaidjs.github.io/', blank: true }, "About mermaid")));
};
MermaidWidget.displayName = 'Mermaid';
