import defaults from 'lodash/defaults';
import cloneDeep from 'lodash/cloneDeep';
import * as React from 'react';
import { createTemplate, createStory } from '../../stories/utils';
import { Card, Table } from '../..';
import { Markdown, defaultSanitizerOptions } from '.';
import source, { customizationSamples, decoratorSample, } from '../../stories/assets/markdownSample';
var generateTableData = function () {
    return customizationSamples.map(function (_a, index) {
        var markdown = _a.markdown, sanitizerOptions = _a.sanitizerOptions;
        var customSanitizerOptions = defaults(cloneDeep(sanitizerOptions || {}), defaultSanitizerOptions);
        return {
            id: index,
            'Specific Sanitizer Options': (React.createElement("pre", null, JSON.stringify(sanitizerOptions, null, 2))),
            Original: (React.createElement(Card, { small: true },
                React.createElement(Markdown, null, markdown))),
            Customized: (React.createElement(Card, { small: true },
                React.createElement(Markdown, { sanitizerOptions: customSanitizerOptions }, markdown))),
        };
    });
};
export default {
    title: 'Extra/Markdown',
    component: Markdown,
};
var Template = createTemplate(Markdown);
export var Default = createStory(Template, {
    children: source,
});
export var Customized = createStory(Template, {});
var cellAttributes = { style: { verticalAlign: 'top' } };
var columns = [
    { field: 'Specific Sanitizer Options', cellAttributes: cellAttributes },
    { field: 'Original', cellAttributes: cellAttributes },
    { field: 'Customized', cellAttributes: cellAttributes },
];
Customized.decorators = [
    function () { return React.createElement(Table, { columns: columns, data: generateTableData() }); },
];
export var WithDecorators = createStory(Template, {
    decorators: [
        {
            match: new RegExp("(\\s|^)((@{1,2}|#|!{1,2})[a-z\\d-_\\/]+(\\.[a-z\\d-_\\/]+)*)(\\s|$)", 'gmi'),
            captureGroupIndex: 2,
            component: 'span',
            properties: {
                style: {
                    color: 'green',
                },
            },
        },
    ],
    children: decoratorSample,
});
