import * as React from 'react';
import { ResolvableReturnType } from '../common-types';
import { Poll } from '../utils/poll';
interface UseRequestOptions {
    polling: boolean;
    pollInterval?: number;
    stopExecution?: boolean;
}
type RequestError = Error | null | undefined;
type ForcePoll = () => void;
type UseRequestResult<TResult> = ([TResult | undefined, true, RequestError, ForcePoll] | [TResult, false, RequestError, ForcePoll]) & ({
    data: TResult | undefined;
    isLoading: true;
    error: RequestError;
    forcePoll: ForcePoll;
} | {
    data: TResult;
    isLoading: false;
    error: RequestError;
    forcePoll: ForcePoll;
});
export declare const useRequest: <TFn extends (poll: Poll | undefined) => Promise<any>, TResult extends ResolvableReturnType<TFn>>(action: TFn, deps: React.DependencyList | Partial<Record<'persist' | 'reset', React.DependencyList>>, options: UseRequestOptions) => UseRequestResult<TResult>;
export {};
