import template from 'lodash/template';
import { OsTypesEnum } from './models';
export var FALLBACK_LOGO_UNKNOWN_DEVICE = 'https://dashboard.balena-cloud.com/img/unknown-device.svg';
export var OS_VARIANT_FULL_DISPLAY_TEXT_MAP = {
    dev: 'Development',
    prod: 'Production',
};
export var getExpanded = function (obj) {
    return (Array.isArray(obj) && obj[0]) || undefined;
};
export var stripVersionBuild = function (version) {
    return version.replace(/(\.dev|\.prod)/, '');
};
export var interpolateMustache = function (data, tpl) { return template(tpl, { interpolate: /{{([\s\S]+?)}}/g })(data); };
export var getOsTypeName = function (osTypeSlug) {
    switch (osTypeSlug) {
        case OsTypesEnum.DEFAULT:
            return 'balenaOS';
        case OsTypesEnum.ESR:
            return 'balenaOS ESR';
        default:
            return 'unknown';
    }
};
export var getOsVariantDisplayText = function (variant) {
    return OS_VARIANT_FULL_DISPLAY_TEXT_MAP[variant] || variant;
};
