import { __assign } from "tslib";
import * as React from 'react';
export function compose() {
    var funcs = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        funcs[_i] = arguments[_i];
    }
    return funcs.reduce(function (a, b) {
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return a(b.apply(void 0, args));
        };
    }, function (arg) { return arg; });
}
export function withProps(fn) {
    var wrapper = function (BaseComponent) {
        var hoc = function (props) {
            if (props === void 0) { props = {}; }
            return (React.createElement(BaseComponent, __assign({}, props, (typeof fn === 'function' ? fn(props) : fn))));
        };
        return hoc;
    };
    return wrapper;
}
